import typing
from . import Colours as Colours
from _typeshed import Incomplete
from typing import Callable, ClassVar, Iterator, Optional, overload

Array: dict
Atomic: dict
AudioBuffer: dict
BorderSize: dict
CachedValue: dict
Line: dict
MathConstants: dict
Parallelogram: dict
Point: dict
Range: dict
Rectangle: dict
RectangleList: dict
dontSendNotification: NotificationType
sendNotification: NotificationType
sendNotificationAsync: NotificationType
sendNotificationSync: NotificationType

class ActionBroadcaster:
    def __init__(self) -> None: ...
    def addActionListener(self, arg0: ActionListener) -> None: ...
    def removeActionListener(self, arg0: ActionListener) -> None: ...
    def removeAllActionListeners(self) -> None: ...
    def sendActionMessage(self, arg0: str) -> None: ...

class ActionListener:
    def __init__(self) -> None: ...
    def actionListenerCallback(self, arg0: str) -> None: ...

class AffineTransform:
    mat00: float
    mat01: float
    mat02: float
    mat10: float
    mat11: float
    mat12: float
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> None: ...
    @overload
    def __init__(self, arg0: AffineTransform) -> None: ...
    def followedBy(self, arg0: AffineTransform) -> AffineTransform: ...
    @overload
    @classmethod
    def fromTargetPoints(cls, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> AffineTransform: ...
    @overload
    @classmethod
    def fromTargetPoints(cls, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: float, arg7: float, arg8: float, arg9: float, arg10: float, arg11: float) -> AffineTransform: ...
    @overload
    @classmethod
    def fromTargetPoints(cls, arg0, arg1, arg2, arg3, arg4, arg5) -> AffineTransform: ...
    @overload
    @classmethod
    def fromTargetPoints(cls, arg0, arg1, arg2, arg3, arg4, arg5) -> AffineTransform: ...
    def getDeterminant(self) -> float: ...
    def getTranslationX(self) -> float: ...
    def getTranslationY(self) -> float: ...
    def inverted(self) -> AffineTransform: ...
    def isIdentity(self) -> bool: ...
    def isOnlyTranslation(self) -> bool: ...
    def isSingularity(self) -> bool: ...
    @overload
    def rotated(self, arg0: float) -> AffineTransform: ...
    @overload
    def rotated(self, arg0: float, arg1: float, arg2: float) -> AffineTransform: ...
    @overload
    @classmethod
    def rotation(cls, arg0: float) -> AffineTransform: ...
    @overload
    @classmethod
    def rotation(cls, arg0: float, arg1: float, arg2: float) -> AffineTransform: ...
    @overload
    @classmethod
    def scale(cls, arg0: float, arg1: float) -> AffineTransform: ...
    @overload
    @classmethod
    def scale(cls, arg0: float) -> AffineTransform: ...
    @overload
    @classmethod
    def scale(cls, arg0: float, arg1: float, arg2: float, arg3: float) -> AffineTransform: ...
    @overload
    def scaled(self, arg0: float, arg1: float) -> AffineTransform: ...
    @overload
    def scaled(self, arg0: float) -> AffineTransform: ...
    @overload
    def scaled(self, arg0: float, arg1: float, arg2: float, arg3: float) -> AffineTransform: ...
    @classmethod
    def shear(cls, arg0: float, arg1: float) -> AffineTransform: ...
    def sheared(self, arg0: float, arg1: float) -> AffineTransform: ...
    @overload
    def transformPoint(self, arg0: int, arg1: int) -> tuple: ...
    @overload
    def transformPoint(self, arg0: float, arg1: float) -> tuple: ...
    @overload
    def transformPoints(self, arg0: int, arg1: int, arg2: int, arg3: int) -> tuple: ...
    @overload
    def transformPoints(self, arg0: float, arg1: float, arg2: float, arg3: float) -> tuple: ...
    @overload
    def transformPoints(self, arg0: int, arg1: int, arg2: int, arg3: int, arg4: int, arg5: int) -> tuple: ...
    @overload
    def transformPoints(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> tuple: ...
    @overload
    def translated(self, arg0: float, arg1: float) -> AffineTransform: ...
    @overload
    def translated(self, arg0) -> AffineTransform: ...
    @overload
    def translated(self, arg0) -> AffineTransform: ...
    @classmethod
    def translation(cls, arg0: float, arg1: float) -> AffineTransform: ...
    @classmethod
    def verticalFlip(cls, arg0: float) -> AffineTransform: ...
    def withAbsoluteTranslation(self, arg0: float, arg1: float) -> AffineTransform: ...
    def __eq__(self, arg0: AffineTransform) -> bool: ...
    def __ne__(self, arg0: AffineTransform) -> bool: ...

class AiffAudioFormat(AudioFormat):
    appleBeats: ClassVar[str] = ...
    appleDenominator: ClassVar[str] = ...
    appleKey: ClassVar[str] = ...
    appleNumerator: ClassVar[str] = ...
    appleOneShot: ClassVar[str] = ...
    appleRootNote: ClassVar[str] = ...
    appleRootSet: ClassVar[str] = ...
    appleTag: ClassVar[str] = ...
    def __init__(self) -> None: ...

class AnimatedAppComponent(Component):
    def __init__(self) -> None: ...
    def getFrameCounter(self) -> int: ...
    def getMillisecondsSinceLastUpdate(self) -> int: ...
    def setFramesPerSecond(self, arg0: int) -> None: ...
    def setSynchroniseToVBlank(self, arg0: bool) -> None: ...
    def update(self) -> None: ...

class ApplicationProperties:
    def __init__(self) -> None: ...
    def closeFiles(self) -> None: ...
    def getCommonSettings(self, arg0: bool) -> PropertiesFile: ...
    def getStorageParameters(self) -> PropertiesFile.Options: ...
    def getUserSettings(self) -> PropertiesFile: ...
    def saveIfNeeded(self) -> bool: ...
    def setStorageParameters(self, arg0: PropertiesFile.Options) -> None: ...

class ArrayBool:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: bool) -> None: ...
    @overload
    def __init__(self, arg0: ArrayBool) -> None: ...
    @overload
    def add(self, arg0: bool) -> None: ...
    @overload
    def add(self, *args) -> None: ...
    @overload
    def addArray(self, arg0: list) -> None: ...
    @overload
    def addArray(self, arg0: ArrayBool) -> None: ...
    def addIfNotAlreadyThere(self, arg0: bool) -> bool: ...
    def addUsingDefaultSort(self, arg0: bool) -> None: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def contains(self, arg0: bool) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def fill(self, arg0: bool) -> None: ...
    def getFirst(self) -> bool: ...
    def getLast(self) -> bool: ...
    def getReference(self, arg0: int) -> bool: ...
    def getUnchecked(self, arg0: int) -> bool: ...
    def indexOf(self, arg0: bool) -> int: ...
    def insert(self, arg0: int, arg1: bool) -> None: ...
    def insertMultiple(self, arg0: int, arg1: bool, arg2: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    @overload
    def remove(self, arg0: bool) -> None: ...
    def removeAllInstancesOf(self, arg0: bool) -> int: ...
    def removeAndReturn(self, arg0: int) -> bool: ...
    def removeFirstMatchingValue(self, arg0: bool) -> int: ...
    def removeLast(self, arg0: int) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def removeValuesIn(self, arg0: ArrayBool) -> None: ...
    def removeValuesNotIn(self, arg0: ArrayBool) -> None: ...
    def resize(self, arg0: int) -> None: ...
    def set(self, arg0: int, arg1: bool) -> None: ...
    def setUnchecked(self, arg0: int, arg1: bool) -> None: ...
    def size(self) -> int: ...
    def sort(self) -> None: ...
    def swap(self, arg0: int, arg1: int) -> None: ...
    def swapWith(self, arg0: ArrayBool) -> None: ...
    def __eq__(self, arg0: ArrayBool) -> bool: ...
    def __getitem__(self, arg0: int) -> bool: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __ne__(self, arg0: ArrayBool) -> bool: ...
    def __setitem__(self, arg0: int, arg1: bool) -> None: ...

class ArrayFile:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: File) -> None: ...
    @overload
    def __init__(self, arg0: ArrayFile) -> None: ...
    @overload
    def add(self, arg0: File) -> None: ...
    @overload
    def add(self, *args) -> None: ...
    @overload
    def addArray(self, arg0: list) -> None: ...
    @overload
    def addArray(self, arg0: ArrayFile) -> None: ...
    def addIfNotAlreadyThere(self, arg0: File) -> bool: ...
    def addUsingDefaultSort(self, arg0: File) -> None: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def contains(self, arg0: File) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def fill(self, arg0: File) -> None: ...
    def getFirst(self) -> File: ...
    def getLast(self) -> File: ...
    def getReference(self, arg0: int) -> File: ...
    def getUnchecked(self, arg0: int) -> File: ...
    def indexOf(self, arg0: File) -> int: ...
    def insert(self, arg0: int, arg1: File) -> None: ...
    def insertMultiple(self, arg0: int, arg1: File, arg2: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    @overload
    def remove(self, arg0: File) -> None: ...
    def removeAllInstancesOf(self, arg0: File) -> int: ...
    def removeAndReturn(self, arg0: int) -> File: ...
    def removeFirstMatchingValue(self, arg0: File) -> int: ...
    def removeLast(self, arg0: int) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def removeValuesIn(self, arg0: ArrayFile) -> None: ...
    def removeValuesNotIn(self, arg0: ArrayFile) -> None: ...
    def resize(self, arg0: int) -> None: ...
    def set(self, arg0: int, arg1: File) -> None: ...
    def setUnchecked(self, arg0: int, arg1: File) -> None: ...
    def size(self) -> int: ...
    def sort(self) -> None: ...
    def swap(self, arg0: int, arg1: int) -> None: ...
    def swapWith(self, arg0: ArrayFile) -> None: ...
    def __eq__(self, arg0: ArrayFile) -> bool: ...
    def __getitem__(self, arg0: int) -> File: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __ne__(self, arg0: ArrayFile) -> bool: ...
    def __setitem__(self, arg0: int, arg1: File) -> None: ...

class ArrayFlexItem:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: FlexItem) -> None: ...
    @overload
    def __init__(self, arg0: ArrayFlexItem) -> None: ...
    @overload
    def add(self, arg0: FlexItem) -> None: ...
    @overload
    def add(self, *args) -> None: ...
    @overload
    def addArray(self, arg0: list) -> None: ...
    @overload
    def addArray(self, arg0: ArrayFlexItem) -> None: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def fill(self, arg0: FlexItem) -> None: ...
    def getFirst(self) -> FlexItem: ...
    def getLast(self) -> FlexItem: ...
    def getReference(self, arg0: int) -> FlexItem: ...
    def getUnchecked(self, arg0: int) -> FlexItem: ...
    def insert(self, arg0: int, arg1: FlexItem) -> None: ...
    def insertMultiple(self, arg0: int, arg1: FlexItem, arg2: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    @overload
    def remove(self, arg0: FlexItem) -> None: ...
    def removeAndReturn(self, arg0: int) -> FlexItem: ...
    def removeLast(self, arg0: int) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def resize(self, arg0: int) -> None: ...
    def set(self, arg0: int, arg1: FlexItem) -> None: ...
    def setUnchecked(self, arg0: int, arg1: FlexItem) -> None: ...
    def size(self) -> int: ...
    def swap(self, arg0: int, arg1: int) -> None: ...
    def swapWith(self, arg0: ArrayFlexItem) -> None: ...
    def __getitem__(self, arg0: int) -> FlexItem: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __setitem__(self, arg0: int, arg1: FlexItem) -> None: ...

class ArrayFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: ArrayFloat) -> None: ...
    @overload
    def add(self, arg0: float) -> None: ...
    @overload
    def add(self, *args) -> None: ...
    @overload
    def addArray(self, arg0: list) -> None: ...
    @overload
    def addArray(self, arg0: ArrayFloat) -> None: ...
    def addIfNotAlreadyThere(self, arg0: float) -> bool: ...
    def addUsingDefaultSort(self, arg0: float) -> None: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def contains(self, arg0: float) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def fill(self, arg0: float) -> None: ...
    def getFirst(self) -> float: ...
    def getLast(self) -> float: ...
    def getReference(self, arg0: int) -> float: ...
    def getUnchecked(self, arg0: int) -> float: ...
    def indexOf(self, arg0: float) -> int: ...
    def insert(self, arg0: int, arg1: float) -> None: ...
    def insertMultiple(self, arg0: int, arg1: float, arg2: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    @overload
    def remove(self, arg0: float) -> None: ...
    def removeAllInstancesOf(self, arg0: float) -> int: ...
    def removeAndReturn(self, arg0: int) -> float: ...
    def removeFirstMatchingValue(self, arg0: float) -> int: ...
    def removeLast(self, arg0: int) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def removeValuesIn(self, arg0: ArrayFloat) -> None: ...
    def removeValuesNotIn(self, arg0: ArrayFloat) -> None: ...
    def resize(self, arg0: int) -> None: ...
    def set(self, arg0: int, arg1: float) -> None: ...
    def setUnchecked(self, arg0: int, arg1: float) -> None: ...
    def size(self) -> int: ...
    def sort(self) -> None: ...
    def swap(self, arg0: int, arg1: int) -> None: ...
    def swapWith(self, arg0: ArrayFloat) -> None: ...
    def __eq__(self, arg0: ArrayFloat) -> bool: ...
    def __getitem__(self, arg0: int) -> float: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __ne__(self, arg0: ArrayFloat) -> bool: ...
    def __setitem__(self, arg0: int, arg1: float) -> None: ...

class ArrayInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: ArrayInt) -> None: ...
    @overload
    def add(self, arg0: int) -> None: ...
    @overload
    def add(self, *args) -> None: ...
    @overload
    def addArray(self, arg0: list) -> None: ...
    @overload
    def addArray(self, arg0: ArrayInt) -> None: ...
    def addIfNotAlreadyThere(self, arg0: int) -> bool: ...
    def addUsingDefaultSort(self, arg0: int) -> None: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def contains(self, arg0: int) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def fill(self, arg0: int) -> None: ...
    def getFirst(self) -> int: ...
    def getLast(self) -> int: ...
    def getReference(self, arg0: int) -> int: ...
    def getUnchecked(self, arg0: int) -> int: ...
    def indexOf(self, arg0: int) -> int: ...
    def insert(self, arg0: int, arg1: int) -> None: ...
    def insertMultiple(self, arg0: int, arg1: int, arg2: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    def removeAllInstancesOf(self, arg0: int) -> int: ...
    def removeAndReturn(self, arg0: int) -> int: ...
    def removeFirstMatchingValue(self, arg0: int) -> int: ...
    def removeLast(self, arg0: int) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def removeValuesIn(self, arg0: ArrayInt) -> None: ...
    def removeValuesNotIn(self, arg0: ArrayInt) -> None: ...
    def resize(self, arg0: int) -> None: ...
    def set(self, arg0: int, arg1: int) -> None: ...
    def setUnchecked(self, arg0: int, arg1: int) -> None: ...
    def size(self) -> int: ...
    def sort(self) -> None: ...
    def swap(self, arg0: int, arg1: int) -> None: ...
    def swapWith(self, arg0: ArrayInt) -> None: ...
    def __eq__(self, arg0: ArrayInt) -> bool: ...
    def __getitem__(self, arg0: int) -> int: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __ne__(self, arg0: ArrayInt) -> bool: ...
    def __setitem__(self, arg0: int, arg1: int) -> None: ...

class ArrayString:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: ArrayString) -> None: ...
    @overload
    def add(self, arg0: str) -> None: ...
    @overload
    def add(self, *args) -> None: ...
    @overload
    def addArray(self, arg0: list) -> None: ...
    @overload
    def addArray(self, arg0: ArrayString) -> None: ...
    def addIfNotAlreadyThere(self, arg0: str) -> bool: ...
    def addUsingDefaultSort(self, arg0: str) -> None: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def contains(self, arg0: str) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def fill(self, arg0: str) -> None: ...
    def getFirst(self) -> str: ...
    def getLast(self) -> str: ...
    def getReference(self, arg0: int) -> str: ...
    def getUnchecked(self, arg0: int) -> str: ...
    def indexOf(self, arg0: str) -> int: ...
    def insert(self, arg0: int, arg1: str) -> None: ...
    def insertMultiple(self, arg0: int, arg1: str, arg2: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    @overload
    def remove(self, arg0: int) -> None: ...
    @overload
    def remove(self, arg0: str) -> None: ...
    def removeAllInstancesOf(self, arg0: str) -> int: ...
    def removeAndReturn(self, arg0: int) -> str: ...
    def removeFirstMatchingValue(self, arg0: str) -> int: ...
    def removeLast(self, arg0: int) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def removeValuesIn(self, arg0: ArrayString) -> None: ...
    def removeValuesNotIn(self, arg0: ArrayString) -> None: ...
    def resize(self, arg0: int) -> None: ...
    def set(self, arg0: int, arg1: str) -> None: ...
    def setUnchecked(self, arg0: int, arg1: str) -> None: ...
    def size(self) -> int: ...
    def sort(self) -> None: ...
    def swap(self, arg0: int, arg1: int) -> None: ...
    def swapWith(self, arg0: ArrayString) -> None: ...
    def __eq__(self, arg0: ArrayString) -> bool: ...
    def __getitem__(self, arg0: int) -> str: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __ne__(self, arg0: ArrayString) -> bool: ...
    def __setitem__(self, arg0: int, arg1: str) -> None: ...

class ArrowButton(Button):
    def __init__(self, arg0: str, arg1: float, arg2: Colour) -> None: ...

class AsyncUpdater:
    def __init__(self) -> None: ...
    def cancelPendingUpdate(self) -> None: ...
    def handleAsyncUpdate(self) -> None: ...
    def handleUpdateNowIfNeeded(self) -> None: ...
    def isUpdatePending(self) -> bool: ...
    def triggerAsyncUpdate(self) -> None: ...

class AtomicBool:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: bool) -> None: ...
    @overload
    def __init__(self, arg0: AtomicBool) -> None: ...
    def compareAndSetBool(self, arg0: bool, arg1: bool) -> bool: ...
    def exchange(self, arg0: bool) -> bool: ...
    def get(self) -> bool: ...
    def memoryBarrier(self) -> None: ...
    def set(self, arg0: bool) -> None: ...

class AtomicFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: AtomicFloat) -> None: ...
    def compareAndSetBool(self, arg0: float, arg1: float) -> bool: ...
    def exchange(self, arg0: float) -> float: ...
    def get(self) -> float: ...
    def memoryBarrier(self) -> None: ...
    def set(self, arg0: float) -> None: ...

class AtomicInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: AtomicInt) -> None: ...
    def compareAndSetBool(self, arg0: int, arg1: int) -> bool: ...
    def exchange(self, arg0: int) -> int: ...
    def get(self) -> int: ...
    def memoryBarrier(self) -> None: ...
    def set(self, arg0: int) -> None: ...
    def __iadd__(self, arg0: int) -> int: ...
    def __isub__(self, arg0: int) -> int: ...

class AttributedString:
    class Attribute:
        colour: Colour
        font: Font
        range: RangeInt
        @overload
        def __init__(self) -> None: ...
        @overload
        def __init__(self, arg0: RangeInt, arg1: Font, arg2: Colour) -> None: ...
        @overload
        def __init__(self, arg0: AttributedString.Attribute) -> None: ...

    class ReadingDirection:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        leftToRight: ClassVar[AttributedString.ReadingDirection] = ...
        natural: ClassVar[AttributedString.ReadingDirection] = ...
        rightToLeft: ClassVar[AttributedString.ReadingDirection] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class WordWrap:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        byChar: ClassVar[AttributedString.WordWrap] = ...
        byWord: ClassVar[AttributedString.WordWrap] = ...
        none: ClassVar[AttributedString.WordWrap] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    byChar: ClassVar[AttributedString.WordWrap] = ...
    byWord: ClassVar[AttributedString.WordWrap] = ...
    leftToRight: ClassVar[AttributedString.ReadingDirection] = ...
    natural: ClassVar[AttributedString.ReadingDirection] = ...
    none: ClassVar[AttributedString.WordWrap] = ...
    rightToLeft: ClassVar[AttributedString.ReadingDirection] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: AttributedString) -> None: ...
    @overload
    def append(self, arg0: str) -> None: ...
    @overload
    def append(self, arg0: str, arg1: Font) -> None: ...
    @overload
    def append(self, arg0: str, arg1: Colour) -> None: ...
    @overload
    def append(self, arg0: str, arg1: Font, arg2: Colour) -> None: ...
    @overload
    def append(self, arg0: AttributedString) -> None: ...
    def clear(self) -> None: ...
    def draw(self, arg0, arg1: RectangleFloat) -> None: ...
    def getAttribute(self, arg0: int) -> AttributedString.Attribute: ...
    def getJustification(self) -> Justification: ...
    def getLineSpacing(self) -> float: ...
    def getNumAttributes(self) -> int: ...
    def getReadingDirection(self) -> AttributedString.ReadingDirection: ...
    def getText(self) -> str: ...
    def getWordWrap(self) -> AttributedString.WordWrap: ...
    @overload
    def setColour(self, arg0: RangeInt, arg1: Colour) -> None: ...
    @overload
    def setColour(self, arg0: Colour) -> None: ...
    @overload
    def setFont(self, arg0: RangeInt, arg1: Font) -> None: ...
    @overload
    def setFont(self, arg0: Font) -> None: ...
    def setLineSpacing(self, arg0: float) -> None: ...
    def setReadingDirection(self, arg0: AttributedString.ReadingDirection) -> None: ...
    def setText(self, arg0: str) -> None: ...
    def setWordWrap(self, arg0: AttributedString.WordWrap) -> None: ...

class AudioAppComponent(Component):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: AudioDeviceManager) -> None: ...
    def getNextAudioBlock(self, arg0: AudioSourceChannelInfo) -> None: ...
    def prepareToPlay(self, arg0: int, arg1: float) -> None: ...
    def releaseResources(self) -> None: ...
    def setAudioChannels(self, numInputChannels: int, numOutputChannels: int, storedSettings: XmlElement = ...) -> None: ...
    def shutdownAudio(self) -> None: ...
    @property
    def deviceManager(self) -> AudioDeviceManager: ...

class AudioBufferDouble:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, numChannels: int, numSamples: int) -> None: ...
    def addFrom(self, destChannel: int, destStartSample: int, source: AudioBufferDouble, sourceChannel: int, sourceStartSample: int, numSamples: int, gainToApplyToSource: float = ...) -> None: ...
    def addSample(self, destChannel: int, destSample: int, valueToAdd: float) -> None: ...
    @overload
    def applyGain(self, channel: int, startSample: int, numSamples: int, gain: float) -> None: ...
    @overload
    def applyGain(self, startSample: int, numSamples: int, gain: float) -> None: ...
    @overload
    def applyGain(self, gain: float) -> None: ...
    @overload
    def applyGainRamp(self, channel: int, startSample: int, numSamples: int, startGain: float, endGain: float) -> None: ...
    @overload
    def applyGainRamp(self, startSample: int, numSamples: int, startGain: float, endGain: float) -> None: ...
    @overload
    def clear(self) -> None: ...
    @overload
    def clear(self, startSample: int, numSamples: int) -> None: ...
    @overload
    def clear(self, channel: int, startSample: int, numSamples: int) -> None: ...
    def copyFrom(self, destChannel: int, destStartSample: int, source: AudioBufferDouble, sourceChannel: int, sourceStartSample: int, numSamples: int) -> None: ...
    def findMinMax(self, *args, **kwargs): ...
    def getArrayOfReadPointers(self) -> list: ...
    def getArrayOfWritePointers(self) -> list: ...
    @overload
    def getMagnitude(self, channel: int, startSample: int, numSamples: int) -> float: ...
    @overload
    def getMagnitude(self, startSample: int, numSamples: int) -> float: ...
    def getNumChannels(self) -> int: ...
    def getNumSamples(self) -> int: ...
    def getRMSLevel(self, channel: int, startSample: int, numSamples: int) -> float: ...
    @overload
    def getReadPointer(self, channelNumber: int) -> ConstDoubleArrayView: ...
    @overload
    def getReadPointer(self, channelNumber: int, sampleIndex: int) -> ConstDoubleArrayView: ...
    def getSample(self, channel: int, sampleIndex: int) -> float: ...
    @overload
    def getWritePointer(self, channelNumber: int) -> DoubleArrayView: ...
    @overload
    def getWritePointer(self, channelNumber: int, sampleIndex: int) -> DoubleArrayView: ...
    def hasBeenCleared(self) -> bool: ...
    def makeCopyOf(self, other: AudioBufferDouble, avoidReallocating: bool = ...) -> None: ...
    @overload
    def reverse(self, channel: int, startSample: int, numSamples: int) -> None: ...
    @overload
    def reverse(self, startSample: int, numSamples: int) -> None: ...
    def setNotClear(self) -> None: ...
    def setSample(self, destChannel: int, destSample: int, newValue: float) -> None: ...
    def setSize(self, newNumChannels: int, newNumSamples: int, keepExistingContent: bool = ..., clearExtraSpace: bool = ..., avoidReallocating: bool = ...) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __eq__(self, arg0: AudioBufferDouble) -> bool: ...
    def __ne__(self, arg0: AudioBufferDouble) -> bool: ...
    def __release_buffer__(self, *args, **kwargs): ...

class AudioBufferFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, numChannels: int, numSamples: int) -> None: ...
    def addFrom(self, destChannel: int, destStartSample: int, source: AudioBufferFloat, sourceChannel: int, sourceStartSample: int, numSamples: int, gainToApplyToSource: float = ...) -> None: ...
    def addSample(self, destChannel: int, destSample: int, valueToAdd: float) -> None: ...
    @overload
    def applyGain(self, channel: int, startSample: int, numSamples: int, gain: float) -> None: ...
    @overload
    def applyGain(self, startSample: int, numSamples: int, gain: float) -> None: ...
    @overload
    def applyGain(self, gain: float) -> None: ...
    @overload
    def applyGainRamp(self, channel: int, startSample: int, numSamples: int, startGain: float, endGain: float) -> None: ...
    @overload
    def applyGainRamp(self, startSample: int, numSamples: int, startGain: float, endGain: float) -> None: ...
    @overload
    def clear(self) -> None: ...
    @overload
    def clear(self, startSample: int, numSamples: int) -> None: ...
    @overload
    def clear(self, channel: int, startSample: int, numSamples: int) -> None: ...
    def copyFrom(self, destChannel: int, destStartSample: int, source: AudioBufferFloat, sourceChannel: int, sourceStartSample: int, numSamples: int) -> None: ...
    def findMinMax(self, channel: int, startSample: int, numSamples: int) -> RangeFloat: ...
    def getArrayOfReadPointers(self) -> list: ...
    def getArrayOfWritePointers(self) -> list: ...
    @overload
    def getMagnitude(self, channel: int, startSample: int, numSamples: int) -> float: ...
    @overload
    def getMagnitude(self, startSample: int, numSamples: int) -> float: ...
    def getNumChannels(self) -> int: ...
    def getNumSamples(self) -> int: ...
    def getRMSLevel(self, channel: int, startSample: int, numSamples: int) -> float: ...
    @overload
    def getReadPointer(self, channelNumber: int) -> ConstFloatArrayView: ...
    @overload
    def getReadPointer(self, channelNumber: int, sampleIndex: int) -> ConstFloatArrayView: ...
    def getSample(self, channel: int, sampleIndex: int) -> float: ...
    @overload
    def getWritePointer(self, channelNumber: int) -> FloatArrayView: ...
    @overload
    def getWritePointer(self, channelNumber: int, sampleIndex: int) -> FloatArrayView: ...
    def hasBeenCleared(self) -> bool: ...
    def makeCopyOf(self, other: AudioBufferFloat, avoidReallocating: bool = ...) -> None: ...
    @overload
    def reverse(self, channel: int, startSample: int, numSamples: int) -> None: ...
    @overload
    def reverse(self, startSample: int, numSamples: int) -> None: ...
    def setNotClear(self) -> None: ...
    def setSample(self, destChannel: int, destSample: int, newValue: float) -> None: ...
    def setSize(self, newNumChannels: int, newNumSamples: int, keepExistingContent: bool = ..., clearExtraSpace: bool = ..., avoidReallocating: bool = ...) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __eq__(self, arg0: AudioBufferFloat) -> bool: ...
    def __ne__(self, arg0: AudioBufferFloat) -> bool: ...
    def __release_buffer__(self, *args, **kwargs): ...

class AudioChannelSet:
    class ChannelType:
        __members__: ClassVar[dict] = ...  # read-only
        LFE: ClassVar[AudioChannelSet.ChannelType] = ...
        LFE2: ClassVar[AudioChannelSet.ChannelType] = ...
        __entries: ClassVar[dict] = ...
        ambisonicACN0: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN1: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN10: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN11: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN12: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN13: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN14: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN15: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN16: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN17: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN18: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN19: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN2: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN20: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN21: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN22: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN23: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN24: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN25: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN26: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN27: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN28: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN29: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN3: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN30: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN31: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN32: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN33: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN34: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN35: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN36: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN37: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN38: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN39: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN4: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN40: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN41: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN42: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN43: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN44: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN45: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN46: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN47: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN48: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN49: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN5: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN50: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN51: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN52: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN53: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN54: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN55: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN56: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN57: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN58: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN59: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN6: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN60: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN61: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN62: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN63: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN7: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN8: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicACN9: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicW: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicX: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicY: ClassVar[AudioChannelSet.ChannelType] = ...
        ambisonicZ: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomFrontCentre: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomFrontLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomFrontRight: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomRearCentre: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomRearLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomRearRight: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomSideLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        bottomSideRight: ClassVar[AudioChannelSet.ChannelType] = ...
        centre: ClassVar[AudioChannelSet.ChannelType] = ...
        centreSurround: ClassVar[AudioChannelSet.ChannelType] = ...
        discreteChannel0: ClassVar[AudioChannelSet.ChannelType] = ...
        left: ClassVar[AudioChannelSet.ChannelType] = ...
        leftCentre: ClassVar[AudioChannelSet.ChannelType] = ...
        leftSurround: ClassVar[AudioChannelSet.ChannelType] = ...
        leftSurroundRear: ClassVar[AudioChannelSet.ChannelType] = ...
        leftSurroundSide: ClassVar[AudioChannelSet.ChannelType] = ...
        proximityLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        proximityRight: ClassVar[AudioChannelSet.ChannelType] = ...
        right: ClassVar[AudioChannelSet.ChannelType] = ...
        rightCentre: ClassVar[AudioChannelSet.ChannelType] = ...
        rightSurround: ClassVar[AudioChannelSet.ChannelType] = ...
        rightSurroundRear: ClassVar[AudioChannelSet.ChannelType] = ...
        rightSurroundSide: ClassVar[AudioChannelSet.ChannelType] = ...
        surround: ClassVar[AudioChannelSet.ChannelType] = ...
        topFrontCentre: ClassVar[AudioChannelSet.ChannelType] = ...
        topFrontLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        topFrontRight: ClassVar[AudioChannelSet.ChannelType] = ...
        topMiddle: ClassVar[AudioChannelSet.ChannelType] = ...
        topRearCentre: ClassVar[AudioChannelSet.ChannelType] = ...
        topRearLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        topRearRight: ClassVar[AudioChannelSet.ChannelType] = ...
        topSideLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        topSideRight: ClassVar[AudioChannelSet.ChannelType] = ...
        unknown: ClassVar[AudioChannelSet.ChannelType] = ...
        wideLeft: ClassVar[AudioChannelSet.ChannelType] = ...
        wideRight: ClassVar[AudioChannelSet.ChannelType] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    LFE: ClassVar[AudioChannelSet.ChannelType] = ...
    LFE2: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN0: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN1: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN10: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN11: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN12: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN13: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN14: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN15: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN16: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN17: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN18: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN19: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN2: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN20: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN21: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN22: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN23: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN24: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN25: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN26: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN27: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN28: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN29: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN3: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN30: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN31: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN32: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN33: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN34: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN35: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN36: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN37: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN38: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN39: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN4: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN40: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN41: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN42: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN43: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN44: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN45: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN46: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN47: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN48: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN49: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN5: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN50: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN51: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN52: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN53: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN54: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN55: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN56: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN57: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN58: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN59: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN6: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN60: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN61: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN62: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN63: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN7: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN8: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicACN9: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicW: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicX: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicY: ClassVar[AudioChannelSet.ChannelType] = ...
    ambisonicZ: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomFrontCentre: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomFrontLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomFrontRight: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomRearCentre: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomRearLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomRearRight: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomSideLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    bottomSideRight: ClassVar[AudioChannelSet.ChannelType] = ...
    centre: ClassVar[AudioChannelSet.ChannelType] = ...
    centreSurround: ClassVar[AudioChannelSet.ChannelType] = ...
    discreteChannel0: ClassVar[AudioChannelSet.ChannelType] = ...
    left: ClassVar[AudioChannelSet.ChannelType] = ...
    leftCentre: ClassVar[AudioChannelSet.ChannelType] = ...
    leftSurround: ClassVar[AudioChannelSet.ChannelType] = ...
    leftSurroundRear: ClassVar[AudioChannelSet.ChannelType] = ...
    leftSurroundSide: ClassVar[AudioChannelSet.ChannelType] = ...
    maxChannelsOfNamedLayout: ClassVar[int] = ...
    proximityLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    proximityRight: ClassVar[AudioChannelSet.ChannelType] = ...
    right: ClassVar[AudioChannelSet.ChannelType] = ...
    rightCentre: ClassVar[AudioChannelSet.ChannelType] = ...
    rightSurround: ClassVar[AudioChannelSet.ChannelType] = ...
    rightSurroundRear: ClassVar[AudioChannelSet.ChannelType] = ...
    rightSurroundSide: ClassVar[AudioChannelSet.ChannelType] = ...
    surround: ClassVar[AudioChannelSet.ChannelType] = ...
    topFrontCentre: ClassVar[AudioChannelSet.ChannelType] = ...
    topFrontLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    topFrontRight: ClassVar[AudioChannelSet.ChannelType] = ...
    topMiddle: ClassVar[AudioChannelSet.ChannelType] = ...
    topRearCentre: ClassVar[AudioChannelSet.ChannelType] = ...
    topRearLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    topRearRight: ClassVar[AudioChannelSet.ChannelType] = ...
    topSideLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    topSideRight: ClassVar[AudioChannelSet.ChannelType] = ...
    unknown: ClassVar[AudioChannelSet.ChannelType] = ...
    wideLeft: ClassVar[AudioChannelSet.ChannelType] = ...
    wideRight: ClassVar[AudioChannelSet.ChannelType] = ...
    def __init__(self) -> None: ...
    def addChannel(self, arg0: AudioChannelSet.ChannelType) -> None: ...
    @classmethod
    def ambisonic(cls, order: int = ...) -> AudioChannelSet: ...
    @classmethod
    def canonicalChannelSet(cls, arg0: int) -> AudioChannelSet: ...
    @classmethod
    def channelSetWithChannels(cls, *args, **kwargs): ...
    @classmethod
    def channelSetsWithNumberOfChannels(cls, *args, **kwargs): ...
    @classmethod
    def create5point0(cls) -> AudioChannelSet: ...
    @classmethod
    def create5point0point2(cls) -> AudioChannelSet: ...
    @classmethod
    def create5point0point4(cls) -> AudioChannelSet: ...
    @classmethod
    def create5point1(cls) -> AudioChannelSet: ...
    @classmethod
    def create5point1point2(cls) -> AudioChannelSet: ...
    @classmethod
    def create5point1point4(cls) -> AudioChannelSet: ...
    @classmethod
    def create6point0(cls) -> AudioChannelSet: ...
    @classmethod
    def create6point0Music(cls) -> AudioChannelSet: ...
    @classmethod
    def create6point1(cls) -> AudioChannelSet: ...
    @classmethod
    def create6point1Music(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point0(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point0SDDS(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point0point2(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point0point4(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point0point6(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point1(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point1SDDS(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point1point2(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point1point4(cls) -> AudioChannelSet: ...
    @classmethod
    def create7point1point6(cls) -> AudioChannelSet: ...
    @classmethod
    def create9point0point4(cls) -> AudioChannelSet: ...
    @classmethod
    def create9point0point6(cls) -> AudioChannelSet: ...
    @classmethod
    def create9point1point4(cls) -> AudioChannelSet: ...
    @classmethod
    def create9point1point6(cls) -> AudioChannelSet: ...
    @classmethod
    def createLCR(cls) -> AudioChannelSet: ...
    @classmethod
    def createLCRS(cls) -> AudioChannelSet: ...
    @classmethod
    def createLRS(cls) -> AudioChannelSet: ...
    @classmethod
    def disabled(cls) -> AudioChannelSet: ...
    @classmethod
    def discreteChannels(cls, arg0: int) -> AudioChannelSet: ...
    @classmethod
    def fromAbbreviatedString(cls, arg0: str) -> AudioChannelSet: ...
    @classmethod
    def fromWaveChannelMask(cls, arg0: int) -> AudioChannelSet: ...
    @classmethod
    def getAbbreviatedChannelTypeName(cls, arg0: AudioChannelSet.ChannelType) -> str: ...
    def getAmbisonicOrder(self) -> int: ...
    @classmethod
    def getAmbisonicOrderForNumChannels(cls, arg0: int, arg1: int) -> int: ...
    def getChannelIndexForType(self, arg0: AudioChannelSet.ChannelType) -> int: ...
    @classmethod
    def getChannelTypeFromAbbreviation(cls, arg0: str) -> AudioChannelSet.ChannelType: ...
    @classmethod
    def getChannelTypeName(cls, arg0: AudioChannelSet.ChannelType) -> str: ...
    def getChannelTypes(self, *args, **kwargs): ...
    def getDescription(self) -> str: ...
    def getSpeakerArrangementAsString(self) -> str: ...
    def getTypeOfChannel(self, arg0: int) -> AudioChannelSet.ChannelType: ...
    def getWaveChannelMask(self) -> int: ...
    @classmethod
    def hexagonal(cls) -> AudioChannelSet: ...
    def intersect(self, arg0: AudioChannelSet) -> None: ...
    def isDisabled(self) -> bool: ...
    def isDiscreteLayout(self) -> bool: ...
    @classmethod
    def mono(cls) -> AudioChannelSet: ...
    @classmethod
    def namedChannelSet(cls, arg0: int) -> AudioChannelSet: ...
    @classmethod
    def octagonal(cls) -> AudioChannelSet: ...
    @classmethod
    def pentagonal(cls) -> AudioChannelSet: ...
    @classmethod
    def quadraphonic(cls) -> AudioChannelSet: ...
    def removeChannel(self, arg0: AudioChannelSet.ChannelType) -> None: ...
    def size(self) -> int: ...
    @classmethod
    def stereo(cls) -> AudioChannelSet: ...
    def __eq__(self, arg0: AudioChannelSet) -> bool: ...
    def __lt__(self, arg0: AudioChannelSet) -> bool: ...
    def __ne__(self, arg0: AudioChannelSet) -> bool: ...

class AudioDeviceManager(ChangeBroadcaster):
    class AudioDeviceSetup:
        bufferSize: int
        inputChannels: BigInteger
        inputDeviceName: str
        outputChannels: BigInteger
        outputDeviceName: str
        sampleRate: float
        useDefaultInputChannels: bool
        useDefaultOutputChannels: bool
        def __init__(self) -> None: ...
        def __eq__(self, arg0: AudioDeviceManager.AudioDeviceSetup) -> bool: ...
        def __ne__(self, arg0: AudioDeviceManager.AudioDeviceSetup) -> bool: ...

    class LevelMeter:
        def __init__(self) -> None: ...
        def getCurrentLevel(self) -> float: ...
    def __init__(self) -> None: ...
    def addAudioCallback(self, arg0: AudioIODeviceCallback) -> None: ...
    def closeAudioDevice(self) -> None: ...
    def createStateXml(self) -> XmlElement: ...
    def getAudioCallbackLock(self) -> CriticalSection: ...
    @overload
    def getAudioDeviceSetup(self) -> AudioDeviceManager.AudioDeviceSetup: ...
    @overload
    def getAudioDeviceSetup(self, arg0: AudioDeviceManager.AudioDeviceSetup) -> None: ...
    def getCpuUsage(self) -> float: ...
    def getCurrentAudioDevice(self) -> AudioIODevice: ...
    def getCurrentAudioDeviceType(self) -> str: ...
    def getCurrentDeviceTypeObject(self) -> AudioIODeviceType: ...
    def getDefaultMidiOutputIdentifier(self) -> str: ...
    def getDeviceAudioWorkgroup(self, *args, **kwargs): ...
    def getInputLevelGetter(self) -> AudioDeviceManager.LevelMeter: ...
    def getMidiCallbackLock(self) -> CriticalSection: ...
    def getOutputLevelGetter(self) -> AudioDeviceManager.LevelMeter: ...
    def getXRunCount(self) -> int: ...
    def initialise(self, numInputChannelsNeeded: int, numOutputChannelsNeeded: int, savedState: XmlElement, selectDefaultDeviceOnFailure: bool, preferredDefaultDeviceName: str = ..., preferredSetupOptions: AudioDeviceManager.AudioDeviceSetup = ...) -> str: ...
    def initialiseWithDefaultDevices(self, arg0: int, arg1: int) -> str: ...
    def isMidiInputDeviceEnabled(self, arg0: str) -> bool: ...
    def playTestSound(self) -> None: ...
    def removeAudioCallback(self, arg0: AudioIODeviceCallback) -> None: ...
    def restartLastAudioDevice(self) -> None: ...
    def setAudioDeviceSetup(self, arg0: AudioDeviceManager.AudioDeviceSetup, arg1: bool) -> str: ...
    def setCurrentAudioDeviceType(self, arg0: str, arg1: bool) -> None: ...
    def setDefaultMidiOutputDevice(self, arg0: str) -> None: ...
    def setMidiInputDeviceEnabled(self, arg0: str, arg1: bool) -> None: ...

class AudioFormat:
    @overload
    def __init__(self, arg0: str, arg1: StringArray) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: str) -> None: ...
    def canDoMono(self) -> bool: ...
    def canDoStereo(self) -> bool: ...
    def canHandleFile(self, arg0: File) -> bool: ...
    @overload
    def createMemoryMappedReader(self, arg0: File) -> MemoryMappedAudioFormatReader: ...
    @overload
    def createMemoryMappedReader(self, arg0: FileInputStream) -> MemoryMappedAudioFormatReader: ...
    def createReaderFor(self, arg0: InputStream, arg1: bool) -> AudioFormatReader: ...
    @overload
    def createWriterFor(self, arg0: OutputStream, arg1: float, arg2: int, arg3: int, arg4, arg5: int) -> AudioFormatWriter: ...
    @overload
    def createWriterFor(self, arg0: OutputStream, arg1: float, arg2: AudioChannelSet, arg3: int, arg4, arg5: int) -> AudioFormatWriter: ...
    def getFileExtensions(self) -> StringArray: ...
    def getFormatName(self) -> str: ...
    def getPossibleBitDepths(self) -> ArrayInt: ...
    def getPossibleSampleRates(self) -> ArrayInt: ...
    def getQualityOptions(self) -> StringArray: ...
    def isChannelLayoutSupported(self, arg0: AudioChannelSet) -> bool: ...
    def isCompressed(self) -> bool: ...

class AudioFormatManager:
    def __init__(self) -> None: ...
    def clearFormats(self) -> None: ...
    def createReaderFor(self, arg0: File) -> AudioFormatReader: ...
    def findFormatForFileExtension(self, arg0: str) -> AudioFormat: ...
    def getDefaultFormat(self) -> AudioFormat: ...
    def getKnownFormat(self, arg0: int) -> AudioFormat: ...
    def getNumKnownFormats(self) -> int: ...
    def getWildcardForAllFormats(self) -> str: ...
    def registerBasicFormats(self) -> None: ...
    def registerFormat(self, arg0: AudioFormat, arg1: bool) -> None: ...
    def __iter__(self) -> Iterator: ...

class AudioFormatReader:
    bitsPerSample: int
    input: InputStream
    lengthInSamples: int
    metadataValues: Incomplete
    numChannels: int
    sampleRate: float
    usesFloatingPointData: bool
    def __init__(self, arg0: InputStream, arg1: str) -> None: ...
    def getChannelLayout(self) -> AudioChannelSet: ...
    def getFormatName(self) -> str: ...
    def read(self, arg0: AudioBufferFloat, arg1: int, arg2: int, arg3: int, arg4: bool, arg5: bool) -> bool: ...
    def readMaxLevels(self, arg0: int, arg1: int, arg2: RangeFloat, arg3: int) -> None: ...
    def searchForLevel(self, arg0: int, arg1: int, arg2: float, arg3: float, arg4: int) -> int: ...

class AudioFormatReaderSource(PositionableAudioSource):
    def __init__(self, sourceReader: AudioFormatReader, deleteReaderWhenThisIsDeleted: bool = ...) -> None: ...
    def getAudioFormatReader(self) -> AudioFormatReader: ...

class AudioFormatWriter:
    @overload
    def __init__(self, destStream: OutputStream, formatName: str, sampleRate: float, numberOfChannels: int, bitsPerSample: int) -> None: ...
    @overload
    def __init__(self, destStream: OutputStream, formatName: str, sampleRate: float, audioChannelLayout: AudioChannelSet, bitsPerSample: int) -> None: ...
    def flush(self) -> bool: ...
    def getBitsPerSample(self) -> int: ...
    def getFormatName(self) -> str: ...
    def getNumChannels(self) -> int: ...
    def getSampleRate(self) -> float: ...
    def isFloatingPoint(self) -> bool: ...
    def writeFromAudioReader(self, reader: AudioFormatReader, startSample: int, numSamplesToRead: int) -> bool: ...
    @overload
    def writeFromAudioSampleBuffer(self, source: AudioBufferFloat, startSample: int, numSamples: int) -> bool: ...
    @overload
    def writeFromAudioSampleBuffer(self, arg0: AudioBufferFloat, arg1: int, arg2: int) -> bool: ...
    def writeFromAudioSource(self, source: AudioSource, numSamplesToRead: int, samplesPerBlock: int = ...) -> bool: ...

class AudioIODevice:
    def __init__(self, arg0: str, arg1: str) -> None: ...
    def close(self) -> None: ...
    def getActiveInputChannels(self) -> BigInteger: ...
    def getActiveOutputChannels(self) -> BigInteger: ...
    def getAvailableBufferSizes(self) -> ArrayInt: ...
    def getAvailableSampleRates(self, *args, **kwargs): ...
    def getCurrentBitDepth(self) -> int: ...
    def getCurrentBufferSizeSamples(self) -> int: ...
    def getCurrentSampleRate(self) -> float: ...
    def getDefaultBufferSize(self) -> int: ...
    def getDefaultInputChannels(self) -> Optional[BigInteger]: ...
    def getDefaultOutputChannels(self) -> Optional[BigInteger]: ...
    def getInputChannelNames(self) -> StringArray: ...
    def getInputLatencyInSamples(self) -> int: ...
    def getLastError(self) -> str: ...
    def getName(self) -> str: ...
    @overload
    def getOutputChannelNames(self) -> StringArray: ...
    @overload
    def getOutputChannelNames(self) -> StringArray: ...
    def getOutputLatencyInSamples(self) -> int: ...
    def getTypeName(self) -> str: ...
    def getXRunCount(self) -> int: ...
    def hasControlPanel(self) -> bool: ...
    def isOpen(self) -> bool: ...
    def isPlaying(self) -> bool: ...
    def open(self, arg0: BigInteger, arg1: BigInteger, arg2: float, arg3: int) -> str: ...
    def showControlPanel(self) -> bool: ...
    def start(self, arg0: AudioIODeviceCallback) -> None: ...
    def stop(self) -> None: ...

class AudioIODeviceCallback:
    def __init__(self) -> None: ...
    def audioDeviceAboutToStart(self, device) -> None: ...
    def audioDeviceError(self, errorMessage: str) -> None: ...
    def audioDeviceStopped(self) -> None: ...

class AudioIODeviceCallbackContext:
    def __init__(self) -> None: ...
    @property
    def hostTimeNs(self) -> int: ...

class AudioIODeviceType:
    def __init__(self, arg0: str) -> None: ...
    def addListener(self, arg0) -> None: ...
    @classmethod
    def createAudioIODeviceType_ALSA(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_ASIO(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_Android(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_Bela(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_CoreAudio(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_DirectSound(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_JACK(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_Oboe(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_OpenSLES(cls) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_WASAPI(cls, arg0: WASAPIDeviceMode) -> AudioIODeviceType: ...
    @classmethod
    def createAudioIODeviceType_iOSAudio(cls) -> AudioIODeviceType: ...
    def createDevice(self, *args, **kwargs): ...
    def getDefaultDeviceIndex(self, arg0: bool) -> int: ...
    def getDeviceNames(self, arg0: bool) -> StringArray: ...
    def getIndexOfDevice(self, arg0, arg1: bool) -> int: ...
    def getTypeName(self) -> str: ...
    def hasSeparateInputsAndOutputs(self) -> bool: ...
    def removeListener(self, arg0) -> None: ...
    def scanForDevices(self) -> None: ...

class AudioPlayHead:
    class CurrentPositionInfo:
        bpm: float
        editOriginTime: float
        frameRate: AudioPlayHead.FrameRate
        isLooping: bool
        isPlaying: bool
        isRecording: bool
        ppqLoopEnd: float
        ppqLoopStart: float
        ppqPosition: float
        ppqPositionOfLastBarStart: float
        timeInSamples: int
        timeInSeconds: float
        timeSigDenominator: int
        timeSigNumerator: int
        def __init__(self) -> None: ...
        def resetToDefault(self) -> None: ...
        def __eq__(self, arg0: AudioPlayHead.CurrentPositionInfo) -> bool: ...
        def __ne__(self, arg0: AudioPlayHead.CurrentPositionInfo) -> bool: ...

    class FrameRate:
        @overload
        def __init__(self) -> None: ...
        @overload
        def __init__(self, arg0: AudioPlayHead.FrameRateType) -> None: ...
        def getBaseRate(self) -> int: ...
        def getEffectiveRate(self) -> float: ...
        def getType(self) -> AudioPlayHead.FrameRateType: ...
        def isDrop(self) -> bool: ...
        def isPullDown(self) -> bool: ...
        def withBaseRate(self, arg0: int) -> AudioPlayHead.FrameRate: ...
        def withDrop(self, arg0: bool) -> AudioPlayHead.FrameRate: ...
        def withPullDown(self, arg0: bool) -> AudioPlayHead.FrameRate: ...
        def __eq__(self, arg0: AudioPlayHead.FrameRate) -> bool: ...
        def __ne__(self, arg0: AudioPlayHead.FrameRate) -> bool: ...

    class FrameRateType:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        fps23976: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps24: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps25: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps2997: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps2997drop: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps30: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps30drop: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps60: ClassVar[AudioPlayHead.FrameRateType] = ...
        fps60drop: ClassVar[AudioPlayHead.FrameRateType] = ...
        fpsUnknown: ClassVar[AudioPlayHead.FrameRateType] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class LoopPoints:
        ppqEnd: float
        ppqStart: float
        def __init__(self) -> None: ...
        def __eq__(self, arg0: AudioPlayHead.LoopPoints) -> bool: ...
        def __ne__(self, arg0: AudioPlayHead.LoopPoints) -> bool: ...

    class PositionInfo:
        def __init__(self) -> None: ...
        def getBarCount(self, *args, **kwargs): ...
        def getBpm(self, *args, **kwargs): ...
        def getEditOriginTime(self, *args, **kwargs): ...
        def getFrameRate(self, *args, **kwargs): ...
        def getHostTimeNs(self, *args, **kwargs): ...
        def getIsLooping(self) -> bool: ...
        def getIsPlaying(self) -> bool: ...
        def getIsRecording(self) -> bool: ...
        def getLoopPoints(self, *args, **kwargs): ...
        def getPpqPosition(self, *args, **kwargs): ...
        def getPpqPositionOfLastBarStart(self, *args, **kwargs): ...
        def getTimeInSamples(self, *args, **kwargs): ...
        def getTimeInSeconds(self, *args, **kwargs): ...
        def getTimeSignature(self, *args, **kwargs): ...
        def setBarCount(self, arg0) -> None: ...
        def setBpm(self, arg0) -> None: ...
        def setEditOriginTime(self, arg0) -> None: ...
        def setFrameRate(self, arg0) -> None: ...
        def setHostTimeNs(self, arg0) -> None: ...
        def setIsLooping(self, arg0: bool) -> None: ...
        def setIsPlaying(self, arg0: bool) -> None: ...
        def setIsRecording(self, arg0: bool) -> None: ...
        def setLoopPoints(self, arg0) -> None: ...
        def setPpqPosition(self, arg0) -> None: ...
        def setPpqPositionOfLastBarStart(self, arg0) -> None: ...
        def setTimeInSamples(self, arg0) -> None: ...
        def setTimeInSeconds(self, arg0) -> None: ...
        def setTimeSignature(self, arg0) -> None: ...
        def __eq__(self, arg0: AudioPlayHead.PositionInfo) -> bool: ...
        def __ne__(self, arg0: AudioPlayHead.PositionInfo) -> bool: ...

    class TimeSignature:
        denominator: int
        numerator: int
        def __init__(self) -> None: ...
        def __eq__(self, arg0: AudioPlayHead.TimeSignature) -> bool: ...
        def __ne__(self, arg0: AudioPlayHead.TimeSignature) -> bool: ...
    fps23976: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps24: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps25: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps2997: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps2997drop: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps30: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps30drop: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps60: ClassVar[AudioPlayHead.FrameRateType] = ...
    fps60drop: ClassVar[AudioPlayHead.FrameRateType] = ...
    fpsUnknown: ClassVar[AudioPlayHead.FrameRateType] = ...
    def __init__(self) -> None: ...
    def canControlTransport(self) -> bool: ...
    def getPosition(self, *args, **kwargs): ...
    def transportPlay(self, arg0: bool) -> None: ...
    def transportRecord(self, arg0: bool) -> None: ...
    def transportRewind(self) -> None: ...

class AudioProcessLoadMeasurer:
    class ScopedTimer:
        @overload
        def __init__(self, arg0: AudioProcessLoadMeasurer) -> None: ...
        @overload
        def __init__(self, arg0: AudioProcessLoadMeasurer, arg1: int) -> None: ...
    def __init__(self) -> None: ...
    def getLoadAsPercentage(self) -> float: ...
    def getLoadAsProportion(self) -> float: ...
    def getXRunCount(self) -> int: ...
    def registerBlockRenderTime(self, arg0: float) -> None: ...
    def registerRenderTime(self, arg0: float, arg1: int) -> None: ...
    @overload
    def reset(self) -> None: ...
    @overload
    def reset(self, arg0: float, arg1: int) -> None: ...

class AudioSampleBuffer:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, numChannels: int, numSamples: int) -> None: ...
    def addFrom(self, destChannel: int, destStartSample: int, source: AudioBufferDouble, sourceChannel: int, sourceStartSample: int, numSamples: int, gainToApplyToSource: float = ...) -> None: ...
    def addSample(self, destChannel: int, destSample: int, valueToAdd: float) -> None: ...
    @overload
    def applyGain(self, channel: int, startSample: int, numSamples: int, gain: float) -> None: ...
    @overload
    def applyGain(self, startSample: int, numSamples: int, gain: float) -> None: ...
    @overload
    def applyGain(self, gain: float) -> None: ...
    @overload
    def applyGainRamp(self, channel: int, startSample: int, numSamples: int, startGain: float, endGain: float) -> None: ...
    @overload
    def applyGainRamp(self, startSample: int, numSamples: int, startGain: float, endGain: float) -> None: ...
    @overload
    def clear(self) -> None: ...
    @overload
    def clear(self, startSample: int, numSamples: int) -> None: ...
    @overload
    def clear(self, channel: int, startSample: int, numSamples: int) -> None: ...
    def copyFrom(self, destChannel: int, destStartSample: int, source: AudioBufferDouble, sourceChannel: int, sourceStartSample: int, numSamples: int) -> None: ...
    def findMinMax(self, *args, **kwargs): ...
    def getArrayOfReadPointers(self) -> list: ...
    def getArrayOfWritePointers(self) -> list: ...
    @overload
    def getMagnitude(self, channel: int, startSample: int, numSamples: int) -> float: ...
    @overload
    def getMagnitude(self, startSample: int, numSamples: int) -> float: ...
    def getNumChannels(self) -> int: ...
    def getNumSamples(self) -> int: ...
    def getRMSLevel(self, channel: int, startSample: int, numSamples: int) -> float: ...
    @overload
    def getReadPointer(self, channelNumber: int) -> ConstDoubleArrayView: ...
    @overload
    def getReadPointer(self, channelNumber: int, sampleIndex: int) -> ConstDoubleArrayView: ...
    def getSample(self, channel: int, sampleIndex: int) -> float: ...
    @overload
    def getWritePointer(self, channelNumber: int) -> DoubleArrayView: ...
    @overload
    def getWritePointer(self, channelNumber: int, sampleIndex: int) -> DoubleArrayView: ...
    def hasBeenCleared(self) -> bool: ...
    def makeCopyOf(self, other: AudioBufferDouble, avoidReallocating: bool = ...) -> None: ...
    @overload
    def reverse(self, channel: int, startSample: int, numSamples: int) -> None: ...
    @overload
    def reverse(self, startSample: int, numSamples: int) -> None: ...
    def setNotClear(self) -> None: ...
    def setSample(self, destChannel: int, destSample: int, newValue: float) -> None: ...
    def setSize(self, newNumChannels: int, newNumSamples: int, keepExistingContent: bool = ..., clearExtraSpace: bool = ..., avoidReallocating: bool = ...) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __eq__(self, arg0: AudioBufferDouble) -> bool: ...
    def __ne__(self, arg0: AudioBufferDouble) -> bool: ...
    def __release_buffer__(self, *args, **kwargs): ...

class AudioSource:
    def __init__(self) -> None: ...
    def getNextAudioBlock(self, arg0: AudioSourceChannelInfo) -> None: ...
    def prepareToPlay(self, arg0: int, arg1: float) -> None: ...
    def releaseResources(self) -> None: ...

class AudioSourceChannelInfo:
    buffer: AudioBufferFloat
    numSamples: int
    startSample: int
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, bufferToUse: AudioBufferFloat, startSampleOffset: int, numSamplesToUse: int) -> None: ...
    @overload
    def __init__(self, bufferToUse: AudioBufferFloat) -> None: ...
    def clearActiveBufferRegion(self) -> None: ...

class AudioSourcePlayer(AudioIODeviceCallback):
    def __init__(self) -> None: ...
    def getCurrentSource(self) -> AudioSource: ...
    def getGain(self) -> float: ...
    def setGain(self, arg0: float) -> None: ...
    @overload
    def setSource(self, arg0: AudioSource) -> None: ...
    @overload
    def setSource(self, arg0: None) -> None: ...

class AudioSubsectionReader(AudioFormatReader):
    def __init__(self, sourceReader: AudioFormatReader, subsectionStartSample: int, subsectionLength: int, deleteSourceWhenDeleted: bool = ...) -> None: ...

class AudioTransportSource(PositionableAudioSource, ChangeBroadcaster):
    def __init__(self) -> None: ...
    def getCurrentPosition(self) -> float: ...
    def getGain(self) -> float: ...
    def getLengthInSeconds(self) -> float: ...
    def hasStreamFinished(self) -> bool: ...
    def isPlaying(self) -> bool: ...
    def setGain(self, arg0: float) -> None: ...
    def setPosition(self, arg0: float) -> None: ...
    @overload
    def setSource(self, newSource: PositionableAudioSource, readAheadBufferSize: int = ..., readAheadThread: TimeSliceThread = ..., sourceSampleRateToCorrectFor: float = ..., maxNumChannels: int = ...) -> None: ...
    @overload
    def setSource(self, newSource: None, readAheadBufferSize: int = ..., readAheadThread: TimeSliceThread = ..., sourceSampleRateToCorrectFor: float = ..., maxNumChannels: int = ...) -> None: ...
    @overload
    def setSource(self, newSource: PositionableAudioSource, readAheadBufferSize: int = ..., readAheadThread: None = ..., sourceSampleRateToCorrectFor: float = ..., maxNumChannels: int = ...) -> None: ...
    @overload
    def setSource(self, newSource: None, readAheadBufferSize: int = ..., readAheadThread: None = ..., sourceSampleRateToCorrectFor: float = ..., maxNumChannels: int = ...) -> None: ...
    def start(self) -> None: ...
    def stop(self) -> None: ...

class Base64:
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def convertFromBase64(cls, arg0, arg1: str) -> bool: ...
    @classmethod
    def convertToBase64(cls, arg0, arg1: buffer) -> bool: ...
    @overload
    @classmethod
    def toBase64(cls, arg0: buffer) -> str: ...
    @overload
    @classmethod
    def toBase64(cls, arg0: str) -> str: ...

class BigInteger:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: BigInteger) -> None: ...
    def clear(self) -> BigInteger: ...
    def clearBit(self, arg0: int) -> BigInteger: ...
    def compare(self, arg0: BigInteger) -> int: ...
    def compareAbsolute(self, arg0: BigInteger) -> int: ...
    def countNumberOfSetBits(self) -> int: ...
    def divideBy(self, arg0: BigInteger, arg1: BigInteger) -> None: ...
    def exponentModulo(self, arg0: BigInteger, arg1: BigInteger) -> None: ...
    def extendedEuclidean(self, arg0: BigInteger, arg1: BigInteger, arg2: BigInteger, arg3: BigInteger) -> None: ...
    def findGreatestCommonDivisor(self, arg0: BigInteger) -> BigInteger: ...
    def findNextClearBit(self, arg0: int) -> int: ...
    def findNextSetBit(self, arg0: int) -> int: ...
    def getBitRange(self, arg0: int, arg1: int) -> BigInteger: ...
    def getBitRangeAsInt(self, arg0: int, arg1: int) -> int: ...
    def getHighestBit(self) -> int: ...
    def insertBit(self, arg0: int, arg1: bool) -> BigInteger: ...
    def inverseModulo(self, arg0: BigInteger) -> None: ...
    def isNegative(self) -> bool: ...
    def isOne(self) -> bool: ...
    def isZero(self) -> bool: ...
    def loadFromMemoryBlock(self, arg0) -> None: ...
    def montgomeryMultiplication(self, arg0: BigInteger, arg1: BigInteger, arg2: BigInteger, arg3: int) -> None: ...
    def negate(self) -> None: ...
    def parseString(self, arg0: str, arg1: int) -> None: ...
    @overload
    def setBit(self, arg0: int) -> BigInteger: ...
    @overload
    def setBit(self, arg0: int, arg1: bool) -> BigInteger: ...
    def setBitRangeAsInt(self, arg0: int, arg1: int, arg2: int) -> BigInteger: ...
    def setNegative(self, arg0: bool) -> None: ...
    def setRange(self, arg0: int, arg1: int, arg2: bool) -> BigInteger: ...
    def shiftBits(self, arg0: int, arg1: int) -> BigInteger: ...
    def swapWith(self, arg0: BigInteger) -> None: ...
    def toInt64(self) -> int: ...
    def toInteger(self) -> int: ...
    def toMemoryBlock(self, *args, **kwargs): ...
    def toString(self, arg0: int, arg1: int) -> str: ...
    def __add__(self, arg0: BigInteger) -> BigInteger: ...
    def __and__(self, arg0: BigInteger) -> BigInteger: ...
    @overload
    def __eq__(self, arg0: BigInteger) -> bool: ...
    @overload
    def __eq__(self, arg0: int) -> bool: ...
    @overload
    def __ge__(self, arg0: BigInteger) -> bool: ...
    @overload
    def __ge__(self, arg0: int) -> bool: ...
    @overload
    def __gt__(self, arg0: BigInteger) -> bool: ...
    @overload
    def __gt__(self, arg0: int) -> bool: ...
    def __iadd__(self, arg0: BigInteger) -> BigInteger: ...
    def __iand__(self, arg0: BigInteger) -> BigInteger: ...
    def __ilshift__(self, arg0: int) -> BigInteger: ...
    def __imod__(self, arg0: BigInteger) -> BigInteger: ...
    def __imul__(self, arg0: BigInteger) -> BigInteger: ...
    def __ior__(self, arg0: BigInteger) -> BigInteger: ...
    def __irshift__(self, arg0: int) -> BigInteger: ...
    def __isub__(self, arg0: BigInteger) -> BigInteger: ...
    def __itruediv__(self, arg0: BigInteger) -> BigInteger: ...
    def __ixor__(self, arg0: BigInteger) -> BigInteger: ...
    @overload
    def __le__(self, arg0: BigInteger) -> bool: ...
    @overload
    def __le__(self, arg0: int) -> bool: ...
    def __lshift__(self, arg0: int) -> BigInteger: ...
    @overload
    def __lt__(self, arg0: BigInteger) -> bool: ...
    @overload
    def __lt__(self, arg0: int) -> bool: ...
    def __mod__(self, arg0: BigInteger) -> BigInteger: ...
    def __mul__(self, arg0: BigInteger) -> BigInteger: ...
    @overload
    def __ne__(self, arg0: BigInteger) -> bool: ...
    @overload
    def __ne__(self, arg0: int) -> bool: ...
    def __neg__(self) -> BigInteger: ...
    def __or__(self, arg0: BigInteger) -> BigInteger: ...
    def __rshift__(self, arg0: int) -> BigInteger: ...
    def __sub__(self, arg0: BigInteger) -> BigInteger: ...
    def __truediv__(self, arg0: BigInteger) -> BigInteger: ...
    def __xor__(self, arg0: BigInteger) -> BigInteger: ...

class BorderSizeFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    def addTo(self, arg0: RectangleFloat) -> None: ...
    @overload
    def addedTo(self, arg0: RectangleFloat) -> RectangleFloat: ...
    @overload
    def addedTo(self, arg0: BorderSizeFloat) -> BorderSizeFloat: ...
    def getBottom(self) -> float: ...
    def getLeft(self) -> float: ...
    def getLeftAndRight(self) -> float: ...
    def getRight(self) -> float: ...
    def getTop(self) -> float: ...
    def getTopAndBottom(self) -> float: ...
    def isEmpty(self) -> bool: ...
    @overload
    def multipliedBy(self, arg0: int) -> BorderSizeFloat: ...
    @overload
    def multipliedBy(self, arg0: float) -> BorderSizeFloat: ...
    def setBottom(self, arg0: float) -> None: ...
    def setLeft(self, arg0: float) -> None: ...
    def setRight(self, arg0: float) -> None: ...
    def setTop(self, arg0: float) -> None: ...
    def subtractFrom(self, arg0: RectangleFloat) -> None: ...
    @overload
    def subtractedFrom(self, arg0: RectangleFloat) -> RectangleFloat: ...
    @overload
    def subtractedFrom(self, arg0: BorderSizeFloat) -> BorderSizeFloat: ...
    def __eq__(self, arg0: BorderSizeFloat) -> bool: ...
    def __ne__(self, arg0: BorderSizeFloat) -> bool: ...

class BorderSizeInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    def addTo(self, arg0: RectangleInt) -> None: ...
    @overload
    def addedTo(self, arg0: RectangleInt) -> RectangleInt: ...
    @overload
    def addedTo(self, arg0: BorderSizeInt) -> BorderSizeInt: ...
    def getBottom(self) -> int: ...
    def getLeft(self) -> int: ...
    def getLeftAndRight(self) -> int: ...
    def getRight(self) -> int: ...
    def getTop(self) -> int: ...
    def getTopAndBottom(self) -> int: ...
    def isEmpty(self) -> bool: ...
    @overload
    def multipliedBy(self, arg0: int) -> BorderSizeInt: ...
    @overload
    def multipliedBy(self, arg0: float) -> BorderSizeInt: ...
    def setBottom(self, arg0: int) -> None: ...
    def setLeft(self, arg0: int) -> None: ...
    def setRight(self, arg0: int) -> None: ...
    def setTop(self, arg0: int) -> None: ...
    def subtractFrom(self, arg0: RectangleInt) -> None: ...
    @overload
    def subtractedFrom(self, arg0: RectangleInt) -> RectangleInt: ...
    @overload
    def subtractedFrom(self, arg0: BorderSizeInt) -> BorderSizeInt: ...
    def __eq__(self, arg0: BorderSizeInt) -> bool: ...
    def __ne__(self, arg0: BorderSizeInt) -> bool: ...

class BufferedInputStream(InputStream):
    def __init__(self, arg0: InputStream, arg1: int) -> None: ...
    def peekByte(self) -> str: ...

class BufferingAudioReader(AudioFormatReader):
    def __init__(self, sourceReader: AudioFormatReader, timeSliceThread: TimeSliceThread, samplesToBuffer: int) -> None: ...
    def setReadTimeout(self, arg0: int) -> None: ...

class BufferingAudioSource(PositionableAudioSource):
    def __init__(self, source: PositionableAudioSource, backgroundThread: TimeSliceThread, deleteSourceWhenDeleted: bool, numberOfSamplesToBuffer: int, numberOfChannels: int = ..., prefillBufferOnPrepareToPlay: bool = ...) -> None: ...
    def waitForNextAudioBlockReady(self, arg0: AudioSourceChannelInfo, arg1: int) -> bool: ...

class Button(Component):
    class ButtonState:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        buttonDown: ClassVar[Button.ButtonState] = ...
        buttonNormal: ClassVar[Button.ButtonState] = ...
        buttonOver: ClassVar[Button.ButtonState] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class ConnectedEdgeFlags:
        __members__: ClassVar[dict] = ...  # read-only
        ConnectedOnBottom: ClassVar[Button.ConnectedEdgeFlags] = ...
        ConnectedOnLeft: ClassVar[Button.ConnectedEdgeFlags] = ...
        ConnectedOnRight: ClassVar[Button.ConnectedEdgeFlags] = ...
        ConnectedOnTop: ClassVar[Button.ConnectedEdgeFlags] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: Button.ConnectedEdgeFlags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: Button.ConnectedEdgeFlags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: Button.ConnectedEdgeFlags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: Button.ConnectedEdgeFlags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: Button.ConnectedEdgeFlags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: Button.ConnectedEdgeFlags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: Button.ConnectedEdgeFlags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: Button.ConnectedEdgeFlags) -> int: ...
        def __xor__(self, arg0: Button.ConnectedEdgeFlags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Listener:
        def __init__(self) -> None: ...
        def buttonClicked(self, arg0: Button) -> None: ...
        def buttonStateChanged(self, arg0: Button) -> None: ...
    ConnectedOnBottom: ClassVar[Button.ConnectedEdgeFlags] = ...
    ConnectedOnLeft: ClassVar[Button.ConnectedEdgeFlags] = ...
    ConnectedOnRight: ClassVar[Button.ConnectedEdgeFlags] = ...
    ConnectedOnTop: ClassVar[Button.ConnectedEdgeFlags] = ...
    buttonDown: ClassVar[Button.ButtonState] = ...
    buttonNormal: ClassVar[Button.ButtonState] = ...
    buttonOver: ClassVar[Button.ButtonState] = ...
    onClick: Callable[[], None]
    onStateChange: Callable[[], None]
    def __init__(self, arg0: str) -> None: ...
    def addListener(self, arg0: Button.Listener) -> None: ...
    def addShortcut(self, arg0: KeyPress) -> None: ...
    def clearShortcuts(self) -> None: ...
    def getButtonText(self) -> str: ...
    def getClickingTogglesState(self) -> bool: ...
    def getCommandID(self) -> int: ...
    def getConnectedEdgeFlags(self) -> int: ...
    def getMillisecondsSinceButtonDown(self) -> int: ...
    def getRadioGroupId(self) -> int: ...
    def getState(self) -> Button.ButtonState: ...
    def getToggleState(self) -> bool: ...
    def getToggleStateValue(self) -> Value: ...
    def getTriggeredOnMouseDown(self) -> bool: ...
    def isConnectedOnBottom(self) -> bool: ...
    def isConnectedOnLeft(self) -> bool: ...
    def isConnectedOnRight(self) -> bool: ...
    def isConnectedOnTop(self) -> bool: ...
    def isDown(self) -> bool: ...
    def isOver(self) -> bool: ...
    def isRegisteredForShortcut(self, arg0: KeyPress) -> bool: ...
    def isToggleable(self) -> bool: ...
    def removeListener(self, arg0: Button.Listener) -> None: ...
    def setButtonText(self, arg0: str) -> None: ...
    def setClickingTogglesState(self, arg0: bool) -> None: ...
    @overload
    def setConnectedEdges(self, arg0: int) -> None: ...
    @overload
    def setConnectedEdges(self, arg0: Button.ConnectedEdgeFlags) -> None: ...
    def setRadioGroupId(self, arg0: int, arg1: NotificationType) -> None: ...
    def setRepeatSpeed(self, arg0: int, arg1: int, arg2: int) -> None: ...
    def setState(self, arg0: Button.ButtonState) -> None: ...
    def setToggleState(self, arg0: bool, arg1: NotificationType) -> None: ...
    def setToggleable(self, arg0: bool) -> None: ...
    def setTriggeredOnMouseDown(self, arg0: bool) -> None: ...
    def triggerClick(self) -> None: ...

class ByteOrder:
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def bigEndian24Bit(cls, arg0: buffer) -> int: ...
    @classmethod
    def bigEndianInt(cls, arg0: buffer) -> int: ...
    @classmethod
    def bigEndianInt64(cls, arg0: buffer) -> int: ...
    @classmethod
    def bigEndianShort(cls, arg0: buffer) -> int: ...
    @classmethod
    def isBigEndian(cls) -> bool: ...
    @classmethod
    def littleEndian24Bit(cls, arg0: buffer) -> int: ...
    @classmethod
    def littleEndianInt(cls, arg0: buffer) -> int: ...
    @classmethod
    def littleEndianInt64(cls, arg0: buffer) -> int: ...
    @classmethod
    def littleEndianShort(cls, arg0: buffer) -> int: ...
    @overload
    @classmethod
    def makeInt(cls, arg0: int, arg1: int) -> int: ...
    @overload
    @classmethod
    def makeInt(cls, arg0: int, arg1: int, arg2: int, arg3: int) -> int: ...
    @overload
    @classmethod
    def makeInt(cls, arg0: int, arg1: int, arg2: int, arg3: int, arg4: int, arg5: int, arg6: int, arg7: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: int) -> int: ...
    @overload
    @classmethod
    def swap(cls, arg0: float) -> float: ...
    @overload
    @classmethod
    def swap(cls, arg0: float) -> float: ...

class CachedValueBool:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: bool) -> None: ...
    def forceUpdateOfCachedValue(self) -> None: ...
    def get(self) -> bool: ...
    def getDefault(self) -> bool: ...
    def getPropertyAsValue(self) -> Value: ...
    def getPropertyID(self) -> Identifier: ...
    def getUndoManager(self) -> UndoManager: ...
    def getValueTree(self) -> ValueTree: ...
    def isUsingDefault(self) -> bool: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: bool) -> None: ...
    @overload
    def resetToDefault(self) -> None: ...
    @overload
    def resetToDefault(self, arg0: UndoManager) -> None: ...
    def setDefault(self, arg0: bool) -> None: ...
    def setValue(self, arg0: bool, arg1: UndoManager) -> None: ...
    def __eq__(self, arg0: CachedValueBool) -> bool: ...
    def __ne__(self, arg0: CachedValueBool) -> bool: ...

class CachedValueFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: float) -> None: ...
    def forceUpdateOfCachedValue(self) -> None: ...
    def get(self) -> float: ...
    def getDefault(self) -> float: ...
    def getPropertyAsValue(self) -> Value: ...
    def getPropertyID(self) -> Identifier: ...
    def getUndoManager(self) -> UndoManager: ...
    def getValueTree(self) -> ValueTree: ...
    def isUsingDefault(self) -> bool: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: float) -> None: ...
    @overload
    def resetToDefault(self) -> None: ...
    @overload
    def resetToDefault(self, arg0: UndoManager) -> None: ...
    def setDefault(self, arg0: float) -> None: ...
    def setValue(self, arg0: float, arg1: UndoManager) -> None: ...
    def __eq__(self, arg0: CachedValueFloat) -> bool: ...
    def __ne__(self, arg0: CachedValueFloat) -> bool: ...

class CachedValueInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: int) -> None: ...
    def forceUpdateOfCachedValue(self) -> None: ...
    def get(self) -> int: ...
    def getDefault(self) -> int: ...
    def getPropertyAsValue(self) -> Value: ...
    def getPropertyID(self) -> Identifier: ...
    def getUndoManager(self) -> UndoManager: ...
    def getValueTree(self) -> ValueTree: ...
    def isUsingDefault(self) -> bool: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: int) -> None: ...
    @overload
    def resetToDefault(self) -> None: ...
    @overload
    def resetToDefault(self, arg0: UndoManager) -> None: ...
    def setDefault(self, arg0: int) -> None: ...
    def setValue(self, arg0: int, arg1: UndoManager) -> None: ...
    def __eq__(self, arg0: CachedValueInt) -> bool: ...
    def __ne__(self, arg0: CachedValueInt) -> bool: ...

class CachedValueString:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: str) -> None: ...
    def forceUpdateOfCachedValue(self) -> None: ...
    def get(self) -> str: ...
    def getDefault(self) -> str: ...
    def getPropertyAsValue(self) -> Value: ...
    def getPropertyID(self) -> Identifier: ...
    def getUndoManager(self) -> UndoManager: ...
    def getValueTree(self) -> ValueTree: ...
    def isUsingDefault(self) -> bool: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: str) -> None: ...
    @overload
    def resetToDefault(self) -> None: ...
    @overload
    def resetToDefault(self, arg0: UndoManager) -> None: ...
    def setDefault(self, arg0: str) -> None: ...
    def setValue(self, arg0: str, arg1: UndoManager) -> None: ...
    def __eq__(self, arg0: CachedValueString) -> bool: ...
    def __ne__(self, arg0: CachedValueString) -> bool: ...

class ChangeBroadcaster:
    def __init__(self) -> None: ...
    def addChangeListener(self, arg0: ChangeListener) -> None: ...
    def dispatchPendingMessages(self) -> None: ...
    def removeAllChangeListeners(self) -> None: ...
    def removeChangeListener(self, arg0: ChangeListener) -> None: ...
    def sendChangeMessage(self) -> None: ...
    def sendSynchronousChangeMessage(self) -> None: ...

class ChangeListener:
    def __init__(self) -> None: ...
    def changeListenerCallback(self, arg0) -> None: ...

class ChannelRemappingAudioSource(AudioSource):
    def __init__(self, source: AudioSource, deleteSourceWhenDeleted: bool = ...) -> None: ...
    def clearAllMappings(self) -> None: ...
    def createXml(self) -> XmlElement: ...
    def getRemappedInputChannel(self, arg0: int) -> int: ...
    def getRemappedOutputChannel(self, arg0: int) -> int: ...
    def restoreFromXml(self, arg0: XmlElement) -> None: ...
    def setInputChannelMapping(self, arg0: int, arg1: int) -> None: ...
    def setNumberOfChannelsToProduce(self, arg0: int) -> None: ...
    def setOutputChannelMapping(self, arg0: int, arg1: int) -> None: ...

class ChildProcess:
    def __init__(self) -> None: ...
    def getExitCode(self) -> int: ...
    def isRunning(self) -> bool: ...
    def kill(self) -> bool: ...
    def readAllProcessOutput(self) -> str: ...
    def readProcessOutput(self, arg0: buffer) -> int: ...
    @overload
    def start(self, arg0: str, arg1: int) -> bool: ...
    @overload
    def start(self, arg0: StringArray, arg1: int) -> bool: ...
    def waitForProcessToFinish(self, arg0: int) -> bool: ...

class Colour:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, argb: int) -> None: ...
    @overload
    def __init__(self, red: int, green: int, blue: int) -> None: ...
    @overload
    def __init__(self, red: int, green: int, blue: int, alpha: int) -> None: ...
    @overload
    def __init__(self, red: int, green: int, blue: int, alpha: float) -> None: ...
    @overload
    def __init__(self, hue: float, saturation: float, brightness: float, alpha: int) -> None: ...
    @overload
    def __init__(self, hue: float, saturation: float, brightness: float, alpha: float) -> None: ...
    @overload
    def __init__(self, arg0: PixelARGB) -> None: ...
    @overload
    def __init__(self, arg0: PixelRGB) -> None: ...
    @overload
    def __init__(self, arg0: PixelAlpha) -> None: ...
    @overload
    def __init__(self, arg0: Colour) -> None: ...
    def brighter(self, arg0: float) -> Colour: ...
    @overload
    def contrasting(self, arg0: float) -> Colour: ...
    @overload
    def contrasting(self, arg0: Colour, arg1: float) -> Colour: ...
    def darker(self, arg0: float) -> Colour: ...
    @classmethod
    def fromFloatRGBA(cls, arg0: float, arg1: float, arg2: float, arg3: float) -> Colour: ...
    @classmethod
    def fromHSL(cls, arg0: float, arg1: float, arg2: float, arg3: float) -> Colour: ...
    @classmethod
    def fromHSV(cls, arg0: float, arg1: float, arg2: float, arg3: float) -> Colour: ...
    @classmethod
    def fromRGB(cls, arg0: int, arg1: int, arg2: int) -> Colour: ...
    @classmethod
    def fromRGBA(cls, arg0: int, arg1: int, arg2: int, arg3: int) -> Colour: ...
    @classmethod
    def fromString(cls, arg0: str) -> Colour: ...
    def getARGB(self) -> int: ...
    def getAlpha(self) -> int: ...
    def getBlue(self) -> int: ...
    def getBrightness(self) -> float: ...
    def getFloatAlpha(self) -> float: ...
    def getFloatBlue(self) -> float: ...
    def getFloatGreen(self) -> float: ...
    def getFloatRed(self) -> float: ...
    def getGreen(self) -> int: ...
    def getHSB(self) -> tuple: ...
    def getHSL(self) -> tuple: ...
    def getHue(self) -> float: ...
    def getLightness(self) -> float: ...
    def getNonPremultipliedPixelARGB(self) -> PixelARGB: ...
    def getPerceivedBrightness(self) -> float: ...
    def getPixelARGB(self) -> PixelARGB: ...
    def getRed(self) -> int: ...
    def getSaturation(self) -> float: ...
    def getSaturationHSL(self) -> float: ...
    @classmethod
    def greyLevel(cls, arg0: float) -> Colour: ...
    def interpolatedWith(self, arg0: Colour, arg1: float) -> Colour: ...
    def isOpaque(self) -> bool: ...
    def isTransparent(self) -> bool: ...
    def overlaidWith(self, arg0: Colour) -> Colour: ...
    def toDisplayString(self, arg0: bool) -> str: ...
    def toString(self) -> str: ...
    @overload
    def withAlpha(self, alpha: int) -> Colour: ...
    @overload
    def withAlpha(self, alpha: float) -> Colour: ...
    def withBrightness(self, arg0: float) -> Colour: ...
    def withHue(self, arg0: float) -> Colour: ...
    def withLightness(self, arg0: float) -> Colour: ...
    def withMultipliedAlpha(self, arg0: float) -> Colour: ...
    def withMultipliedBrightness(self, arg0: float) -> Colour: ...
    def withMultipliedLightness(self, arg0: float) -> Colour: ...
    def withMultipliedSaturation(self, arg0: float) -> Colour: ...
    def withMultipliedSaturationHSL(self, arg0: float) -> Colour: ...
    def withRotatedHue(self, arg0: float) -> Colour: ...
    def withSaturation(self, arg0: float) -> Colour: ...
    def withSaturationHSL(self, arg0: float) -> Colour: ...
    def __eq__(self, arg0: Colour) -> bool: ...
    def __ne__(self, arg0: Colour) -> bool: ...

class ColourGradient:
    isRadial: bool
    point1: PointFloat
    point2: PointFloat
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, colour1: Colour, x1: float, y1: float, colour2: Colour, x2: float, y2: float, isRadial: bool) -> None: ...
    @overload
    def __init__(self, colour1: Colour, point1: PointFloat, colour2: Colour, point2: PointFloat, isRadial: bool) -> None: ...
    @overload
    def __init__(self, arg0: ColourGradient) -> None: ...
    def addColour(self, proportionAlongGradient: float, colour: Colour) -> int: ...
    def clearColours(self) -> None: ...
    def getColour(self, index: int) -> Colour: ...
    def getColourAtPosition(self, position: float) -> Colour: ...
    def getColourPosition(self, index: int) -> float: ...
    def getNumColours(self) -> int: ...
    @overload
    @classmethod
    def horizontal(cls, colour1: Colour, x1: float, colour2: Colour, x2: float) -> ColourGradient: ...
    @overload
    @classmethod
    def horizontal(cls, colourLeft: Colour, colourRight: Colour, area: RectangleInt) -> ColourGradient: ...
    @overload
    @classmethod
    def horizontal(cls, colourLeft: Colour, colourRight: Colour, area: RectangleFloat) -> ColourGradient: ...
    def isInvisible(self) -> bool: ...
    def isOpaque(self) -> bool: ...
    def multiplyOpacity(self, multiplier: float) -> None: ...
    def removeColour(self, index: int) -> None: ...
    def setColour(self, index: int, colour: Colour) -> None: ...
    @overload
    @classmethod
    def vertical(cls, colour1: Colour, y1: float, colour2: Colour, y2: float) -> ColourGradient: ...
    @overload
    @classmethod
    def vertical(cls, colourTop: Colour, colourBottom: Colour, area: RectangleInt) -> ColourGradient: ...
    @overload
    @classmethod
    def vertical(cls, colourTop: Colour, colourBottom: Colour, area: RectangleFloat) -> ColourGradient: ...
    def __eq__(self, arg0: ColourGradient) -> bool: ...
    def __ne__(self, arg0: ColourGradient) -> bool: ...

class Component:
    class FocusChangeDirection:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        backward: ClassVar[Component.FocusChangeDirection] = ...
        forward: ClassVar[Component.FocusChangeDirection] = ...
        unknown: ClassVar[Component.FocusChangeDirection] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class FocusChangeType:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        focusChangedByMouseClick: ClassVar[Component.FocusChangeType] = ...
        focusChangedByTabKey: ClassVar[Component.FocusChangeType] = ...
        focusChangedDirectly: ClassVar[Component.FocusChangeType] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class FocusContainerType:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        focusContainer: ClassVar[Component.FocusContainerType] = ...
        keyboardFocusContainer: ClassVar[Component.FocusContainerType] = ...
        none: ClassVar[Component.FocusContainerType] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    focusChangedByMouseClick: ClassVar[Component.FocusChangeType] = ...
    focusChangedByTabKey: ClassVar[Component.FocusChangeType] = ...
    focusChangedDirectly: ClassVar[Component.FocusChangeType] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def addAndMakeVisible(self, arg0: Component) -> None: ...
    @overload
    def addAndMakeVisible(self, arg0: Component, arg1: int) -> None: ...
    def addChildAndSetID(self, arg0: Component, arg1: str) -> None: ...
    @overload
    def addChildComponent(self, arg0: Component) -> None: ...
    @overload
    def addChildComponent(self, arg0: Component, arg1: int) -> None: ...
    def addComponentListener(self, arg0: ComponentListener) -> None: ...
    def addKeyListener(self, arg0: KeyListener) -> None: ...
    def addMouseListener(self, arg0: MouseListener, arg1: bool) -> None: ...
    @overload
    def addToDesktop(self, windowStyleFlags: ComponentPeer.StyleFlags, nativeWindowToAttachTo=...) -> None: ...
    @overload
    def addToDesktop(self, windowStyleFlags: int, nativeWindowToAttachTo=...) -> None: ...
    def alphaChanged(self) -> None: ...
    @classmethod
    def beginDragAutoRepeat(cls, arg0: int) -> None: ...
    def broughtToFront(self) -> None: ...
    def canModalEventBeSentToComponent(self, arg0: Component) -> bool: ...
    def centreWithSize(self, arg0: int, arg1: int) -> None: ...
    def childBoundsChanged(self, arg0: Component) -> None: ...
    def childrenChanged(self) -> None: ...
    def colourChanged(self) -> None: ...
    def contains(self, arg0: PointFloat) -> bool: ...
    def copyAllExplicitColoursTo(self, arg0: Component) -> None: ...
    def createComponentSnapshot(self, areaToGrab: RectangleInt, clipImageToComponentBounds: bool = ..., scaleFactor: float = ...) -> Image: ...
    def createFocusTraverser(self) -> ComponentTraverser: ...
    def createKeyboardFocusTraverser(self) -> ComponentTraverser: ...
    def deleteAllChildren(self) -> None: ...
    def enablementChanged(self) -> None: ...
    def enterModalState(self, takeKeyboardFocus: bool = ..., callback: function = ..., deleteWhenDismissed: bool = ...) -> None: ...
    def exitModalState(self, arg0: int) -> None: ...
    def findChildWithID(self, arg0: str) -> Component: ...
    def findColour(self, arg0: int, arg1: bool) -> Colour: ...
    def findFocusContainer(self) -> Component: ...
    def findKeyboardFocusContainer(self) -> Component: ...
    def getAlpha(self) -> float: ...
    @classmethod
    def getApproximateScaleFactorForComponent(cls, arg0: Component) -> float: ...
    def getBottom(self) -> int: ...
    def getBounds(self) -> RectangleInt: ...
    def getBoundsInParent(self) -> RectangleInt: ...
    def getChildComponent(self, arg0: int) -> Component: ...
    def getChildren(self) -> list: ...
    @overload
    def getComponentAt(self, arg0: int, arg1: int) -> Component: ...
    @overload
    def getComponentAt(self, arg0: PointInt) -> Component: ...
    @overload
    def getComponentAt(self, arg0: PointFloat) -> Component: ...
    def getComponentID(self) -> str: ...
    @classmethod
    def getCurrentlyFocusedComponent(cls) -> Component: ...
    @classmethod
    def getCurrentlyModalComponent(cls, arg0: int) -> Component: ...
    def getDescription(self) -> str: ...
    @overload
    def getDesktopScaleFactor(self) -> float: ...
    @overload
    def getDesktopScaleFactor(self) -> float: ...
    def getExplicitFocusOrder(self) -> int: ...
    def getHeight(self) -> int: ...
    def getHelpText(self) -> str: ...
    def getIndexOfChildComponent(self, arg0: Component) -> int: ...
    def getInterceptsMouseClicks(self) -> tuple: ...
    def getLocalBounds(self) -> RectangleInt: ...
    def getLookAndFeel(self) -> LookAndFeel: ...
    def getMouseClickGrabsKeyboardFocus(self) -> bool: ...
    def getMouseCursor(self) -> MouseCursor: ...
    def getMouseXYRelative(self) -> PointInt: ...
    def getName(self) -> str: ...
    def getNumChildComponents(self) -> int: ...
    @classmethod
    def getNumCurrentlyModalComponents(cls) -> int: ...
    def getParentComponent(self) -> Component: ...
    def getParentHeight(self) -> int: ...
    def getParentMonitorArea(self) -> RectangleInt: ...
    def getParentWidth(self) -> int: ...
    def getPeer(self) -> ComponentPeer: ...
    def getPosition(self) -> PointInt: ...
    @overload
    def getProperties(self) -> NamedValueSet: ...
    @overload
    def getProperties(self) -> NamedValueSet: ...
    def getRight(self) -> int: ...
    def getScreenBounds(self) -> RectangleInt: ...
    def getScreenPosition(self) -> PointInt: ...
    def getScreenX(self) -> int: ...
    def getScreenY(self) -> int: ...
    def getTitle(self) -> str: ...
    def getTopLevelComponent(self) -> Component: ...
    def getTransform(self) -> AffineTransform: ...
    def getViewportIgnoreDragFlag(self) -> bool: ...
    def getWantsKeyboardFocus(self) -> bool: ...
    def getWidth(self) -> int: ...
    def getWindowHandle(self, *args, **kwargs): ...
    def getX(self) -> int: ...
    def getY(self) -> int: ...
    def giveAwayKeyboardFocus(self) -> None: ...
    def grabKeyboardFocus(self) -> None: ...
    def handleCommandMessage(self, arg0: int) -> None: ...
    def hasFocusOutline(self) -> bool: ...
    def hasKeyboardFocus(self, arg0: bool) -> bool: ...
    def hitTest(self, arg0: int, arg1: int) -> bool: ...
    def inputAttemptWhenModal(self) -> None: ...
    def invalidateAccessibilityHandler(self) -> None: ...
    def isAccessible(self) -> bool: ...
    def isAlwaysOnTop(self) -> bool: ...
    def isBroughtToFrontOnMouseClick(self) -> bool: ...
    def isColourSpecified(self, arg0: int) -> bool: ...
    def isCurrentlyBlockedByAnotherModalComponent(self) -> bool: ...
    def isCurrentlyModal(self, arg0: bool) -> bool: ...
    def isEnabled(self) -> bool: ...
    def isFocusContainer(self) -> bool: ...
    def isKeyboardFocusContainer(self) -> bool: ...
    def isMouseButtonDown(self, arg0: bool) -> bool: ...
    @classmethod
    def isMouseButtonDownAnywhere(cls) -> bool: ...
    def isMouseOver(self, arg0: bool) -> bool: ...
    def isMouseOverOrDragging(self, arg0: bool) -> bool: ...
    def isOnDesktop(self) -> bool: ...
    def isOpaque(self) -> bool: ...
    def isPaintingUnclipped(self) -> bool: ...
    def isParentOf(self, arg0: Component) -> bool: ...
    def isShowing(self) -> bool: ...
    def isTransformed(self) -> bool: ...
    def isVisible(self) -> bool: ...
    def keyPressed(self, arg0: KeyPress) -> bool: ...
    def keyStateChanged(self, arg0: bool) -> bool: ...
    def lookAndFeelChanged(self) -> None: ...
    def minimisationStateChanged(self, arg0: bool) -> None: ...
    def modifierKeysChanged(self, arg0: ModifierKeys) -> None: ...
    def mouseDoubleClick(self, arg0: MouseEvent) -> None: ...
    def mouseDown(self, arg0: MouseEvent) -> None: ...
    def mouseDrag(self, arg0: MouseEvent) -> None: ...
    def mouseEnter(self, arg0: MouseEvent) -> None: ...
    def mouseExit(self, arg0: MouseEvent) -> None: ...
    def mouseMagnify(self, arg0: MouseEvent, arg1: float) -> None: ...
    def mouseMove(self, arg0: MouseEvent) -> None: ...
    def mouseUp(self, arg0: MouseEvent) -> None: ...
    def mouseWheelMove(self, arg0: MouseEvent, arg1: MouseWheelDetails) -> None: ...
    def moveKeyboardFocusToSibling(self, arg0: bool) -> None: ...
    def moved(self) -> None: ...
    def paint(self, arg0: Graphics) -> None: ...
    def paintEntireComponent(self, arg0: Graphics, arg1: bool) -> None: ...
    def paintOverChildren(self, arg0: Graphics) -> None: ...
    def parentHierarchyChanged(self) -> None: ...
    def parentSizeChanged(self) -> None: ...
    def postCommandMessage(self, arg0: int) -> None: ...
    def proportionOfHeight(self, arg0: float) -> int: ...
    def proportionOfWidth(self, arg0: float) -> int: ...
    def reallyContains(self, arg0: PointFloat, arg1: bool) -> bool: ...
    def releaseOwnership(self) -> handle: ...
    def removeAllChildren(self) -> None: ...
    @overload
    def removeChildComponent(self, arg0: Component) -> None: ...
    @overload
    def removeChildComponent(self, arg0: int) -> Component: ...
    def removeColour(self, arg0: int) -> None: ...
    def removeComponentListener(self, arg0: ComponentListener) -> None: ...
    def removeFromDesktop(self) -> None: ...
    def removeKeyListener(self, arg0: KeyListener) -> None: ...
    def removeMouseListener(self, arg0: MouseListener) -> None: ...
    @overload
    def repaint(self) -> None: ...
    @overload
    def repaint(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def repaint(self, arg0: RectangleInt) -> None: ...
    def resized(self) -> None: ...
    def runModalLoop(self) -> int: ...
    def sendLookAndFeelChange(self) -> None: ...
    def setAccessible(self, arg0: bool) -> None: ...
    def setAlpha(self, arg0: float) -> None: ...
    def setAlwaysOnTop(self, arg0: bool) -> None: ...
    @overload
    def setBounds(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def setBounds(self, arg0: RectangleInt) -> None: ...
    def setBoundsInset(self, arg0: BorderSizeInt) -> None: ...
    @overload
    def setBoundsRelative(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def setBoundsRelative(self, arg0: RectangleFloat) -> None: ...
    def setBoundsToFit(self, arg0: RectangleInt, arg1: Justification, arg2: bool) -> None: ...
    def setBroughtToFrontOnMouseClick(self, arg0: bool) -> None: ...
    def setBufferedToImage(self, arg0: bool) -> None: ...
    @overload
    def setCentrePosition(self, arg0: int, arg1: int) -> None: ...
    @overload
    def setCentrePosition(self, arg0: PointInt) -> None: ...
    def setCentreRelative(self, arg0: float, arg1: float) -> None: ...
    def setColour(self, arg0: int, arg1: Colour) -> None: ...
    def setDescription(self, arg0: str) -> None: ...
    def setEnabled(self, arg0: bool) -> None: ...
    def setExplicitFocusOrder(self, arg0: int) -> None: ...
    def setFocusContainerType(self, arg0: Component.FocusContainerType) -> None: ...
    def setHasFocusOutline(self, arg0: bool) -> None: ...
    def setHelpText(self, arg0: str) -> None: ...
    def setInterceptsMouseClicks(self, arg0: bool, arg1: bool) -> None: ...
    def setLookAndFeel(self, arg0: LookAndFeel) -> None: ...
    def setMouseClickGrabsKeyboardFocus(self, arg0: bool) -> None: ...
    def setMouseCursor(self, arg0: MouseCursor) -> None: ...
    def setName(self, arg0: str) -> None: ...
    def setOpaque(self, arg0: bool) -> None: ...
    def setPaintingIsUnclipped(self, arg0: bool) -> None: ...
    def setRepaintsOnMouseActivity(self, arg0: bool) -> None: ...
    def setSize(self, arg0: int, arg1: int) -> None: ...
    def setTitle(self, arg0: str) -> None: ...
    @overload
    def setTopLeftPosition(self, arg0: int, arg1: int) -> None: ...
    @overload
    def setTopLeftPosition(self, arg0: PointInt) -> None: ...
    def setTopRightPosition(self, arg0: int, arg1: int) -> None: ...
    def setTransform(self, arg0: AffineTransform) -> None: ...
    def setViewportIgnoreDragFlag(self, arg0: bool) -> None: ...
    def setVisible(self, arg0: bool) -> None: ...
    def setWantsKeyboardFocus(self, arg0: bool) -> None: ...
    def toBack(self) -> None: ...
    def toBehind(self, arg0: Component) -> None: ...
    def toFront(self, arg0: bool) -> None: ...
    def typeName(self) -> str: ...
    @classmethod
    def unfocusAllComponents(cls) -> None: ...
    def updateMouseCursor(self) -> None: ...
    def userTriedToCloseWindow(self) -> None: ...
    def visibilityChanged(self) -> None: ...

class ComponentAnimator:
    def __init__(self) -> None: ...
    def animateComponent(self, arg0, arg1: RectangleInt, arg2: float, arg3: int, arg4: bool, arg5: float, arg6: float) -> None: ...
    def cancelAllAnimations(self, arg0: bool) -> None: ...
    def cancelAnimation(self, arg0, arg1: bool) -> None: ...
    def fadeIn(self, arg0, arg1: int) -> None: ...
    def fadeOut(self, arg0, arg1: int) -> None: ...
    def getComponentDestination(self, arg0) -> RectangleInt: ...
    @overload
    def isAnimating(self, arg0) -> bool: ...
    @overload
    def isAnimating(self) -> bool: ...

class ComponentListener:
    def __init__(self) -> None: ...
    def componentBeingDeleted(self, arg0) -> None: ...
    def componentBroughtToFront(self, arg0) -> None: ...
    def componentChildrenChanged(self, arg0) -> None: ...
    def componentEnablementChanged(self, arg0) -> None: ...
    def componentMovedOrResized(self, arg0, arg1: bool, arg2: bool) -> None: ...
    def componentNameChanged(self, arg0) -> None: ...
    def componentParentHierarchyChanged(self, arg0) -> None: ...
    def componentVisibilityChanged(self, arg0) -> None: ...

class ComponentPeer:
    class StyleFlags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        windowAppearsOnTaskbar: ClassVar[ComponentPeer.StyleFlags] = ...
        windowHasCloseButton: ClassVar[ComponentPeer.StyleFlags] = ...
        windowHasDropShadow: ClassVar[ComponentPeer.StyleFlags] = ...
        windowHasMaximiseButton: ClassVar[ComponentPeer.StyleFlags] = ...
        windowHasMinimiseButton: ClassVar[ComponentPeer.StyleFlags] = ...
        windowHasTitleBar: ClassVar[ComponentPeer.StyleFlags] = ...
        windowIgnoresKeyPresses: ClassVar[ComponentPeer.StyleFlags] = ...
        windowIgnoresMouseClicks: ClassVar[ComponentPeer.StyleFlags] = ...
        windowIsResizable: ClassVar[ComponentPeer.StyleFlags] = ...
        windowIsSemiTransparent: ClassVar[ComponentPeer.StyleFlags] = ...
        windowIsTemporary: ClassVar[ComponentPeer.StyleFlags] = ...
        windowRequiresSynchronousCoreGraphicsRendering: ClassVar[ComponentPeer.StyleFlags] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: ComponentPeer.StyleFlags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: ComponentPeer.StyleFlags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: ComponentPeer.StyleFlags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: ComponentPeer.StyleFlags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: ComponentPeer.StyleFlags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: ComponentPeer.StyleFlags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: ComponentPeer.StyleFlags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: ComponentPeer.StyleFlags) -> int: ...
        def __xor__(self, arg0: ComponentPeer.StyleFlags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    windowAppearsOnTaskbar: ClassVar[ComponentPeer.StyleFlags] = ...
    windowHasCloseButton: ClassVar[ComponentPeer.StyleFlags] = ...
    windowHasDropShadow: ClassVar[ComponentPeer.StyleFlags] = ...
    windowHasMaximiseButton: ClassVar[ComponentPeer.StyleFlags] = ...
    windowHasMinimiseButton: ClassVar[ComponentPeer.StyleFlags] = ...
    windowHasTitleBar: ClassVar[ComponentPeer.StyleFlags] = ...
    windowIgnoresKeyPresses: ClassVar[ComponentPeer.StyleFlags] = ...
    windowIgnoresMouseClicks: ClassVar[ComponentPeer.StyleFlags] = ...
    windowIsResizable: ClassVar[ComponentPeer.StyleFlags] = ...
    windowIsSemiTransparent: ClassVar[ComponentPeer.StyleFlags] = ...
    windowIsTemporary: ClassVar[ComponentPeer.StyleFlags] = ...
    windowRequiresSynchronousCoreGraphicsRendering: ClassVar[ComponentPeer.StyleFlags] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def closeInputMethodContext(self) -> None: ...
    def contains(self, arg0: PointInt, arg1: bool) -> bool: ...
    def getAreaCoveredBy(self, arg0) -> RectangleInt: ...
    def getAvailableRenderingEngines(self) -> StringArray: ...
    def getBounds(self) -> RectangleInt: ...
    def getComponent(self, *args, **kwargs): ...
    @classmethod
    def getCurrentModifiersRealtime(cls) -> ModifierKeys: ...
    def getCurrentRenderingEngine(self) -> int: ...
    def getFrameSizeIfPresent(self, *args, **kwargs): ...
    def getLastFocusedSubcomponent(self, *args, **kwargs): ...
    def getNativeHandle(self, *args, **kwargs): ...
    def getNonFullScreenBounds(self) -> RectangleInt: ...
    @classmethod
    def getNumPeers(cls) -> int: ...
    @classmethod
    def getPeer(cls, arg0: int) -> ComponentPeer: ...
    @classmethod
    def getPeerFor(cls, arg0) -> ComponentPeer: ...
    def getPlatformScaleFactor(self) -> float: ...
    def getStyleFlags(self) -> int: ...
    def getUniqueID(self) -> int: ...
    @overload
    def globalToLocal(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def globalToLocal(self, arg0: PointInt) -> PointInt: ...
    @overload
    def globalToLocal(self, arg0: RectangleInt) -> RectangleInt: ...
    @overload
    def globalToLocal(self, arg0: RectangleFloat) -> RectangleFloat: ...
    def grabFocus(self) -> None: ...
    def handleBroughtToFront(self) -> None: ...
    def isFocused(self) -> bool: ...
    def isFullScreen(self) -> bool: ...
    def isKioskMode(self) -> bool: ...
    def isMinimised(self) -> bool: ...
    @classmethod
    def isValidPeer(cls, arg0: ComponentPeer) -> bool: ...
    @overload
    def localToGlobal(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def localToGlobal(self, arg0: PointInt) -> PointInt: ...
    @overload
    def localToGlobal(self, arg0: RectangleInt) -> RectangleInt: ...
    @overload
    def localToGlobal(self, arg0: RectangleFloat) -> RectangleFloat: ...
    def performAnyPendingRepaintsNow(self) -> None: ...
    def refreshTextInputTarget(self) -> None: ...
    def repaint(self, arg0: RectangleInt) -> None: ...
    def setAlpha(self, arg0: float) -> None: ...
    def setAlwaysOnTop(self, arg0: bool) -> bool: ...
    def setBounds(self, arg0: RectangleInt, arg1: bool) -> None: ...
    def setCurrentRenderingEngine(self, arg0: int) -> None: ...
    def setDocumentEditedStatus(self, arg0: bool) -> bool: ...
    def setFullScreen(self, arg0: bool) -> None: ...
    def setHasChangedSinceSaved(self, arg0: bool) -> None: ...
    def setIcon(self, arg0: Image) -> None: ...
    def setMinimised(self, arg0: bool) -> None: ...
    def setNonFullScreenBounds(self, arg0: RectangleInt) -> None: ...
    def setRepresentedFile(self, arg0: File) -> None: ...
    def setTitle(self, arg0: str) -> None: ...
    def setVisible(self, arg0: bool) -> None: ...
    def toBehind(self, arg0: ComponentPeer) -> None: ...
    def toFront(self, arg0: bool) -> None: ...
    def updateBounds(self) -> None: ...

class ComponentTraverser:
    def __init__(self) -> None: ...
    def getDefaultComponent(self, arg0) -> list: ...
    def getNextComponent(self, *args, **kwargs): ...
    def getPreviousComponent(self, *args, **kwargs): ...

class ConstDoubleArrayView:
    def __init__(self, *args, **kwargs) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __getitem__(self, arg0: int) -> float: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __release_buffer__(self, *args, **kwargs): ...

class ConstFloatArrayView:
    def __init__(self, *args, **kwargs) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __getitem__(self, arg0: int) -> float: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __release_buffer__(self, *args, **kwargs): ...

class ConstIntArrayView:
    def __init__(self, *args, **kwargs) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __getitem__(self, arg0: int) -> int: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __release_buffer__(self, *args, **kwargs): ...

class CriticalSection:
    def __init__(self) -> None: ...
    def enter(self) -> None: ...
    def exit(self) -> None: ...
    def tryEnter(self) -> bool: ...

class Decibels:
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def decibelsToGain(cls, decibels: float, minusInfinityDb: float = ...) -> float: ...
    @classmethod
    def gainToDecibels(cls, gain: float, minusInfinityDb: float = ...) -> float: ...
    @classmethod
    def gainWithLowerBound(cls, gain: float, lowerBoundDb: float) -> float: ...
    @classmethod
    def toString(cls, decibels: float, decimalPlaces: int = ..., minusInfinityDb: float = ..., shouldIncludeSuffix: bool = ..., customMinusInfinityString: str = ...) -> str: ...

class Desktop:
    class DisplayOrientation:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        allOrientations: ClassVar[Desktop.DisplayOrientation] = ...
        rotatedAntiClockwise: ClassVar[Desktop.DisplayOrientation] = ...
        rotatedClockwise: ClassVar[Desktop.DisplayOrientation] = ...
        upright: ClassVar[Desktop.DisplayOrientation] = ...
        upsideDown: ClassVar[Desktop.DisplayOrientation] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: Desktop.DisplayOrientation) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: Desktop.DisplayOrientation) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: Desktop.DisplayOrientation) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: Desktop.DisplayOrientation) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: Desktop.DisplayOrientation) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: Desktop.DisplayOrientation) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: Desktop.DisplayOrientation) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: Desktop.DisplayOrientation) -> int: ...
        def __xor__(self, arg0: Desktop.DisplayOrientation) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    allOrientations: ClassVar[Desktop.DisplayOrientation] = ...
    rotatedAntiClockwise: ClassVar[Desktop.DisplayOrientation] = ...
    rotatedClockwise: ClassVar[Desktop.DisplayOrientation] = ...
    upright: ClassVar[Desktop.DisplayOrientation] = ...
    upsideDown: ClassVar[Desktop.DisplayOrientation] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def addDarkModeSettingListener(self, arg0) -> None: ...
    def addFocusChangeListener(self, arg0) -> None: ...
    def addGlobalMouseListener(self, arg0: MouseListener) -> None: ...
    def beginDragAutoRepeat(self, arg0: int) -> None: ...
    @classmethod
    def canUseSemiTransparentWindows(cls) -> bool: ...
    def findComponentAt(self, *args, **kwargs): ...
    def getAnimator(self, *args, **kwargs): ...
    def getComponent(self, *args, **kwargs): ...
    def getCurrentOrientation(self) -> Desktop.DisplayOrientation: ...
    def getDefaultLookAndFeel(self) -> LookAndFeel: ...
    def getDisplays(self) -> Displays: ...
    def getDraggingMouseSource(self, arg0: int) -> MouseInputSource: ...
    def getGlobalScaleFactor(self) -> float: ...
    @classmethod
    def getInstance(cls) -> Desktop: ...
    def getKioskModeComponent(self, *args, **kwargs): ...
    @classmethod
    def getLastMouseDownPosition(cls) -> PointInt: ...
    def getMainMouseSource(self) -> MouseInputSource: ...
    def getMouseButtonClickCounter(self) -> int: ...
    @classmethod
    def getMousePosition(cls) -> PointInt: ...
    def getMouseSource(self, arg0: int) -> MouseInputSource: ...
    def getMouseSources(self) -> list: ...
    def getMouseWheelMoveCounter(self) -> int: ...
    def getNumComponents(self) -> int: ...
    def getNumDraggingMouseSources(self) -> int: ...
    def getNumMouseSources(self) -> int: ...
    def getOrientationsEnabled(self) -> int: ...
    def isDarkModeActive(self) -> bool: ...
    def isHeadless(self) -> bool: ...
    def isOrientationEnabled(self, arg0: Desktop.DisplayOrientation) -> bool: ...
    @classmethod
    def isScreenSaverEnabled(cls) -> bool: ...
    def removeDarkModeSettingListener(self, arg0) -> None: ...
    def removeFocusChangeListener(self, arg0) -> None: ...
    def removeGlobalMouseListener(self, arg0: MouseListener) -> None: ...
    def setDefaultLookAndFeel(self, arg0: LookAndFeel) -> None: ...
    def setGlobalScaleFactor(self, arg0: float) -> None: ...
    def setKioskModeComponent(self, arg0, arg1: bool) -> None: ...
    @classmethod
    def setMousePosition(cls, arg0: PointInt) -> None: ...
    def setOrientationsEnabled(self, arg0: int) -> None: ...
    @classmethod
    def setScreenSaverEnabled(cls, arg0: bool) -> None: ...

class DirectoryEntry:
    def __init__(self) -> None: ...
    def getCreationTime(self) -> Time: ...
    def getEstimatedProgress(self) -> float: ...
    def getFile(self) -> File: ...
    def getFileSize(self) -> int: ...
    def getModificationTime(self) -> Time: ...
    def isDirectory(self) -> bool: ...
    def isHidden(self) -> bool: ...
    def isReadOnly(self) -> bool: ...

class Displays:
    class Display:
        dpi: float
        isMain: bool
        keyboardInsets: BorderSizeInt
        safeAreaInsets: BorderSizeInt
        scale: float
        topLeftPhysical: PointInt
        totalArea: RectangleInt
        userArea: RectangleInt
        verticalFrequencyHz: Optional[float]
        def __init__(self, *args, **kwargs) -> None: ...
    def __init__(self, *args, **kwargs) -> None: ...
    def getDisplayForPoint(self, *args, **kwargs): ...
    def getDisplayForRect(self, *args, **kwargs): ...
    def getPrimaryDisplay(self, *args, **kwargs): ...
    def getRectangleList(self, arg0: bool) -> RectangleListInt: ...
    def getTotalBounds(self, arg0: bool) -> RectangleInt: ...
    @overload
    def logicalToPhysical(self, arg0: RectangleInt, arg1) -> RectangleInt: ...
    @overload
    def logicalToPhysical(self, arg0: RectangleFloat, arg1) -> RectangleFloat: ...
    @overload
    def logicalToPhysical(self, arg0: PointInt, arg1) -> PointInt: ...
    @overload
    def logicalToPhysical(self, arg0: PointFloat, arg1) -> PointFloat: ...
    @overload
    def physicalToLogical(self, arg0: RectangleInt, arg1) -> RectangleInt: ...
    @overload
    def physicalToLogical(self, arg0: RectangleFloat, arg1) -> RectangleFloat: ...
    @overload
    def physicalToLogical(self, arg0: PointInt, arg1) -> PointInt: ...
    @overload
    def physicalToLogical(self, arg0: PointFloat, arg1) -> PointFloat: ...
    def refresh(self) -> None: ...

class DocumentWindow(ResizableWindow):
    class TitleBarButtons:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        allButtons: ClassVar[DocumentWindow.TitleBarButtons] = ...
        closeButton: ClassVar[DocumentWindow.TitleBarButtons] = ...
        maximiseButton: ClassVar[DocumentWindow.TitleBarButtons] = ...
        minimiseButton: ClassVar[DocumentWindow.TitleBarButtons] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: DocumentWindow.TitleBarButtons) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: DocumentWindow.TitleBarButtons) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: DocumentWindow.TitleBarButtons) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: DocumentWindow.TitleBarButtons) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: DocumentWindow.TitleBarButtons) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: DocumentWindow.TitleBarButtons) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: DocumentWindow.TitleBarButtons) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: DocumentWindow.TitleBarButtons) -> int: ...
        def __xor__(self, arg0: DocumentWindow.TitleBarButtons) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    allButtons: ClassVar[DocumentWindow.TitleBarButtons] = ...
    closeButton: ClassVar[DocumentWindow.TitleBarButtons] = ...
    maximiseButton: ClassVar[DocumentWindow.TitleBarButtons] = ...
    minimiseButton: ClassVar[DocumentWindow.TitleBarButtons] = ...
    textColourId: ClassVar[int] = ...
    @overload
    def __init__(self, name: str, backgroundColour: Colour, requiredButtons: DocumentWindow.TitleBarButtons, addToDesktop: bool = ...) -> None: ...
    @overload
    def __init__(self, name: str, backgroundColour: Colour, requiredButtons: int, addToDesktop: bool = ...) -> None: ...
    def closeButtonPressed(self) -> None: ...
    def getCloseButton(self) -> Button: ...
    def getMaximiseButton(self) -> Button: ...
    def getMenuBarComponent(self) -> Component: ...
    def getMinimiseButton(self) -> Button: ...
    def getTitleBarHeight(self) -> int: ...
    def maximiseButtonPressed(self) -> None: ...
    def minimiseButtonPressed(self) -> None: ...
    def setIcon(self, arg0: Image) -> None: ...
    def setMenuBar(self, arg0: MenuBarModel, arg1: int) -> None: ...
    def setMenuBarComponent(self, arg0: Component) -> None: ...
    def setName(self, arg0: str) -> None: ...
    def setTitleBarButtonsRequired(self, arg0: DocumentWindow.TitleBarButtons, arg1: bool) -> None: ...
    def setTitleBarHeight(self, arg0: int) -> None: ...
    def setTitleBarTextCentred(self, arg0: bool) -> None: ...

class DoubleArrayView:
    def __init__(self, *args, **kwargs) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __getitem__(self, arg0: int) -> float: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __release_buffer__(self, *args, **kwargs): ...
    def __setitem__(self, arg0: int, arg1: float) -> None: ...

class Drawable(Component):
    def __init__(self) -> None: ...
    @classmethod
    def createFromImageData(cls, arg0: buffer) -> Drawable: ...
    @classmethod
    def createFromImageDataStream(cls, arg0: InputStream) -> Drawable: ...
    @classmethod
    def createFromImageFile(cls, arg0: File) -> Drawable: ...
    @classmethod
    def createFromSVG(cls, arg0: XmlElement) -> Drawable: ...
    @classmethod
    def createFromSVGFile(cls, arg0: File) -> Drawable: ...
    def draw(self, g: Graphics, opacity: float, transform: AffineTransform = ...) -> None: ...
    def drawAt(self, arg0: Graphics, arg1: float, arg2: float, arg3: float) -> None: ...
    def drawWithin(self, arg0: Graphics, arg1: RectangleFloat, arg2: RectanglePlacement, arg3: float) -> None: ...
    def getDrawableBounds(self) -> RectangleFloat: ...
    def getParent(self, *args, **kwargs): ...
    @classmethod
    def parseSVGPath(cls, arg0: str) -> Path: ...
    def replaceColour(self, arg0: Colour, arg1: Colour) -> bool: ...
    def setDrawableTransform(self, arg0: AffineTransform) -> None: ...
    def setOriginWithOriginalSize(self, arg0: PointFloat) -> None: ...
    def setTransformToFit(self, arg0: RectangleFloat, arg1: RectanglePlacement) -> None: ...

class DrawableButton(Button):
    class ButtonStyle:
        __members__: ClassVar[dict] = ...  # read-only
        ImageAboveTextLabel: ClassVar[DrawableButton.ButtonStyle] = ...
        ImageFitted: ClassVar[DrawableButton.ButtonStyle] = ...
        ImageOnButtonBackground: ClassVar[DrawableButton.ButtonStyle] = ...
        ImageOnButtonBackgroundOriginalSize: ClassVar[DrawableButton.ButtonStyle] = ...
        ImageRaw: ClassVar[DrawableButton.ButtonStyle] = ...
        ImageStretched: ClassVar[DrawableButton.ButtonStyle] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    ImageAboveTextLabel: ClassVar[DrawableButton.ButtonStyle] = ...
    ImageFitted: ClassVar[DrawableButton.ButtonStyle] = ...
    ImageOnButtonBackground: ClassVar[DrawableButton.ButtonStyle] = ...
    ImageOnButtonBackgroundOriginalSize: ClassVar[DrawableButton.ButtonStyle] = ...
    ImageRaw: ClassVar[DrawableButton.ButtonStyle] = ...
    ImageStretched: ClassVar[DrawableButton.ButtonStyle] = ...
    backgroundColourId: ClassVar[int] = ...
    backgroundOnColourId: ClassVar[int] = ...
    textColourId: ClassVar[int] = ...
    textColourOnId: ClassVar[int] = ...
    def __init__(self, arg0: str, arg1: DrawableButton.ButtonStyle) -> None: ...
    def getCurrentImage(self) -> Drawable: ...
    def getDownImage(self) -> Drawable: ...
    def getEdgeIndent(self) -> int: ...
    def getImageBounds(self) -> RectangleFloat: ...
    def getNormalImage(self) -> Drawable: ...
    def getOverImage(self) -> Drawable: ...
    def getStyle(self) -> DrawableButton.ButtonStyle: ...
    def setButtonStyle(self, arg0: DrawableButton.ButtonStyle) -> None: ...
    def setEdgeIndent(self, arg0: int) -> None: ...
    @overload
    def setImages(self, arg0: Drawable) -> None: ...
    @overload
    def setImages(self, arg0: Drawable, arg1: Drawable) -> None: ...
    @overload
    def setImages(self, arg0: Drawable, arg1: Drawable, arg2: Drawable) -> None: ...
    @overload
    def setImages(self, arg0: Drawable, arg1: Drawable, arg2: Drawable, arg3: Drawable) -> None: ...
    @overload
    def setImages(self, arg0: Drawable, arg1: Drawable, arg2: Drawable, arg3: Drawable, arg4: Drawable) -> None: ...
    @overload
    def setImages(self, arg0: Drawable, arg1: Drawable, arg2: Drawable, arg3: Drawable, arg4: Drawable, arg5: Drawable) -> None: ...
    @overload
    def setImages(self, arg0: Drawable, arg1: Drawable, arg2: Drawable, arg3: Drawable, arg4: Drawable, arg5: Drawable, arg6: Drawable, arg7: Drawable) -> None: ...

class DrawableComposite(Drawable):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DrawableComposite) -> None: ...
    def getBoundingBox(self) -> ParallelogramFloat: ...
    def getContentArea(self) -> RectangleFloat: ...
    def resetBoundingBoxToContentArea(self) -> None: ...
    def resetContentAreaAndBoundingBoxToFitChildren(self) -> None: ...
    @overload
    def setBoundingBox(self, arg0: ParallelogramFloat) -> None: ...
    @overload
    def setBoundingBox(self, arg0: RectangleFloat) -> None: ...
    def setContentArea(self, arg0: RectangleFloat) -> None: ...

class DrawableImage(Drawable):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Image) -> None: ...
    @overload
    def __init__(self, arg0: DrawableImage) -> None: ...
    def getBoundingBox(self) -> ParallelogramFloat: ...
    def getImage(self) -> Image: ...
    def getOpacity(self) -> float: ...
    def getOverlayColour(self) -> Colour: ...
    @overload
    def setBoundingBox(self, arg0: ParallelogramFloat) -> None: ...
    @overload
    def setBoundingBox(self, arg0: RectangleFloat) -> None: ...
    def setImage(self, arg0: Image) -> None: ...
    def setOpacity(self, arg0: float) -> None: ...
    def setOverlayColour(self, arg0: Colour) -> None: ...

class DrawablePath(Drawable):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DrawablePath) -> None: ...
    def getPath(self) -> Path: ...
    def getStrokePath(self) -> Path: ...
    def setPath(self, arg0: Path) -> None: ...

class DrawableRectangle(Drawable):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DrawableRectangle) -> None: ...
    def getCornerSize(self) -> PointFloat: ...
    def getRectangle(self) -> ParallelogramFloat: ...
    def setCornerSize(self, arg0: PointFloat) -> None: ...
    def setRectangle(self, arg0: ParallelogramFloat) -> None: ...

class DrawableShape(Drawable):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DrawableShape) -> None: ...
    def getDashLengths(self) -> ArrayFloat: ...
    def getFill(self) -> FillType: ...
    def getStrokeFill(self) -> FillType: ...
    def getStrokeType(self) -> PathStrokeType: ...
    def setDashLengths(self, arg0: ArrayFloat) -> None: ...
    def setFill(self, arg0: FillType) -> None: ...
    def setStrokeFill(self, arg0: FillType) -> None: ...
    def setStrokeThickness(self, arg0: float) -> None: ...
    def setStrokeType(self, arg0: PathStrokeType) -> None: ...

class DrawableText(Drawable):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DrawableText) -> None: ...
    def getBoundingBox(self) -> ParallelogramFloat: ...
    def getColour(self) -> Colour: ...
    def getFont(self) -> Font: ...
    def getFontHeight(self) -> float: ...
    def getFontHorizontalScale(self) -> float: ...
    def getJustification(self) -> Justification: ...
    def getText(self) -> str: ...
    def setBoundingBox(self, arg0: ParallelogramFloat) -> None: ...
    def setColour(self, arg0: Colour) -> None: ...
    def setFont(self, arg0: Font, arg1: bool) -> None: ...
    def setFontHeight(self, arg0: float) -> None: ...
    def setFontHorizontalScale(self, arg0: float) -> None: ...
    def setJustification(self, arg0: Justification) -> None: ...
    def setText(self, arg0: str) -> None: ...

class File:
    class FollowSymlinks:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        no: ClassVar[File.FollowSymlinks] = ...
        noCycles: ClassVar[File.FollowSymlinks] = ...
        yes: ClassVar[File.FollowSymlinks] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class SpecialLocationType:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        commonApplicationDataDirectory: ClassVar[File.SpecialLocationType] = ...
        commonDocumentsDirectory: ClassVar[File.SpecialLocationType] = ...
        currentApplicationFile: ClassVar[File.SpecialLocationType] = ...
        currentExecutableFile: ClassVar[File.SpecialLocationType] = ...
        globalApplicationsDirectory: ClassVar[File.SpecialLocationType] = ...
        hostApplicationPath: ClassVar[File.SpecialLocationType] = ...
        invokedExecutableFile: ClassVar[File.SpecialLocationType] = ...
        tempDirectory: ClassVar[File.SpecialLocationType] = ...
        userApplicationDataDirectory: ClassVar[File.SpecialLocationType] = ...
        userDesktopDirectory: ClassVar[File.SpecialLocationType] = ...
        userDocumentsDirectory: ClassVar[File.SpecialLocationType] = ...
        userHomeDirectory: ClassVar[File.SpecialLocationType] = ...
        userMoviesDirectory: ClassVar[File.SpecialLocationType] = ...
        userMusicDirectory: ClassVar[File.SpecialLocationType] = ...
        userPicturesDirectory: ClassVar[File.SpecialLocationType] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class TypesOfFileToFind:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        findDirectories: ClassVar[File.TypesOfFileToFind] = ...
        findFiles: ClassVar[File.TypesOfFileToFind] = ...
        findFilesAndDirectories: ClassVar[File.TypesOfFileToFind] = ...
        ignoreHiddenFiles: ClassVar[File.TypesOfFileToFind] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    commonApplicationDataDirectory: ClassVar[File.SpecialLocationType] = ...
    commonDocumentsDirectory: ClassVar[File.SpecialLocationType] = ...
    currentApplicationFile: ClassVar[File.SpecialLocationType] = ...
    currentExecutableFile: ClassVar[File.SpecialLocationType] = ...
    findDirectories: ClassVar[File.TypesOfFileToFind] = ...
    findFiles: ClassVar[File.TypesOfFileToFind] = ...
    findFilesAndDirectories: ClassVar[File.TypesOfFileToFind] = ...
    globalApplicationsDirectory: ClassVar[File.SpecialLocationType] = ...
    hostApplicationPath: ClassVar[File.SpecialLocationType] = ...
    ignoreHiddenFiles: ClassVar[File.TypesOfFileToFind] = ...
    invokedExecutableFile: ClassVar[File.SpecialLocationType] = ...
    tempDirectory: ClassVar[File.SpecialLocationType] = ...
    userApplicationDataDirectory: ClassVar[File.SpecialLocationType] = ...
    userDesktopDirectory: ClassVar[File.SpecialLocationType] = ...
    userDocumentsDirectory: ClassVar[File.SpecialLocationType] = ...
    userHomeDirectory: ClassVar[File.SpecialLocationType] = ...
    userMoviesDirectory: ClassVar[File.SpecialLocationType] = ...
    userMusicDirectory: ClassVar[File.SpecialLocationType] = ...
    userPicturesDirectory: ClassVar[File.SpecialLocationType] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: File) -> None: ...
    @classmethod
    def addTrailingSeparator(cls, arg0: str) -> str: ...
    def appendData(self, arg0: buffer) -> bool: ...
    def appendText(self, textToAppend: str, asUnicode: bool = ..., writeUnicodeHeaderBytes: bool = ..., lineEndings: str = ...) -> bool: ...
    @classmethod
    def areFileNamesCaseSensitive(cls) -> bool: ...
    def containsSubDirectories(self) -> bool: ...
    def copyDirectoryTo(self, arg0: File) -> bool: ...
    def copyFileTo(self, arg0: File) -> bool: ...
    def create(self) -> Result: ...
    def createDirectory(self) -> Result: ...
    @classmethod
    def createFileWithoutCheckingPath(cls, arg0: str) -> File: ...
    def createInputStream(self) -> FileInputStream: ...
    @classmethod
    def createLegalFileName(cls, arg0: str) -> str: ...
    @classmethod
    def createLegalPathName(cls, arg0: str) -> str: ...
    def createOutputStream(self, bufferSize: int = ...) -> FileOutputStream: ...
    def createShortcut(self, arg0: str, arg1: File) -> bool: ...
    def createSymbolicLink(self, arg0: File, arg1: bool) -> bool: ...
    @classmethod
    def createTempFile(cls, arg0: str) -> File: ...
    def deleteFile(self) -> bool: ...
    def deleteRecursively(self, followSymlinks: bool = ...) -> bool: ...
    @classmethod
    def descriptionOfSizeInBytes(cls, arg0: int) -> str: ...
    def exists(self) -> bool: ...
    def existsAsFile(self) -> bool: ...
    def findChildFiles(self, *args, **kwargs): ...
    @classmethod
    def findFileSystemRoots(cls, *args, **kwargs): ...
    def getBytesFreeOnVolume(self) -> int: ...
    def getChildFile(self, arg0: str) -> File: ...
    def getCreationTime(self) -> Time: ...
    @classmethod
    def getCurrentWorkingDirectory(cls) -> File: ...
    def getFileExtension(self) -> str: ...
    def getFileIdentifier(self) -> int: ...
    def getFileName(self) -> str: ...
    def getFileNameWithoutExtension(self) -> str: ...
    def getFullPathName(self) -> str: ...
    def getLastAccessTime(self) -> Time: ...
    def getLastModificationTime(self) -> Time: ...
    def getLinkedTarget(self) -> File: ...
    def getNativeLinkedTarget(self) -> str: ...
    def getNonexistentChildFile(self, prefix: str, suffix: str, putNumbersInBrackets: bool = ...) -> File: ...
    def getNonexistentSibling(self, putNumbersInBrackets: bool = ...) -> File: ...
    def getNumberOfChildFiles(self, whatToLookFor: int, wildCardPattern: str = ...) -> int: ...
    def getParentDirectory(self) -> File: ...
    def getRelativePathFrom(self, arg0: File) -> str: ...
    @classmethod
    def getSeparatorChar(cls) -> int: ...
    @classmethod
    def getSeparatorString(cls) -> str: ...
    def getSiblingFile(self, arg0: str) -> File: ...
    def getSize(self) -> int: ...
    @classmethod
    def getSpecialLocation(cls, arg0: File.SpecialLocationType) -> File: ...
    def getVersion(self) -> str: ...
    def getVolumeLabel(self) -> str: ...
    def getVolumeSerialNumber(self) -> int: ...
    def getVolumeTotalSize(self) -> int: ...
    def hasFileExtension(self, arg0: str) -> bool: ...
    def hasIdenticalContentTo(self, arg0: File) -> bool: ...
    def hasReadAccess(self) -> bool: ...
    def hasWriteAccess(self) -> bool: ...
    def hashCode(self) -> int: ...
    def hashCode64(self) -> int: ...
    def isAChildOf(self, arg0: File) -> bool: ...
    @classmethod
    def isAbsolutePath(cls, arg0: str) -> bool: ...
    def isDirectory(self) -> bool: ...
    def isHidden(self) -> bool: ...
    def isOnCDRomDrive(self) -> bool: ...
    def isOnHardDisk(self) -> bool: ...
    def isOnRemovableDrive(self) -> bool: ...
    def isRoot(self) -> bool: ...
    def isShortcut(self) -> bool: ...
    def isSymbolicLink(self) -> bool: ...
    def loadFileAsData(self, arg0: MemoryBlock) -> bool: ...
    def loadFileAsString(self) -> str: ...
    def moveFileTo(self, arg0: File) -> bool: ...
    def moveToTrash(self) -> bool: ...
    def readLines(self, arg0: StringArray) -> None: ...
    def replaceFileIn(self, arg0: File) -> bool: ...
    def replaceWithData(self, arg0: buffer) -> bool: ...
    def replaceWithText(self, textToWrite: str, asUnicode: bool = ..., writeUnicodeHeaderBytes: bool = ..., lineEndings: str = ...) -> bool: ...
    def revealToUser(self) -> None: ...
    def setAsCurrentWorkingDirectory(self) -> bool: ...
    def setCreationTime(self, arg0: Time) -> bool: ...
    def setExecutePermission(self, arg0: bool) -> bool: ...
    def setLastAccessTime(self, arg0: Time) -> bool: ...
    def setLastModificationTime(self, arg0: Time) -> bool: ...
    def setReadOnly(self, shouldBeReadOnly: bool, applyRecursively: bool = ...) -> bool: ...
    def startAsProcess(self, arg0: str) -> bool: ...
    def withFileExtension(self, arg0: str) -> File: ...
    def __eq__(self, arg0: File) -> bool: ...
    def __gt__(self, arg0: File) -> bool: ...
    def __lt__(self, arg0: File) -> bool: ...
    def __ne__(self, arg0: File) -> bool: ...

class FileChooser:
    def __init__(self, dialogBoxTitle: str, initialFileOrDirectory: File = ..., filePatternsAllowed: str = ..., useOSNativeDialogBox: bool = ..., treatFilePackagesAsDirectories: bool = ..., parentComponent: Component = ...) -> None: ...
    def browseForDirectory(self) -> bool: ...
    def browseForFileToOpen(self) -> bool: ...
    def browseForFileToSave(self, warnAboutOverwritingExistingFiles: bool) -> bool: ...
    def browseForMultipleFilesOrDirectories(self) -> bool: ...
    def browseForMultipleFilesToOpen(self) -> bool: ...
    def getResult(self) -> File: ...
    def getResults(self) -> ArrayFile: ...
    def getURLResult(self) -> URL: ...
    def getURLResults(self, *args, **kwargs): ...
    @classmethod
    def isPlatformDialogAvailable(cls) -> bool: ...
    def launchAsync(self, arg0: int, arg1: Callable[[FileChooser], None]) -> None: ...
    @classmethod
    def registerCustomMimeTypeForFileExtension(cls, arg0: str, arg1: str) -> None: ...
    def showDialog(self, arg0: int) -> bool: ...

class FileFilter:
    def __init__(self, arg0: str) -> None: ...
    def getDescription(self) -> str: ...
    def isDirectorySuitable(self, arg0: File) -> bool: ...
    def isFileSuitable(self, arg0: File) -> bool: ...

class FileInputSource(InputSource):
    def __init__(self, arg0, arg1: bool) -> None: ...

class FileInputStream(InputStream):
    def __init__(self, arg0) -> None: ...
    def failedToOpen(self) -> bool: ...
    def getFile(self, *args, **kwargs): ...
    def getStatus(self) -> Result: ...
    def openedOk(self) -> bool: ...

class FileOutputStream(OutputStream):
    def __init__(self, fileToWriteTo, bufferSizeToUse: int = ...) -> None: ...
    def failedToOpen(self) -> bool: ...
    def getFile(self, *args, **kwargs): ...
    def getStatus(self) -> Result: ...
    def openedOk(self) -> bool: ...
    def truncate(self) -> Result: ...

class FileSearchPath:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    def add(self, arg0: File, arg1: int) -> None: ...
    def addIfNotAlreadyThere(self, arg0: File) -> bool: ...
    def addPath(self, arg0: FileSearchPath) -> None: ...
    def findChildFiles(self, *args, **kwargs): ...
    def getNumPaths(self) -> int: ...
    def getRawString(self, arg0: int) -> str: ...
    def isFileInPath(self, arg0: File, arg1: bool) -> bool: ...
    def remove(self, arg0: int) -> None: ...
    def removeNonExistentPaths(self) -> None: ...
    def removeRedundantPaths(self) -> None: ...
    def toString(self) -> str: ...
    def toStringWithSeparator(self, arg0: str) -> str: ...
    def __getitem__(self, arg0: int) -> File: ...
    def __iter__(self) -> typing.Iterator[File]: ...

class FillType:
    colour: Colour
    gradient: ColourGradient
    image: Image
    transform: AffineTransform
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Colour) -> None: ...
    @overload
    def __init__(self, arg0: ColourGradient) -> None: ...
    @overload
    def __init__(self, arg0: Image, arg1: AffineTransform) -> None: ...
    @overload
    def __init__(self, arg0: FillType) -> None: ...
    def getOpacity(self) -> float: ...
    def isColour(self) -> bool: ...
    def isGradient(self) -> bool: ...
    def isInvisible(self) -> bool: ...
    def isTiledImage(self) -> bool: ...
    def setColour(self, arg0: Colour) -> None: ...
    def setGradient(self, arg0: ColourGradient) -> None: ...
    def setOpacity(self, arg0: float) -> None: ...
    def setTiledImage(self, arg0: Image, arg1: AffineTransform) -> None: ...
    def transformed(self, arg0: AffineTransform) -> FillType: ...
    def __eq__(self, arg0: FillType) -> bool: ...
    def __ne__(self, arg0: FillType) -> bool: ...

class FlacAudioFormat(AudioFormat):
    def __init__(self) -> None: ...

class FlexBox:
    class AlignContent:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        center: ClassVar[FlexBox.AlignContent] = ...
        flexEnd: ClassVar[FlexBox.AlignContent] = ...
        flexStart: ClassVar[FlexBox.AlignContent] = ...
        spaceAround: ClassVar[FlexBox.AlignContent] = ...
        spaceBetween: ClassVar[FlexBox.AlignContent] = ...
        stretch: ClassVar[FlexBox.AlignContent] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class AlignItems:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        center: ClassVar[FlexBox.AlignItems] = ...
        flexEnd: ClassVar[FlexBox.AlignItems] = ...
        flexStart: ClassVar[FlexBox.AlignItems] = ...
        stretch: ClassVar[FlexBox.AlignItems] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Direction:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        column: ClassVar[FlexBox.Direction] = ...
        columnReverse: ClassVar[FlexBox.Direction] = ...
        row: ClassVar[FlexBox.Direction] = ...
        rowReverse: ClassVar[FlexBox.Direction] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class JustifyContent:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        center: ClassVar[FlexBox.JustifyContent] = ...
        flexEnd: ClassVar[FlexBox.JustifyContent] = ...
        flexStart: ClassVar[FlexBox.JustifyContent] = ...
        spaceAround: ClassVar[FlexBox.JustifyContent] = ...
        spaceBetween: ClassVar[FlexBox.JustifyContent] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Wrap:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        noWrap: ClassVar[FlexBox.Wrap] = ...
        wrap: ClassVar[FlexBox.Wrap] = ...
        wrapReverse: ClassVar[FlexBox.Wrap] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    alignContent: FlexBox.AlignContent
    alignItems: FlexBox.AlignItems
    flexDirection: FlexBox.Direction
    flexWrap: FlexBox.Wrap
    items: Incomplete
    justifyContent: FlexBox.JustifyContent
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: FlexBox.Direction, arg1: FlexBox.Wrap, arg2: FlexBox.AlignContent, arg3: FlexBox.AlignItems, arg4: FlexBox.JustifyContent) -> None: ...
    @overload
    def __init__(self, arg0: FlexBox.JustifyContent) -> None: ...
    @overload
    def performLayout(self, arg0: RectangleFloat) -> None: ...
    @overload
    def performLayout(self, arg0: RectangleInt) -> None: ...

class FlexItem:
    class AlignSelf:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        autoAlign: ClassVar[FlexItem.AlignSelf] = ...
        center: ClassVar[FlexItem.AlignSelf] = ...
        flexEnd: ClassVar[FlexItem.AlignSelf] = ...
        flexStart: ClassVar[FlexItem.AlignSelf] = ...
        stretch: ClassVar[FlexItem.AlignSelf] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Margin:
        bottom: float
        left: float
        right: float
        top: float
        @overload
        def __init__(self) -> None: ...
        @overload
        def __init__(self, arg0: float) -> None: ...
        @overload
        def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    alignSelf: FlexItem.AlignSelf
    associatedComponent: Component
    associatedFlexBox: FlexBox
    currentBounds: RectangleFloat
    flexBasis: float
    flexGrow: float
    flexShrink: float
    height: float
    margin: FlexItem.Margin
    maxHeight: float
    maxWidth: float
    minHeight: float
    minWidth: float
    order: int
    width: float
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: Component) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: FlexBox) -> None: ...
    @overload
    def __init__(self, arg0: Component) -> None: ...
    @overload
    def __init__(self, arg0: FlexBox) -> None: ...
    def withAlignSelf(self, arg0: FlexItem.AlignSelf) -> FlexItem: ...
    @overload
    def withFlex(self, arg0: float) -> FlexItem: ...
    @overload
    def withFlex(self, arg0: float, arg1: float) -> FlexItem: ...
    @overload
    def withFlex(self, arg0: float, arg1: float, arg2: float) -> FlexItem: ...
    def withHeight(self, arg0: float) -> FlexItem: ...
    def withMargin(self, arg0: FlexItem.Margin) -> FlexItem: ...
    def withMaxHeight(self, arg0: float) -> FlexItem: ...
    def withMaxWidth(self, arg0: float) -> FlexItem: ...
    def withMinHeight(self, arg0: float) -> FlexItem: ...
    def withMinWidth(self, arg0: float) -> FlexItem: ...
    def withOrder(self, arg0: int) -> FlexItem: ...
    def withWidth(self, arg0: float) -> FlexItem: ...

class FloatArrayView:
    def __init__(self, *args, **kwargs) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __getitem__(self, arg0: int) -> float: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __release_buffer__(self, *args, **kwargs): ...
    def __setitem__(self, arg0: int, arg1: float) -> None: ...

class FocusTraverser(ComponentTraverser):
    def __init__(self, *args, **kwargs) -> None: ...

class Font:
    class FontStyleFlags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        bold: ClassVar[Font.FontStyleFlags] = ...
        italic: ClassVar[Font.FontStyleFlags] = ...
        plain: ClassVar[Font.FontStyleFlags] = ...
        underlined: ClassVar[Font.FontStyleFlags] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: Font.FontStyleFlags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: Font.FontStyleFlags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: Font.FontStyleFlags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: Font.FontStyleFlags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: Font.FontStyleFlags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: Font.FontStyleFlags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: Font.FontStyleFlags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: Font.FontStyleFlags) -> int: ...
        def __xor__(self, arg0: Font.FontStyleFlags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    bold: ClassVar[Font.FontStyleFlags] = ...
    italic: ClassVar[Font.FontStyleFlags] = ...
    plain: ClassVar[Font.FontStyleFlags] = ...
    underlined: ClassVar[Font.FontStyleFlags] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, fontHeight: float, styleFlags: int = ...) -> None: ...
    @overload
    def __init__(self, fontHeight: float, styleFlags: Font.FontStyleFlags) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: float, arg2: Font.FontStyleFlags) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: str, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0: Font) -> None: ...
    def boldened(self) -> Font: ...
    @classmethod
    def findAllTypefaceNames(cls) -> StringArray: ...
    @classmethod
    def findAllTypefaceStyles(cls, arg0: str) -> StringArray: ...
    @classmethod
    def fromString(cls, arg0: str) -> Font: ...
    def getAscent(self) -> float: ...
    def getAscentInPoints(self) -> float: ...
    @classmethod
    def getDefaultMinimumHorizontalScaleFactor(cls) -> float: ...
    @classmethod
    def getDefaultMonospacedFontName(cls) -> str: ...
    @classmethod
    def getDefaultSansSerifFontName(cls) -> str: ...
    @classmethod
    def getDefaultSerifFontName(cls) -> str: ...
    @classmethod
    def getDefaultStyle(cls) -> str: ...
    def getDescent(self) -> float: ...
    def getDescentInPoints(self) -> float: ...
    def getExtraKerningFactor(self) -> float: ...
    @classmethod
    def getFallbackFontName(cls) -> str: ...
    @classmethod
    def getFallbackFontStyle(cls) -> str: ...
    def getHeight(self) -> float: ...
    def getHeightInPoints(self) -> float: ...
    def getHorizontalScale(self) -> float: ...
    def getStringWidth(self, arg0: str) -> int: ...
    def getStringWidthFloat(self, arg0: str) -> float: ...
    def getStyleFlags(self) -> int: ...
    def getTypefaceName(self) -> str: ...
    def getTypefaceStyle(self) -> str: ...
    def isBold(self) -> bool: ...
    def isItalic(self) -> bool: ...
    def isUnderlined(self) -> bool: ...
    def italicised(self) -> Font: ...
    def setBold(self, arg0: bool) -> None: ...
    @classmethod
    def setDefaultMinimumHorizontalScaleFactor(cls, arg0: float) -> None: ...
    def setExtraKerningFactor(self, arg0: float) -> None: ...
    @classmethod
    def setFallbackFontName(cls, arg0: str) -> None: ...
    @classmethod
    def setFallbackFontStyle(cls, arg0: str) -> None: ...
    def setHeight(self, arg0: float) -> None: ...
    def setHeightWithoutChangingWidth(self, arg0: float) -> None: ...
    def setHorizontalScale(self, arg0: float) -> None: ...
    def setItalic(self, arg0: bool) -> None: ...
    @overload
    def setSizeAndStyle(self, arg0: float, arg1: int, arg2: float, arg3: float) -> None: ...
    @overload
    def setSizeAndStyle(self, arg0: float, arg1: Font.FontStyleFlags, arg2: float, arg3: float) -> None: ...
    @overload
    def setSizeAndStyle(self, arg0: float, arg1: str, arg2: float, arg3: float) -> None: ...
    @overload
    def setStyleFlags(self, arg0: int) -> None: ...
    @overload
    def setStyleFlags(self, arg0: Font.FontStyleFlags) -> None: ...
    def setTypefaceName(self, arg0: str) -> None: ...
    def setTypefaceStyle(self, arg0: str) -> None: ...
    def setUnderline(self, arg0: bool) -> None: ...
    def toString(self) -> str: ...
    def withExtraKerningFactor(self, arg0: float) -> Font: ...
    def withHeight(self, arg0: float) -> Font: ...
    def withHorizontalScale(self, arg0: float) -> Font: ...
    def withPointHeight(self, arg0: float) -> Font: ...
    @overload
    def withStyle(self, arg0: int) -> Font: ...
    @overload
    def withStyle(self, arg0: Font.FontStyleFlags) -> Font: ...
    def withTypefaceStyle(self, arg0: str) -> Font: ...
    def __eq__(self, arg0: Font) -> bool: ...
    def __ne__(self, arg0: Font) -> bool: ...

class GIFImageFormat(ImageFileFormat):
    def __init__(self) -> None: ...

class Graphics:
    class ResamplingQuality:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        highResamplingQuality: ClassVar[Graphics.ResamplingQuality] = ...
        lowResamplingQuality: ClassVar[Graphics.ResamplingQuality] = ...
        mediumResamplingQuality: ClassVar[Graphics.ResamplingQuality] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class ScopedSaveState:
        def __init__(self, arg0: Graphics) -> None: ...
        def __enter__(self) -> None: ...
        def __exit__(self, arg0: Optional[type], arg1: Optional[object], arg2: Optional[object]) -> None: ...
    highResamplingQuality: ClassVar[Graphics.ResamplingQuality] = ...
    lowResamplingQuality: ClassVar[Graphics.ResamplingQuality] = ...
    mediumResamplingQuality: ClassVar[Graphics.ResamplingQuality] = ...
    @overload
    def __init__(self, arg0: Image) -> None: ...
    @overload
    def __init__(self, arg0: LowLevelGraphicsContext) -> None: ...
    def addTransform(self, arg0: AffineTransform) -> None: ...
    def beginTransparencyLayer(self, arg0: float) -> None: ...
    def clipRegionIntersects(self, arg0: RectangleInt) -> bool: ...
    def drawArrow(self, arg0: LineFloat, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def drawEllipse(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float) -> None: ...
    @overload
    def drawEllipse(self, arg0: RectangleFloat, arg1: float) -> None: ...
    @overload
    def drawFittedText(self, text: str, x: int, y: int, width: int, height: int, justificationType: Justification, maximumNumberOfLines: int, minimumHorizontalScale: float = ...) -> None: ...
    @overload
    def drawFittedText(self, text: str, x: int, y: int, width: int, height: int, justificationType: Justification.Flags, maximumNumberOfLines: int, minimumHorizontalScale: float = ...) -> None: ...
    @overload
    def drawFittedText(self, text: str, x: int, y: int, width: int, height: int, justificationType: int, maximumNumberOfLines: int, minimumHorizontalScale: float = ...) -> None: ...
    @overload
    def drawFittedText(self, text: str, area: RectangleInt, justificationType: Justification, maximumNumberOfLines: int, minimumHorizontalScale: float = ...) -> None: ...
    @overload
    def drawFittedText(self, text: str, area: RectangleInt, justificationType: Justification.Flags, maximumNumberOfLines: int, minimumHorizontalScale: float = ...) -> None: ...
    @overload
    def drawFittedText(self, text: str, area: RectangleInt, justificationType: int, maximumNumberOfLines: int, minimumHorizontalScale: float = ...) -> None: ...
    def drawHorizontalLine(self, arg0: int, arg1: float, arg2: float) -> None: ...
    @overload
    def drawImage(self, imageToDraw: Image, destX: int, destY: int, destWidth: int, destHeight: int, sourceX: int, sourceY: int, sourceWidth: int, sourceHeight: int, fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawImage(self, imageToDraw: Image, targetArea: RectangleFloat, placementWithinTarget: RectanglePlacement = ..., fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawImage(self, imageToDraw: Image, targetArea: RectangleFloat, placementWithinTarget: RectanglePlacement.Flags = ..., fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawImage(self, imageToDraw: Image, targetArea: RectangleFloat, placementWithinTarget: int = ..., fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    def drawImageAt(self, imageToDraw: Image, topLeftX: int, topLeftY: int, fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    def drawImageTransformed(self, imageToDraw: Image, transform: AffineTransform, fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawImageWithin(self, imageToDraw: Image, destX: int, destY: int, destWidth: int, destHeight: int, placementWithinTarget: RectanglePlacement, fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawImageWithin(self, imageToDraw: Image, destX: float, destY: float, destWidth: float, destHeight: float, placementWithinTarget: RectanglePlacement.Flags, fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawImageWithin(self, imageToDraw: Image, destX: float, destY: float, destWidth: float, destHeight: float, placementWithinTarget: int, fillAlphaChannelWithCurrentBrush: bool = ...) -> None: ...
    @overload
    def drawLine(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def drawLine(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float) -> None: ...
    @overload
    def drawLine(self, arg0: LineFloat) -> None: ...
    @overload
    def drawLine(self, arg0: LineFloat, arg1: float) -> None: ...
    @overload
    def drawMultiLineText(self, text: str, startX: int, baselineY: int, maximumLineWidth: int, justification: Justification = ..., loading: float = ...) -> None: ...
    @overload
    def drawMultiLineText(self, text: str, startX: int, baselineY: int, maximumLineWidth: int, justification: Justification.Flags = ..., loading: float = ...) -> None: ...
    @overload
    def drawMultiLineText(self, text: str, startX: int, baselineY: int, maximumLineWidth: int, justification: int = ..., loading: float = ...) -> None: ...
    @overload
    def drawRect(self, x: int, y: int, width: int, height: int, lineThickness: int = ...) -> None: ...
    @overload
    def drawRect(self, x: float, y: float, width: float, height: float, lineThickness: float = ...) -> None: ...
    @overload
    def drawRect(self, rectangle: RectangleInt, lineThickness: int = ...) -> None: ...
    @overload
    def drawRect(self, rectangle: RectangleFloat, lineThickness: float = ...) -> None: ...
    @overload
    def drawRoundedRectangle(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> None: ...
    @overload
    def drawRoundedRectangle(self, arg0: RectangleFloat, arg1: float, arg2: float) -> None: ...
    @overload
    def drawSingleLineText(self, text: str, startX: int, baselineY: int, justification: Justification = ...) -> None: ...
    @overload
    def drawSingleLineText(self, text: str, startX: int, baselineY: int, justification: Justification.Flags = ...) -> None: ...
    @overload
    def drawSingleLineText(self, text: str, startX: int, baselineY: int, justification: int = ...) -> None: ...
    @overload
    def drawText(self, text: str, x: int, y: int, width: int, height: int, justificationType: Justification, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, x: int, y: int, width: int, height: int, justificationType: Justification.Flags, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, x: int, y: int, width: int, height: int, justificationType: int, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, area: RectangleInt, justificationType: Justification, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, area: RectangleInt, justificationType: Justification.Flags, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, area: RectangleInt, justificationType: int, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, area: RectangleFloat, justificationType: Justification, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, area: RectangleFloat, justificationType: Justification.Flags, useEllipsesIfTooBig: bool = ...) -> None: ...
    @overload
    def drawText(self, text: str, area: RectangleFloat, justificationType: int, useEllipsesIfTooBig: bool = ...) -> None: ...
    def drawVerticalLine(self, arg0: int, arg1: float, arg2: float) -> None: ...
    def endTransparencyLayer(self) -> None: ...
    def excludeClipRegion(self, arg0: RectangleInt) -> None: ...
    @overload
    def fillAll(self) -> None: ...
    @overload
    def fillAll(self, arg0: Colour) -> None: ...
    def fillCheckerBoard(self, arg0: RectangleFloat, arg1: float, arg2: float, arg3: Colour, arg4: Colour) -> None: ...
    @overload
    def fillEllipse(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def fillEllipse(self, arg0: RectangleFloat) -> None: ...
    @overload
    def fillPath(self, arg0: Path) -> None: ...
    @overload
    def fillPath(self, arg0: Path, arg1: AffineTransform) -> None: ...
    @overload
    def fillRect(self, arg0: RectangleInt) -> None: ...
    @overload
    def fillRect(self, arg0: RectangleFloat) -> None: ...
    @overload
    def fillRect(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def fillRect(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def fillRectList(self, arg0: RectangleListFloat) -> None: ...
    @overload
    def fillRectList(self, arg0: RectangleListInt) -> None: ...
    @overload
    def fillRoundedRectangle(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float) -> None: ...
    @overload
    def fillRoundedRectangle(self, arg0: RectangleFloat, arg1: float) -> None: ...
    def getClipBounds(self) -> RectangleInt: ...
    def getCurrentFont(self) -> Font: ...
    def isClipEmpty(self) -> bool: ...
    def isVectorDevice(self) -> bool: ...
    @overload
    def reduceClipRegion(self, arg0: int, arg1: int, arg2: int, arg3: int) -> bool: ...
    @overload
    def reduceClipRegion(self, arg0: RectangleInt) -> bool: ...
    @overload
    def reduceClipRegion(self, arg0: RectangleListInt) -> bool: ...
    @overload
    def reduceClipRegion(self, path: Path, transform: AffineTransform = ...) -> bool: ...
    @overload
    def reduceClipRegion(self, arg0: Image, arg1: AffineTransform) -> bool: ...
    def resetToDefaultState(self) -> None: ...
    def restoreState(self) -> None: ...
    def saveState(self) -> None: ...
    def setColour(self, arg0: Colour) -> None: ...
    def setFillType(self, arg0: FillType) -> None: ...
    @overload
    def setFont(self, arg0: Font) -> None: ...
    @overload
    def setFont(self, arg0: float) -> None: ...
    def setGradientFill(self, arg0: ColourGradient) -> None: ...
    def setImageResamplingQuality(self, arg0: Graphics.ResamplingQuality) -> None: ...
    def setOpacity(self, arg0: float) -> None: ...
    @overload
    def setOrigin(self, arg0: PointInt) -> None: ...
    @overload
    def setOrigin(self, arg0: int, arg1: int) -> None: ...
    def setTiledImageFill(self, arg0: Image, arg1: int, arg2: int, arg3: float) -> None: ...
    def strokePath(self, path: Path, strokeType: PathStrokeType, transform: AffineTransform = ...) -> None: ...

class HighResolutionTimer:
    def __init__(self) -> None: ...
    def getTimerInterval(self) -> int: ...
    def hiResTimerCallback(self) -> None: ...
    def isTimerRunning(self) -> bool: ...
    def startTimer(self, arg0: int) -> None: ...
    def stopTimer(self) -> None: ...

class HyperlinkButton(Button):
    textColourId: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: URL) -> None: ...
    def changeWidthToFitText(self) -> None: ...
    def getJustificationType(self) -> Justification: ...
    def getURL(self) -> URL: ...
    def setFont(self, arg0: Font, arg1: bool, arg2: Justification) -> None: ...
    @overload
    def setJustificationType(self, arg0: Justification) -> None: ...
    @overload
    def setJustificationType(self, arg0: Justification.Flags) -> None: ...
    @overload
    def setJustificationType(self, arg0: int) -> None: ...
    def setURL(self, arg0: URL) -> None: ...

class IIRFilterAudioSource(AudioSource):
    def __init__(self, source: AudioSource, deleteSourceWhenDeleted: bool = ...) -> None: ...
    def makeInactive(self) -> None: ...

class Identifier:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: Identifier) -> None: ...
    def isNull(self) -> bool: ...
    def isValid(self) -> bool: ...
    @classmethod
    def isValidIdentifier(cls, arg0: str) -> bool: ...
    def toString(self) -> str: ...
    def __eq__(self, arg0: Identifier) -> bool: ...
    def __ge__(self, arg0: Identifier) -> bool: ...
    def __gt__(self, arg0: Identifier) -> bool: ...
    def __le__(self, arg0: Identifier) -> bool: ...
    def __lt__(self, arg0: Identifier) -> bool: ...
    def __ne__(self, arg0: Identifier) -> bool: ...

class Image:
    class BitmapData:
        class ReadWriteMode:
            __members__: ClassVar[dict] = ...  # read-only
            __entries: ClassVar[dict] = ...
            readOnly: ClassVar[Image.BitmapData.ReadWriteMode] = ...
            readWrite: ClassVar[Image.BitmapData.ReadWriteMode] = ...
            writeOnly: ClassVar[Image.BitmapData.ReadWriteMode] = ...
            def __init__(self, value: int) -> None: ...
            def __eq__(self, other: object) -> bool: ...
            def __hash__(self) -> int: ...
            def __index__(self) -> int: ...
            def __int__(self) -> int: ...
            def __ne__(self, other: object) -> bool: ...
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        readOnly: ClassVar[Image.BitmapData.ReadWriteMode] = ...
        readWrite: ClassVar[Image.BitmapData.ReadWriteMode] = ...
        writeOnly: ClassVar[Image.BitmapData.ReadWriteMode] = ...
        data: memoryview
        height: int
        lineStride: int
        pixelFormat: Image.PixelFormat
        pixelStride: int
        size: int
        width: int
        @overload
        def __init__(self, arg0: Image, arg1: int, arg2: int, arg3: int, arg4: int, arg5: Image.BitmapData.ReadWriteMode) -> None: ...
        @overload
        def __init__(self, arg0: Image, arg1: int, arg2: int, arg3: int, arg4: int) -> None: ...
        @overload
        def __init__(self, arg0: Image, arg1: Image.BitmapData.ReadWriteMode) -> None: ...
        def getBounds(self) -> RectangleInt: ...
        def getLinePointer(self, arg0: int) -> memoryview: ...
        def getPixelColour(self, arg0: int, arg1: int) -> Colour: ...
        def getPixelPointer(self, arg0: int, arg1: int) -> memoryview: ...
        def setPixelColour(self, arg0: int, arg1: int, arg2: Colour) -> None: ...
        def __buffer__(self, *args, **kwargs): ...
        def __release_buffer__(self, *args, **kwargs): ...

    class PixelFormat:
        __members__: ClassVar[dict] = ...  # read-only
        ARGB: ClassVar[Image.PixelFormat] = ...
        RGB: ClassVar[Image.PixelFormat] = ...
        SingleChannel: ClassVar[Image.PixelFormat] = ...
        UnknownFormat: ClassVar[Image.PixelFormat] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    ARGB: ClassVar[Image.PixelFormat] = ...
    RGB: ClassVar[Image.PixelFormat] = ...
    SingleChannel: ClassVar[Image.PixelFormat] = ...
    UnknownFormat: ClassVar[Image.PixelFormat] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Image.PixelFormat, arg1: int, arg2: int, arg3: bool) -> None: ...
    @overload
    def __init__(self, arg0: Image.PixelFormat, arg1: int, arg2: int, arg3: bool, arg4) -> None: ...
    @overload
    def __init__(self, arg0: Image) -> None: ...
    def clear(self, arg0: RectangleInt, arg1: Colour) -> None: ...
    def convertedToFormat(self, arg0: Image.PixelFormat) -> Image: ...
    def createCopy(self) -> Image: ...
    def createSolidAreaMask(self, arg0: RectangleListInt, arg1: float) -> None: ...
    def desaturate(self) -> None: ...
    def duplicateIfShared(self) -> None: ...
    def getBounds(self) -> RectangleInt: ...
    def getClippedImage(self, arg0: RectangleInt) -> Image: ...
    def getFormat(self) -> Image.PixelFormat: ...
    def getHeight(self) -> int: ...
    def getPixelAt(self, arg0: int, arg1: int) -> Colour: ...
    def getPixelData(self, *args, **kwargs): ...
    def getProperties(self) -> NamedValueSet: ...
    def getReferenceCount(self) -> int: ...
    def getWidth(self) -> int: ...
    def hasAlphaChannel(self) -> bool: ...
    def isARGB(self) -> bool: ...
    def isNull(self) -> bool: ...
    def isRGB(self) -> bool: ...
    def isSingleChannel(self) -> bool: ...
    def isValid(self) -> bool: ...
    def moveImageSection(self, arg0: int, arg1: int, arg2: int, arg3: int, arg4: int, arg5: int) -> None: ...
    def multiplyAllAlphas(self, arg0: float) -> None: ...
    def multiplyAlphaAt(self, arg0: int, arg1: int, arg2: float) -> None: ...
    def rescaled(self, arg0: int, arg1: int, arg2) -> Image: ...
    def setPixelAt(self, arg0: int, arg1: int, arg2: Colour) -> None: ...
    def __eq__(self, arg0: Image) -> bool: ...
    def __ne__(self, arg0: Image) -> bool: ...

class ImageButton(Button):
    def __init__(self, name: str = ...) -> None: ...
    def getDownImage(self) -> Image: ...
    def getNormalImage(self) -> Image: ...
    def getOverImage(self) -> Image: ...
    def setImages(self, arg0: bool, arg1: bool, arg2: bool, arg3: Image, arg4: float, arg5: Colour, arg6: Image, arg7: float, arg8: Colour, arg9: Image, arg10: float, arg11: Colour, arg12: float) -> None: ...

class ImageCache:
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def addImageToCache(cls, arg0: Image, arg1: int) -> None: ...
    @classmethod
    def getFromFile(cls, arg0: File) -> Image: ...
    @classmethod
    def getFromHashCode(cls, arg0: int) -> Image: ...
    @classmethod
    def getFromMemory(cls, arg0: buffer) -> Image: ...
    @classmethod
    def releaseUnusedImages(cls) -> None: ...
    @classmethod
    def setCacheTimeout(cls, arg0: int) -> None: ...

class ImageConvolutionKernel:
    def __init__(self, size: int) -> None: ...
    def applyToImage(self, arg0: Image, arg1: Image, arg2: RectangleInt) -> None: ...
    def clear(self) -> None: ...
    def createGaussianBlur(self, arg0: float) -> None: ...
    def getKernelSize(self) -> int: ...
    def getKernelValue(self, arg0: int, arg1: int) -> float: ...
    def rescaleAllValues(self, arg0: float) -> None: ...
    def setKernelValue(self, arg0: int, arg1: int, arg2: float) -> None: ...
    def setOverallSum(self, arg0: float) -> None: ...

class ImageFileFormat:
    def __init__(self) -> None: ...
    def canUnderstand(self, arg0: InputStream) -> bool: ...
    def decodeImage(self, arg0: InputStream) -> Image: ...
    @classmethod
    def findImageFormatForFileExtension(cls, arg0: File) -> ImageFileFormat: ...
    @classmethod
    def findImageFormatForStream(cls, arg0: InputStream) -> ImageFileFormat: ...
    def getFormatName(self) -> str: ...
    @overload
    @classmethod
    def loadFrom(cls, arg0: InputStream) -> Image: ...
    @overload
    @classmethod
    def loadFrom(cls, arg0: File) -> Image: ...
    @overload
    @classmethod
    def loadFrom(cls, arg0: buffer) -> Image: ...
    def usesFileExtension(self, arg0: File) -> bool: ...
    def writeImageToStream(self, arg0: Image, arg1: OutputStream) -> bool: ...

class ImagePixelData:
    userData: NamedValueSet
    def __init__(self, *args, **kwargs) -> None: ...
    def getSharedCount(self) -> int: ...
    def sendDataChangeMessage(self) -> None: ...
    @property
    def height(self) -> int: ...
    @property
    def pixelFormat(self) -> Image.PixelFormat: ...
    @property
    def width(self) -> int: ...

class ImageType:
    def __init__(self) -> None: ...
    def convert(self, arg0: Image) -> Image: ...
    def create(self, arg0: Image.PixelFormat, arg1: int, arg2: int, arg3: bool) -> ImagePixelData: ...
    def getTypeID(self) -> int: ...

class InputSource:
    def __init__(self) -> None: ...
    def createInputStream(self) -> InputStream: ...
    def createInputStreamFor(self, arg0: str) -> InputStream: ...
    def hashCode(self) -> int: ...

class InputStream:
    def __init__(self) -> None: ...
    def getNumBytesRemaining(self) -> int: ...
    def getPosition(self) -> int: ...
    def getTotalLength(self) -> int: ...
    def isExhausted(self) -> bool: ...
    def read(self, arg0: buffer) -> int: ...
    def readBool(self) -> bool: ...
    def readByte(self) -> str: ...
    def readCompressedInt(self) -> int: ...
    def readDouble(self) -> float: ...
    def readDoubleBigEndian(self) -> float: ...
    def readEntireStreamAsString(self) -> str: ...
    def readFloat(self) -> float: ...
    def readFloatBigEndian(self) -> float: ...
    def readInt(self) -> int: ...
    def readInt64(self) -> int: ...
    def readInt64BigEndian(self) -> int: ...
    def readIntBigEndian(self) -> int: ...
    def readIntoMemoryBlock(self, destBlock: MemoryBlock, maxNumBytesToRead: int = ...) -> int: ...
    def readNextLine(self) -> str: ...
    def readShort(self) -> int: ...
    def readShortBigEndian(self) -> int: ...
    def readString(self) -> str: ...
    def setPosition(self, arg0: int) -> bool: ...
    def skipNextBytes(self, arg0: int) -> None: ...

class IntArrayView:
    def __init__(self, *args, **kwargs) -> None: ...
    def __buffer__(self, *args, **kwargs): ...
    def __getitem__(self, arg0: int) -> int: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __release_buffer__(self, *args, **kwargs): ...
    def __setitem__(self, arg0: int, arg1: int) -> None: ...

class InterProcessLock:
    def __init__(self, arg0: str) -> None: ...
    def enter(self, timeOutMillisecs: int = ...) -> bool: ...
    def exit(self) -> None: ...

class JPEGImageFormat(ImageFileFormat):
    def __init__(self) -> None: ...

class JUCEApplication:
    def __init__(self) -> None: ...
    def anotherInstanceStarted(self, arg0: str) -> None: ...
    def getApplicationName(self) -> str: ...
    def getApplicationReturnValue(self) -> int: ...
    def getApplicationVersion(self) -> str: ...
    @classmethod
    def getCommandLineParameterArray(cls) -> StringArray: ...
    @classmethod
    def getCommandLineParameters(cls) -> str: ...
    @classmethod
    def getInstance(cls) -> JUCEApplication: ...
    def initialise(self, commandLineParameters: str) -> None: ...
    def isInitialising(self) -> bool: ...
    @classmethod
    def isStandaloneApp(cls) -> bool: ...
    def memoryWarningReceived(self) -> None: ...
    def moreThanOneInstanceAllowed(self) -> bool: ...
    @classmethod
    def quit(cls) -> None: ...
    def resumed(self) -> None: ...
    def setApplicationReturnValue(self, arg0: int) -> None: ...
    def shutdown(self) -> None: ...
    def suspended(self) -> None: ...
    def systemRequestedQuit(self) -> None: ...
    def unhandledException(self, arg0, arg1: str, arg2: int) -> None: ...

class Justification:
    class Flags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        bottom: ClassVar[Justification.Flags] = ...
        bottomLeft: ClassVar[Justification.Flags] = ...
        bottomRight: ClassVar[Justification.Flags] = ...
        centred: ClassVar[Justification.Flags] = ...
        centredBottom: ClassVar[Justification.Flags] = ...
        centredLeft: ClassVar[Justification.Flags] = ...
        centredRight: ClassVar[Justification.Flags] = ...
        centredTop: ClassVar[Justification.Flags] = ...
        horizontallyCentred: ClassVar[Justification.Flags] = ...
        horizontallyJustified: ClassVar[Justification.Flags] = ...
        left: ClassVar[Justification.Flags] = ...
        right: ClassVar[Justification.Flags] = ...
        top: ClassVar[Justification.Flags] = ...
        topLeft: ClassVar[Justification.Flags] = ...
        topRight: ClassVar[Justification.Flags] = ...
        verticallyCentred: ClassVar[Justification.Flags] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: Justification.Flags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: Justification.Flags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: Justification.Flags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: Justification.Flags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: Justification.Flags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: Justification.Flags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: Justification.Flags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: Justification.Flags) -> int: ...
        def __xor__(self, arg0: Justification.Flags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    bottom: ClassVar[Justification.Flags] = ...
    bottomLeft: ClassVar[Justification.Flags] = ...
    bottomRight: ClassVar[Justification.Flags] = ...
    centred: ClassVar[Justification.Flags] = ...
    centredBottom: ClassVar[Justification.Flags] = ...
    centredLeft: ClassVar[Justification.Flags] = ...
    centredRight: ClassVar[Justification.Flags] = ...
    centredTop: ClassVar[Justification.Flags] = ...
    horizontallyCentred: ClassVar[Justification.Flags] = ...
    horizontallyJustified: ClassVar[Justification.Flags] = ...
    left: ClassVar[Justification.Flags] = ...
    right: ClassVar[Justification.Flags] = ...
    top: ClassVar[Justification.Flags] = ...
    topLeft: ClassVar[Justification.Flags] = ...
    topRight: ClassVar[Justification.Flags] = ...
    verticallyCentred: ClassVar[Justification.Flags] = ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: Justification.Flags) -> None: ...
    @overload
    def __init__(self, arg0: Justification) -> None: ...
    def appliedToRectangle(self, *args, **kwargs): ...
    def getFlags(self) -> int: ...
    def getOnlyHorizontalFlags(self) -> int: ...
    def getOnlyVerticalFlags(self) -> int: ...
    @overload
    def testFlags(self, arg0: int) -> bool: ...
    @overload
    def testFlags(self, arg0: Justification.Flags) -> bool: ...
    @overload
    def __eq__(self, arg0: Justification) -> bool: ...
    @overload
    def __eq__(self, arg0: Justification.Flags) -> bool: ...
    @overload
    def __eq__(self, arg0: int) -> bool: ...
    @overload
    def __ne__(self, arg0: Justification) -> bool: ...
    @overload
    def __ne__(self, arg0: Justification.Flags) -> bool: ...
    @overload
    def __ne__(self, arg0: int) -> bool: ...

class KeyListener:
    def __init__(self) -> None: ...
    def keyPressed(self, arg0: KeyPress, arg1) -> bool: ...
    def keyStateChanged(self, arg0: bool, arg1) -> bool: ...

class KeyPress:
    F10Key: ClassVar[int] = ...
    F11Key: ClassVar[int] = ...
    F12Key: ClassVar[int] = ...
    F13Key: ClassVar[int] = ...
    F14Key: ClassVar[int] = ...
    F15Key: ClassVar[int] = ...
    F16Key: ClassVar[int] = ...
    F17Key: ClassVar[int] = ...
    F18Key: ClassVar[int] = ...
    F19Key: ClassVar[int] = ...
    F1Key: ClassVar[int] = ...
    F20Key: ClassVar[int] = ...
    F21Key: ClassVar[int] = ...
    F22Key: ClassVar[int] = ...
    F23Key: ClassVar[int] = ...
    F24Key: ClassVar[int] = ...
    F25Key: ClassVar[int] = ...
    F26Key: ClassVar[int] = ...
    F27Key: ClassVar[int] = ...
    F28Key: ClassVar[int] = ...
    F29Key: ClassVar[int] = ...
    F2Key: ClassVar[int] = ...
    F30Key: ClassVar[int] = ...
    F31Key: ClassVar[int] = ...
    F32Key: ClassVar[int] = ...
    F33Key: ClassVar[int] = ...
    F34Key: ClassVar[int] = ...
    F35Key: ClassVar[int] = ...
    F3Key: ClassVar[int] = ...
    F4Key: ClassVar[int] = ...
    F5Key: ClassVar[int] = ...
    F6Key: ClassVar[int] = ...
    F7Key: ClassVar[int] = ...
    F8Key: ClassVar[int] = ...
    F9Key: ClassVar[int] = ...
    backspaceKey: ClassVar[int] = ...
    deleteKey: ClassVar[int] = ...
    downKey: ClassVar[int] = ...
    endKey: ClassVar[int] = ...
    escapeKey: ClassVar[int] = ...
    fastForwardKey: ClassVar[int] = ...
    homeKey: ClassVar[int] = ...
    insertKey: ClassVar[int] = ...
    leftKey: ClassVar[int] = ...
    numberPad0: ClassVar[int] = ...
    numberPad1: ClassVar[int] = ...
    numberPad2: ClassVar[int] = ...
    numberPad3: ClassVar[int] = ...
    numberPad4: ClassVar[int] = ...
    numberPad5: ClassVar[int] = ...
    numberPad6: ClassVar[int] = ...
    numberPad7: ClassVar[int] = ...
    numberPad8: ClassVar[int] = ...
    numberPad9: ClassVar[int] = ...
    numberPadAdd: ClassVar[int] = ...
    numberPadDecimalPoint: ClassVar[int] = ...
    numberPadDelete: ClassVar[int] = ...
    numberPadDivide: ClassVar[int] = ...
    numberPadEquals: ClassVar[int] = ...
    numberPadMultiply: ClassVar[int] = ...
    numberPadSeparator: ClassVar[int] = ...
    numberPadSubtract: ClassVar[int] = ...
    pageDownKey: ClassVar[int] = ...
    pageUpKey: ClassVar[int] = ...
    playKey: ClassVar[int] = ...
    returnKey: ClassVar[int] = ...
    rewindKey: ClassVar[int] = ...
    rightKey: ClassVar[int] = ...
    spaceKey: ClassVar[int] = ...
    stopKey: ClassVar[int] = ...
    tabKey: ClassVar[int] = ...
    upKey: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, keyCode: int) -> None: ...
    @overload
    def __init__(self, keyCode: str) -> None: ...
    @overload
    def __init__(self, keyCode: int, modifiers: ModifierKeys, textCharacter: int) -> None: ...
    @overload
    def __init__(self, keyCode: int, modifiers: ModifierKeys, textCharacter: str) -> None: ...
    @overload
    def __init__(self, keyCode: int, modifiers: int, textCharacter: int) -> None: ...
    @overload
    def __init__(self, keyCode: int, modifiers: int, textCharacter: str) -> None: ...
    @overload
    def __init__(self, keyCode: str, modifiers: ModifierKeys, textCharacter: int) -> None: ...
    @overload
    def __init__(self, keyCode: str, modifiers: ModifierKeys, textCharacter: str) -> None: ...
    @overload
    def __init__(self, keyCode: str, modifiers: int, textCharacter: int) -> None: ...
    @overload
    def __init__(self, keyCode: str, modifiers: int, textCharacter: str) -> None: ...
    @overload
    def __init__(self, arg0: KeyPress) -> None: ...
    @classmethod
    def createFromDescription(cls, arg0: str) -> KeyPress: ...
    def getKeyCode(self) -> int: ...
    def getModifiers(self) -> ModifierKeys: ...
    def getTextCharacter(self) -> int: ...
    def getTextDescription(self) -> str: ...
    def getTextDescriptionWithIcons(self) -> str: ...
    def isCurrentlyDown(self) -> bool: ...
    def isKeyCode(self, arg0: int) -> bool: ...
    @classmethod
    def isKeyCurrentlyDown(cls, arg0: int) -> bool: ...
    def isValid(self) -> bool: ...
    @overload
    def __eq__(self, arg0: KeyPress) -> bool: ...
    @overload
    def __eq__(self, arg0: int) -> bool: ...
    @overload
    def __ne__(self, arg0: KeyPress) -> bool: ...
    @overload
    def __ne__(self, arg0: int) -> bool: ...

class Label(Component):
    class Listener:
        def __init__(self) -> None: ...
        def editorHidden(self, arg0: Label, arg1) -> None: ...
        def editorShown(self, arg0: Label, arg1) -> None: ...
        def labelTextChanged(self, arg0: Label) -> None: ...
    backgroundColourId: ClassVar[int] = ...
    backgroundWhenEditingColourId: ClassVar[int] = ...
    outlineColourId: ClassVar[int] = ...
    outlineWhenEditingColourId: ClassVar[int] = ...
    textColourId: ClassVar[int] = ...
    textWhenEditingColourId: ClassVar[int] = ...
    onEditorHide: Callable[[], None]
    onEditorShow: Callable[[], None]
    onTextChange: Callable[[], None]
    def __init__(self, componentName: str = ..., labelText: str = ...) -> None: ...
    def addListener(self, arg0: Label.Listener) -> None: ...
    def attachToComponent(self, arg0: Component, arg1: bool) -> None: ...
    def doesLossOfFocusDiscardChanges(self) -> bool: ...
    def getAttachedComponent(self) -> Component: ...
    def getBorderSize(self) -> BorderSizeInt: ...
    def getFont(self) -> Font: ...
    def getJustificationType(self) -> Justification: ...
    def getMinimumHorizontalScale(self) -> float: ...
    def getText(self, returnActiveEditorContents: bool = ...) -> str: ...
    def getTextValue(self) -> Value: ...
    def hideEditor(self, arg0: bool) -> None: ...
    def isAttachedOnLeft(self) -> bool: ...
    def isBeingEdited(self) -> bool: ...
    def isEditable(self) -> bool: ...
    def isEditableOnDoubleClick(self) -> bool: ...
    def isEditableOnSingleClick(self) -> bool: ...
    def removeListener(self, arg0: Label.Listener) -> None: ...
    def setBorderSize(self, arg0: BorderSizeInt) -> None: ...
    def setEditable(self, editOnSingleClick: bool, editOnDoubleClick: bool = ..., lossOfFocusDiscardsChanges: bool = ...) -> None: ...
    def setFont(self, arg0: Font) -> None: ...
    @overload
    def setJustificationType(self, arg0: Justification) -> None: ...
    @overload
    def setJustificationType(self, arg0: Justification.Flags) -> None: ...
    @overload
    def setJustificationType(self, arg0: int) -> None: ...
    def setMinimumHorizontalScale(self, arg0: float) -> None: ...
    def setText(self, arg0: str, arg1: NotificationType) -> None: ...
    def showEditor(self) -> None: ...

class LineFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: PointFloat, arg1: PointFloat) -> None: ...
    @overload
    def __init__(self, arg0: LineFloat) -> None: ...
    def applyTransform(self, arg0: AffineTransform) -> None: ...
    def findNearestPointTo(self, arg0: PointFloat) -> PointFloat: ...
    def findNearestProportionalPositionTo(self, arg0: PointFloat) -> float: ...
    def getAngle(self) -> float: ...
    def getDistanceFromPoint(self, arg0: PointFloat, arg1: PointFloat) -> float: ...
    def getEnd(self) -> PointFloat: ...
    def getEndX(self) -> float: ...
    def getEndY(self) -> float: ...
    def getIntersection(self, arg0: LineFloat) -> PointFloat: ...
    def getLength(self) -> float: ...
    def getLengthSquared(self) -> float: ...
    @overload
    def getPointAlongLine(self, arg0: float) -> PointFloat: ...
    @overload
    def getPointAlongLine(self, arg0: float, arg1: float) -> PointFloat: ...
    def getPointAlongLineProportionally(self, arg0: float) -> PointFloat: ...
    def getStart(self) -> PointFloat: ...
    def getStartX(self) -> float: ...
    def getStartY(self) -> float: ...
    @overload
    def intersects(self, arg0: LineFloat, arg1: PointFloat) -> bool: ...
    @overload
    def intersects(self, arg0: LineFloat) -> bool: ...
    def isHorizontal(self) -> bool: ...
    def isPointAbove(self, arg0: PointFloat) -> bool: ...
    def isVertical(self) -> bool: ...
    def reversed(self) -> LineFloat: ...
    @overload
    def setEnd(self, arg0: float, arg1: float) -> None: ...
    @overload
    def setEnd(self, arg0: PointFloat) -> None: ...
    @overload
    def setStart(self, arg0: float, arg1: float) -> None: ...
    @overload
    def setStart(self, arg0: PointFloat) -> None: ...
    def toFloat(self) -> LineFloat: ...
    def withLengthenedEnd(self, arg0: float) -> LineFloat: ...
    def withLengthenedStart(self, arg0: float) -> LineFloat: ...
    def withShortenedEnd(self, arg0: float) -> LineFloat: ...
    def withShortenedStart(self, arg0: float) -> LineFloat: ...
    def __eq__(self, arg0: LineFloat) -> bool: ...
    def __ne__(self, arg0: LineFloat) -> bool: ...

class LineInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def __init__(self, arg0: PointInt, arg1: PointInt) -> None: ...
    @overload
    def __init__(self, arg0: LineInt) -> None: ...
    def applyTransform(self, arg0: AffineTransform) -> None: ...
    def findNearestPointTo(self, arg0: PointInt) -> PointInt: ...
    def findNearestProportionalPositionTo(self, arg0: PointInt) -> int: ...
    def getAngle(self) -> float: ...
    def getDistanceFromPoint(self, arg0: PointInt, arg1: PointInt) -> int: ...
    def getEnd(self) -> PointInt: ...
    def getEndX(self) -> int: ...
    def getEndY(self) -> int: ...
    def getIntersection(self, arg0: LineInt) -> PointInt: ...
    def getLength(self) -> int: ...
    def getLengthSquared(self) -> int: ...
    @overload
    def getPointAlongLine(self, arg0: int) -> PointInt: ...
    @overload
    def getPointAlongLine(self, arg0: int, arg1: int) -> PointInt: ...
    def getPointAlongLineProportionally(self, arg0: float) -> PointInt: ...
    def getStart(self) -> PointInt: ...
    def getStartX(self) -> int: ...
    def getStartY(self) -> int: ...
    @overload
    def intersects(self, arg0: LineInt, arg1: PointInt) -> bool: ...
    @overload
    def intersects(self, arg0: LineInt) -> bool: ...
    def isHorizontal(self) -> bool: ...
    def isPointAbove(self, arg0: PointInt) -> bool: ...
    def isVertical(self) -> bool: ...
    def reversed(self) -> LineInt: ...
    @overload
    def setEnd(self, arg0: int, arg1: int) -> None: ...
    @overload
    def setEnd(self, arg0: PointInt) -> None: ...
    @overload
    def setStart(self, arg0: int, arg1: int) -> None: ...
    @overload
    def setStart(self, arg0: PointInt) -> None: ...
    def toFloat(self, *args, **kwargs): ...
    def withLengthenedEnd(self, arg0: int) -> LineInt: ...
    def withLengthenedStart(self, arg0: int) -> LineInt: ...
    def withShortenedEnd(self, arg0: int) -> LineInt: ...
    def withShortenedStart(self, arg0: int) -> LineInt: ...
    def __eq__(self, arg0: LineInt) -> bool: ...
    def __ne__(self, arg0: LineInt) -> bool: ...

class ListBox(Component):
    backgroundColourId: ClassVar[int] = ...
    outlineColourId: ClassVar[int] = ...
    textColourId: ClassVar[int] = ...
    def __init__(self, componentName: str = ..., model: ListBoxModel = ...) -> None: ...
    def deselectAllRows(self) -> None: ...
    def deselectRow(self, arg0: int) -> None: ...
    def flipRowSelection(self, arg0: int) -> None: ...
    def getComponentForRowNumber(self, arg0: int) -> Component: ...
    def getInsertionIndexForPosition(self, arg0: int, arg1: int) -> int: ...
    def getLastRowSelected(self) -> int: ...
    def getListBoxModel(self) -> ListBoxModel: ...
    def getNumRowsOnScreen(self) -> int: ...
    def getNumSelectedRows(self) -> int: ...
    def getOutlineThickness(self) -> int: ...
    def getRowContainingPosition(self, arg0: int, arg1: int) -> int: ...
    def getRowHeight(self) -> int: ...
    def getRowNumberOfComponent(self, arg0: Component) -> int: ...
    def getRowPosition(self, arg0: int, arg1: bool) -> RectangleInt: ...
    def getRowSelectedOnMouseDown(self) -> bool: ...
    def getSelectedRow(self, index: int = ...) -> int: ...
    def getVerticalPosition(self) -> float: ...
    def getVisibleContentWidth(self) -> int: ...
    def getVisibleRowWidth(self) -> int: ...
    def isRowSelected(self, arg0: int) -> bool: ...
    def repaintRow(self, arg0: int) -> None: ...
    def scrollToEnsureRowIsOnscreen(self, arg0: int) -> None: ...
    def selectRangeOfRows(self, firstRow: int, lastRow: int, dontScrollToShowThisRange: bool = ...) -> None: ...
    def selectRow(self, rowNumber: int, dontScrollToShowThisRow: bool = ..., deselectOthersFirst: bool = ...) -> None: ...
    def selectRowsBasedOnModifierKeys(self, arg0: int, arg1: ModifierKeys, arg2: bool) -> None: ...
    def setClickingTogglesRowSelection(self, arg0: bool) -> None: ...
    def setMinimumContentWidth(self, arg0: int) -> None: ...
    def setModel(self, arg0: ListBoxModel) -> None: ...
    def setMouseMoveSelectsRows(self, arg0: bool) -> None: ...
    def setMultipleSelectionEnabled(self, arg0: bool) -> None: ...
    def setOutlineThickness(self, arg0: int) -> None: ...
    def setRowHeight(self, arg0: int) -> None: ...
    def setRowSelectedOnMouseDown(self, arg0: bool) -> None: ...
    def setVerticalPosition(self, arg0: float) -> None: ...
    def updateContent(self) -> None: ...

class ListBoxModel:
    def __init__(self) -> None: ...

class Listener:
    def __init__(self) -> None: ...
    def menuBarActivated(self, arg0: MenuBarModel, arg1: bool) -> None: ...
    def menuBarItemsChanged(self, arg0: MenuBarModel) -> None: ...
    def menuCommandInvoked(self, arg0: MenuBarModel, arg1) -> None: ...

class LockingAsyncUpdater:
    def __init__(self, arg0: Callable[[], None]) -> None: ...
    def cancelPendingUpdate(self) -> None: ...
    def handleUpdateNowIfNeeded(self) -> None: ...
    def isUpdatePending(self) -> bool: ...
    def triggerAsyncUpdate(self) -> None: ...

class LookAndFeel:
    def __init__(self, *args, **kwargs) -> None: ...
    def drawSpinningWaitAnimation(self, arg0: Graphics, arg1: Colour, arg2: int, arg3: int, arg4: int, arg5: int) -> None: ...
    def findColour(self, arg0: int) -> Colour: ...
    def getCrossShape(self, arg0: float) -> Path: ...
    @classmethod
    def getDefaultLookAndFeel(cls) -> LookAndFeel: ...
    def getMouseCursorFor(self, arg0) -> MouseCursor: ...
    def getTickShape(self, arg0: float) -> Path: ...
    def isColourSpecified(self, arg0: int) -> bool: ...
    def isUsingNativeAlertWindows(self) -> bool: ...
    def playAlertSound(self) -> None: ...
    def setColour(self, arg0: int, arg1: Colour) -> None: ...
    @classmethod
    def setDefaultLookAndFeel(cls, arg0: LookAndFeel) -> None: ...
    def setDefaultSansSerifTypefaceName(self, arg0: str) -> None: ...
    def setUsingNativeAlertWindows(self, arg0: bool) -> None: ...

class LookAndFeel_V1(LookAndFeel_V2):
    def __init__(self, *args, **kwargs) -> None: ...

class LookAndFeel_V2(LookAndFeel):
    def __init__(self, *args, **kwargs) -> None: ...

class LookAndFeel_V3(LookAndFeel_V2):
    def __init__(self, *args, **kwargs) -> None: ...

class LookAndFeel_V4(LookAndFeel_V3):
    class ColourScheme:
        defaultFill: ClassVar[int] = ...
        defaultText: ClassVar[int] = ...
        highlightedFill: ClassVar[int] = ...
        highlightedText: ClassVar[int] = ...
        menuBackground: ClassVar[int] = ...
        menuText: ClassVar[int] = ...
        numColours: ClassVar[int] = ...
        outline: ClassVar[int] = ...
        widgetBackground: ClassVar[int] = ...
        windowBackground: ClassVar[int] = ...
        @overload
        def __init__(self, *args) -> None: ...
        @overload
        def __init__(self, arg0: LookAndFeel_V4.ColourScheme) -> None: ...
        def getUIColour(self, arg0) -> Colour: ...
        def setUIColour(self, arg0, arg1: Colour) -> None: ...
        def __eq__(self, arg0: LookAndFeel_V4.ColourScheme) -> bool: ...
        def __ne__(self, arg0: LookAndFeel_V4.ColourScheme) -> bool: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: LookAndFeel_V4.ColourScheme) -> None: ...
    def getCurrentColourScheme(self) -> LookAndFeel_V4.ColourScheme: ...
    @classmethod
    def getDarkColourScheme(cls) -> LookAndFeel_V4.ColourScheme: ...
    @classmethod
    def getGreyColourScheme(cls) -> LookAndFeel_V4.ColourScheme: ...
    @classmethod
    def getLightColourScheme(cls) -> LookAndFeel_V4.ColourScheme: ...
    @classmethod
    def getMidnightColourScheme(cls) -> LookAndFeel_V4.ColourScheme: ...
    def setColourScheme(self, arg0: LookAndFeel_V4.ColourScheme) -> None: ...

class LowLevelGraphicsContext:
    def __init__(self) -> None: ...

class LowLevelGraphicsSoftwareRenderer(LowLevelGraphicsContext):
    @overload
    def __init__(self, imageToRenderOnto: Image) -> None: ...
    @overload
    def __init__(self, imageToRenderOnto: Image, origin: PointInt, initialClip: RectangleListInt) -> None: ...

class MathConstantsDouble:
    euler: ClassVar[float] = ...  # read-only
    halfPi: ClassVar[float] = ...  # read-only
    pi: ClassVar[float] = ...  # read-only
    sqrt2: ClassVar[float] = ...  # read-only
    twoPi: ClassVar[float] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class MathConstantsFloat:
    euler: ClassVar[float] = ...  # read-only
    halfPi: ClassVar[float] = ...  # read-only
    pi: ClassVar[float] = ...  # read-only
    sqrt2: ClassVar[float] = ...  # read-only
    twoPi: ClassVar[float] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class MemoryAudioSource(PositionableAudioSource):
    def __init__(self, audioBuffer: AudioBufferFloat, copyMemory: bool, shouldLoop: bool = ...) -> None: ...

class MemoryBlock:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, initialSize: int, initialiseToZero: bool = ...) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    @overload
    def __init__(self, arg0: MemoryBlock) -> None: ...
    def append(self, arg0: buffer) -> None: ...
    def copyFrom(self, arg0: buffer, arg1: int) -> None: ...
    def copyTo(self, arg0: buffer, arg1: int) -> None: ...
    def ensureSize(self, newSize: int, initialiseNewSpaceToZero: bool = ...) -> None: ...
    def fillWith(self, arg0: int) -> None: ...
    def fromBase64Encoding(self, arg0: str) -> bool: ...
    def getBitRange(self, arg0: int, arg1: int) -> int: ...
    @overload
    def getData(self) -> memoryview: ...
    @overload
    def getData(self) -> memoryview: ...
    def getSize(self) -> int: ...
    def insert(self, arg0: buffer, arg1: int) -> None: ...
    def isEmpty(self) -> bool: ...
    def loadFromHexString(self, arg0: str) -> None: ...
    def matches(self, arg0: buffer) -> bool: ...
    def removeSection(self, arg0: int, arg1: int) -> None: ...
    def replaceAll(self, arg0: buffer) -> None: ...
    def reset(self) -> None: ...
    def setBitRange(self, arg0: int, arg1: int, arg2: int) -> None: ...
    def setSize(self, newSize: int, initialiseNewSpaceToZero: bool = ...) -> None: ...
    def swapWith(self, arg0: MemoryBlock) -> None: ...
    def toBase64Encoding(self) -> str: ...
    def toString(self) -> str: ...
    def __eq__(self, arg0: MemoryBlock) -> bool: ...
    def __getitem__(self, arg0: int) -> str: ...
    def __iter__(self) -> typing.Iterator[str]: ...
    def __ne__(self, arg0: MemoryBlock) -> bool: ...
    @overload
    def __setitem__(self, arg0: int, arg1: str) -> None: ...
    @overload
    def __setitem__(self, arg0: int, arg1: int) -> None: ...

class MemoryInputStream(InputStream):
    def __init__(self, arg0: MemoryBlock, arg1: bool) -> None: ...
    def getData(self) -> memoryview: ...
    def getDataSize(self) -> int: ...

class MemoryMappedAudioFormatReader(AudioFormatReader):
    def __init__(self, file: File, details: AudioFormatReader, dataChunkStart: int, dataChunkLength: int, bytesPerFrame: int) -> None: ...
    def getFile(self) -> File: ...
    def getMappedSection(self, *args, **kwargs): ...
    def getNumBytesUsed(self) -> int: ...
    def mapEntireFile(self) -> bool: ...
    def mapSectionOfFile(self, arg0) -> bool: ...
    @overload
    def touchSample(self, arg0: int) -> None: ...
    @overload
    def touchSample(self, arg0: int) -> None: ...

class MemoryMappedFile:
    class AccessMode:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        readOnly: ClassVar[MemoryMappedFile.AccessMode] = ...
        readWrite: ClassVar[MemoryMappedFile.AccessMode] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    readOnly: ClassVar[MemoryMappedFile.AccessMode] = ...
    readWrite: ClassVar[MemoryMappedFile.AccessMode] = ...
    @overload
    def __init__(self, file, mode: MemoryMappedFile.AccessMode, exclusive: bool = ...) -> None: ...
    @overload
    def __init__(self, file, fileRange, mode: MemoryMappedFile.AccessMode, exclusive: bool = ...) -> None: ...
    def getData(self) -> memoryview: ...
    def getRange(self, *args, **kwargs): ...
    def getSize(self) -> int: ...

class MemoryOutputStream(OutputStream):
    @overload
    def __init__(self, initialSize: int = ...) -> None: ...
    @overload
    def __init__(self, memoryBlockToWriteTo: MemoryBlock, appendToExistingBlockContent: bool) -> None: ...
    def appendUTF8Char(self, arg0: int) -> bool: ...
    def flush(self) -> None: ...
    def getData(self) -> memoryview: ...
    def getDataSize(self) -> int: ...
    def getMemoryBlock(self) -> MemoryBlock: ...
    def preallocate(self, arg0: int) -> None: ...
    def reset(self) -> None: ...
    def toString(self) -> str: ...
    def toUTF8(self) -> str: ...

class MenuBarModel:
    def __init__(self) -> None: ...
    def addListener(self, arg0: Listener) -> None: ...
    def getMenuBarNames(self) -> StringArray: ...
    def getMenuForIndex(self, *args, **kwargs): ...
    def menuBarActivated(self, arg0: bool) -> None: ...
    def menuItemSelected(self, arg0: int, arg1: int) -> None: ...
    def menuItemsChanged(self) -> None: ...
    def removeListener(self, arg0: Listener) -> None: ...

class Message(MessageManager.MessageBase):
    def __init__(self) -> None: ...

class MessageListener:
    def __init__(self) -> None: ...
    def handleMessage(self, arg0: Message) -> None: ...
    def postMessage(self, message: object) -> None: ...

class MessageManager:
    class CallbackMessage(MessageManager.MessageBase):
        def __init__(self) -> None: ...
        def messageCallback(self) -> None: ...

    class Lock:
        def __init__(self) -> None: ...
        def abort(self) -> None: ...
        def enter(self) -> None: ...
        def exit(self) -> None: ...
        def tryEnter(self) -> bool: ...

    class MessageBase:
        def __init__(self) -> None: ...
        def messageCallback(self) -> None: ...
        def post(self) -> bool: ...
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def broadcastMessage(cls, arg0: str) -> None: ...
    @classmethod
    def callAsync(cls, arg0: Callable[[], None]) -> bool: ...
    def callFunctionOnMessageThread(self, arg0: function) -> object: ...
    def currentThreadHasLockedMessageManager(self) -> bool: ...
    @classmethod
    def deleteInstance(cls) -> None: ...
    def deliverBroadcastMessage(self, arg0: str) -> None: ...
    def deregisterBroadcastListener(self, arg0: ActionListener) -> None: ...
    @classmethod
    def existsAndIsCurrentThread(cls) -> bool: ...
    @classmethod
    def existsAndIsLockedByCurrentThread(cls) -> bool: ...
    def getCurrentMessageThread(self) -> Thread.ThreadID: ...
    @classmethod
    def getInstance(cls) -> MessageManager: ...
    @classmethod
    def getInstanceWithoutCreating(cls) -> MessageManager: ...
    def hasStopMessageBeenSent(self) -> bool: ...
    def isThisTheMessageThread(self) -> bool: ...
    def registerBroadcastListener(self, arg0: ActionListener) -> None: ...
    def runDispatchLoop(self) -> None: ...
    def runDispatchLoopUntil(self, arg0: int) -> bool: ...
    def setCurrentThreadAsMessageThread(self) -> None: ...
    def stopDispatchLoop(self) -> None: ...

class MessageManagerLock:
    @overload
    def __init__(self, threadToCheckForExitSignal: Thread = ...) -> None: ...
    @overload
    def __init__(self, arg0: ThreadPoolJob) -> None: ...
    def lockWasGained(self) -> bool: ...
    def __enter__(self) -> MessageManagerLock: ...
    def __exit__(self, arg0: Optional[type], arg1: Optional[object], arg2: Optional[object]) -> None: ...

class MixerAudioSource(AudioSource):
    def __init__(self) -> None: ...
    def addInputSource(self, arg0: AudioSource, arg1: bool) -> None: ...
    def removeAllInputs(self) -> None: ...
    def removeInputSource(self, arg0: AudioSource) -> None: ...

class ModalComponentManager:
    class Callback:
        def __init__(self) -> None: ...
        def modalStateFinished(self, arg0: int) -> None: ...
    def __init__(self, *args, **kwargs) -> None: ...
    def attachCallback(self, arg0, arg1: function) -> None: ...
    def bringModalComponentsToFront(self, topOneShouldGrabFocus: bool = ...) -> None: ...
    def cancelAllModalComponents(self) -> bool: ...
    @classmethod
    def deleteInstance(cls) -> None: ...
    @classmethod
    def getInstance(cls) -> ModalComponentManager: ...
    @classmethod
    def getInstanceWithoutCreating(cls) -> ModalComponentManager: ...
    def getModalComponent(self, *args, **kwargs): ...
    @overload
    def getNumModalComponents(self) -> int: ...
    @overload
    def getNumModalComponents(self) -> int: ...
    def isFrontModalComponent(self, arg0) -> bool: ...
    def isModal(self, arg0) -> bool: ...
    def runEventLoopForCurrentComponent(self) -> int: ...

class ModifierKeys:
    class Flags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        allKeyboardModifiers: ClassVar[ModifierKeys.Flags] = ...
        allMouseButtonModifiers: ClassVar[ModifierKeys.Flags] = ...
        altModifier: ClassVar[ModifierKeys.Flags] = ...
        commandModifier: ClassVar[ModifierKeys.Flags] = ...
        ctrlAltCommandModifiers: ClassVar[ModifierKeys.Flags] = ...
        ctrlModifier: ClassVar[ModifierKeys.Flags] = ...
        leftButtonModifier: ClassVar[ModifierKeys.Flags] = ...
        middleButtonModifier: ClassVar[ModifierKeys.Flags] = ...
        noModifiers: ClassVar[ModifierKeys.Flags] = ...
        popupMenuClickModifier: ClassVar[ModifierKeys.Flags] = ...
        rightButtonModifier: ClassVar[ModifierKeys.Flags] = ...
        shiftModifier: ClassVar[ModifierKeys.Flags] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: ModifierKeys.Flags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: ModifierKeys.Flags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: ModifierKeys.Flags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: ModifierKeys.Flags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: ModifierKeys.Flags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: ModifierKeys.Flags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: ModifierKeys.Flags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: ModifierKeys.Flags) -> int: ...
        def __xor__(self, arg0: ModifierKeys.Flags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    currentModifiers: ClassVar[ModifierKeys] = ...  # read-only
    allKeyboardModifiers: ClassVar[ModifierKeys.Flags] = ...
    allMouseButtonModifiers: ClassVar[ModifierKeys.Flags] = ...
    altModifier: ClassVar[ModifierKeys.Flags] = ...
    commandModifier: ClassVar[ModifierKeys.Flags] = ...
    ctrlAltCommandModifiers: ClassVar[ModifierKeys.Flags] = ...
    ctrlModifier: ClassVar[ModifierKeys.Flags] = ...
    leftButtonModifier: ClassVar[ModifierKeys.Flags] = ...
    middleButtonModifier: ClassVar[ModifierKeys.Flags] = ...
    noModifiers: ClassVar[ModifierKeys.Flags] = ...
    popupMenuClickModifier: ClassVar[ModifierKeys.Flags] = ...
    rightButtonModifier: ClassVar[ModifierKeys.Flags] = ...
    shiftModifier: ClassVar[ModifierKeys.Flags] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: ModifierKeys.Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModifierKeys) -> None: ...
    @classmethod
    def getCurrentModifiers(cls) -> ModifierKeys: ...
    @classmethod
    def getCurrentModifiersRealtime(cls) -> ModifierKeys: ...
    def getNumMouseButtonsDown(self) -> int: ...
    def getRawFlags(self) -> int: ...
    def isAltDown(self) -> bool: ...
    def isAnyModifierKeyDown(self) -> bool: ...
    def isAnyMouseButtonDown(self) -> bool: ...
    def isCommandDown(self) -> bool: ...
    def isCtrlDown(self) -> bool: ...
    def isLeftButtonDown(self) -> bool: ...
    def isMiddleButtonDown(self) -> bool: ...
    def isPopupMenu(self) -> bool: ...
    def isRightButtonDown(self) -> bool: ...
    def isShiftDown(self) -> bool: ...
    @overload
    def testFlags(self, arg0: int) -> bool: ...
    @overload
    def testFlags(self, arg0: ModifierKeys.Flags) -> bool: ...
    @overload
    def withFlags(self, arg0: int) -> ModifierKeys: ...
    @overload
    def withFlags(self, arg0: ModifierKeys.Flags) -> ModifierKeys: ...
    def withOnlyMouseButtons(self) -> ModifierKeys: ...
    @overload
    def withoutFlags(self, arg0: int) -> ModifierKeys: ...
    @overload
    def withoutFlags(self, arg0: ModifierKeys.Flags) -> ModifierKeys: ...
    def withoutMouseButtons(self) -> ModifierKeys: ...
    def __eq__(self, arg0: ModifierKeys) -> bool: ...
    def __ne__(self, arg0: ModifierKeys) -> bool: ...

class MouseCursor:
    class StandardCursorType:
        __members__: ClassVar[dict] = ...  # read-only
        BottomEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        BottomLeftCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        BottomRightCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        CopyingCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        CrosshairCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        DraggingHandCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        IBeamCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        LeftEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        LeftRightResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        NoCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        NormalCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        NumStandardCursorTypes: ClassVar[MouseCursor.StandardCursorType] = ...
        ParentCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        PointingHandCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        RightEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        TopEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        TopLeftCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        TopRightCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        UpDownLeftRightResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        UpDownResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        WaitCursor: ClassVar[MouseCursor.StandardCursorType] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    BottomEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    BottomLeftCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    BottomRightCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    CopyingCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    CrosshairCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    DraggingHandCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    IBeamCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    LeftEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    LeftRightResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    NoCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    NormalCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    NumStandardCursorTypes: ClassVar[MouseCursor.StandardCursorType] = ...
    ParentCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    PointingHandCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    RightEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    TopEdgeResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    TopLeftCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    TopRightCornerResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    UpDownLeftRightResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    UpDownResizeCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    WaitCursor: ClassVar[MouseCursor.StandardCursorType] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: MouseCursor.StandardCursorType) -> None: ...
    @overload
    def __init__(self, arg0: Image, arg1: int, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: Image, arg1: int, arg2: int, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: ScaledImage, arg1: PointInt) -> None: ...
    @classmethod
    def hideWaitCursor(cls) -> None: ...
    @classmethod
    def showWaitCursor(cls) -> None: ...
    @overload
    def __eq__(self, arg0: MouseCursor) -> bool: ...
    @overload
    def __eq__(self, arg0: MouseCursor.StandardCursorType) -> bool: ...
    @overload
    def __ne__(self, arg0: MouseCursor) -> bool: ...
    @overload
    def __ne__(self, arg0: MouseCursor.StandardCursorType) -> bool: ...

class MouseEvent:
    def __init__(self, arg0: MouseInputSource, arg1: PointFloat, arg2: ModifierKeys, arg3: float, arg4: float, arg5: float, arg6: float, arg7: float, arg8, arg9, arg10: Time, arg11: PointFloat, arg12: Time, arg13: int, arg14: bool) -> None: ...
    def getDistanceFromDragStart(self) -> int: ...
    def getDistanceFromDragStartX(self) -> int: ...
    def getDistanceFromDragStartY(self) -> int: ...
    @classmethod
    def getDoubleClickTimeout(cls) -> int: ...
    def getEventRelativeTo(self, arg0) -> MouseEvent: ...
    def getLengthOfMousePress(self) -> int: ...
    def getMouseDownPosition(self) -> PointInt: ...
    def getMouseDownScreenPosition(self) -> PointInt: ...
    def getMouseDownScreenX(self) -> int: ...
    def getMouseDownScreenY(self) -> int: ...
    def getMouseDownX(self) -> int: ...
    def getMouseDownY(self) -> int: ...
    def getNumberOfClicks(self) -> int: ...
    def getOffsetFromDragStart(self) -> PointInt: ...
    def getPosition(self) -> PointInt: ...
    def getScreenPosition(self) -> PointInt: ...
    def getScreenX(self) -> int: ...
    def getScreenY(self) -> int: ...
    def isOrientationValid(self) -> bool: ...
    def isPressureValid(self) -> bool: ...
    def isRotationValid(self) -> bool: ...
    def isTiltValid(self, arg0: bool) -> bool: ...
    def mouseWasClicked(self) -> bool: ...
    def mouseWasDraggedSinceMouseDown(self) -> bool: ...
    @classmethod
    def setDoubleClickTimeout(cls, arg0: int) -> None: ...
    @overload
    def withNewPosition(self, arg0: PointFloat) -> MouseEvent: ...
    @overload
    def withNewPosition(self, arg0: PointInt) -> MouseEvent: ...
    @property
    def eventComponent(self): ...
    @property
    def eventTime(self) -> Time: ...
    @property
    def mods(self) -> ModifierKeys: ...
    @property
    def mouseDownPosition(self) -> PointFloat: ...
    @property
    def mouseDownTime(self) -> Time: ...
    @property
    def orientation(self) -> float: ...
    @property
    def originalComponent(self): ...
    @property
    def position(self) -> PointFloat: ...
    @property
    def pressure(self) -> float: ...
    @property
    def rotation(self) -> float: ...
    @property
    def source(self) -> MouseInputSource: ...
    @property
    def tiltX(self) -> float: ...
    @property
    def tiltY(self) -> float: ...
    @property
    def x(self) -> int: ...
    @property
    def y(self) -> int: ...

class MouseInputSource:
    class InputSourceType:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        mouse: ClassVar[MouseInputSource.InputSourceType] = ...
        pen: ClassVar[MouseInputSource.InputSourceType] = ...
        touch: ClassVar[MouseInputSource.InputSourceType] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    defaultPressure: ClassVar[float] = ...  # read-only
    defaultRotation: ClassVar[float] = ...  # read-only
    defaultTiltX: ClassVar[float] = ...  # read-only
    defaultTiltY: ClassVar[float] = ...  # read-only
    offscreenMousePos: ClassVar[PointFloat] = ...  # read-only
    mouse: ClassVar[MouseInputSource.InputSourceType] = ...
    pen: ClassVar[MouseInputSource.InputSourceType] = ...
    touch: ClassVar[MouseInputSource.InputSourceType] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def canDoUnboundedMovement(self) -> bool: ...
    def canHover(self) -> bool: ...
    def enableUnboundedMouseMovement(self, arg0: bool, arg1: bool) -> None: ...
    def forceMouseCursorUpdate(self) -> None: ...
    def getComponentUnderMouse(self, *args, **kwargs): ...
    def getCurrentModifiers(self) -> ModifierKeys: ...
    def getCurrentOrientation(self) -> float: ...
    def getCurrentPressure(self) -> float: ...
    def getCurrentRotation(self) -> float: ...
    def getCurrentTilt(self, arg0: bool) -> float: ...
    def getIndex(self) -> int: ...
    def getLastMouseDownPosition(self) -> PointFloat: ...
    def getLastMouseDownTime(self) -> Time: ...
    def getNumberOfMultipleClicks(self) -> int: ...
    def getRawScreenPosition(self) -> PointFloat: ...
    def getScreenPosition(self) -> PointFloat: ...
    def getType(self) -> MouseInputSource.InputSourceType: ...
    def hasMouseCursor(self) -> bool: ...
    def hasMouseWheel(self) -> bool: ...
    def hasMovedSignificantlySincePressed(self) -> bool: ...
    def hideCursor(self) -> None: ...
    def isDragging(self) -> bool: ...
    def isLongPressOrDrag(self) -> bool: ...
    def isMouse(self) -> bool: ...
    def isOrientationValid(self) -> bool: ...
    def isPen(self) -> bool: ...
    def isPressureValid(self) -> bool: ...
    def isRotationValid(self) -> bool: ...
    def isTiltValid(self, arg0: bool) -> bool: ...
    def isTouch(self) -> bool: ...
    def isUnboundedMouseMovementEnabled(self) -> bool: ...
    def revealCursor(self) -> None: ...
    def setScreenPosition(self, arg0: PointFloat) -> None: ...
    def showMouseCursor(self, arg0) -> None: ...
    def triggerFakeMove(self) -> None: ...

class MouseListener:
    def __init__(self) -> None: ...
    def mouseDoubleClick(self, arg0: MouseEvent) -> None: ...
    def mouseDown(self, arg0: MouseEvent) -> None: ...
    def mouseDrag(self, arg0: MouseEvent) -> None: ...
    def mouseEnter(self, arg0: MouseEvent) -> None: ...
    def mouseExit(self, arg0: MouseEvent) -> None: ...
    def mouseMagnify(self, arg0: MouseEvent, arg1: float) -> None: ...
    def mouseMove(self, arg0: MouseEvent) -> None: ...
    def mouseUp(self, arg0: MouseEvent) -> None: ...
    def mouseWheelMove(self, arg0: MouseEvent, arg1: MouseWheelDetails) -> None: ...

class MouseWheelDetails:
    deltaX: float
    deltaY: float
    isInertial: bool
    isReversed: bool
    isSmooth: bool
    def __init__(self) -> None: ...

class MultiTimer:
    def __init__(self) -> None: ...
    def getTimerInterval(self, arg0: int) -> int: ...
    def isTimerRunning(self, arg0: int) -> bool: ...
    def startTimer(self, arg0: int, arg1: int) -> None: ...
    def stopTimer(self, arg0: int) -> None: ...
    def timerCallback(self, arg0: int) -> None: ...

class NamedValueSet:
    class NamedValue:
        name: Identifier
        value: var
        @overload
        def __init__(self) -> None: ...
        @overload
        def __init__(self, arg0: Identifier, arg1: var) -> None: ...
        @overload
        def __init__(self, arg0: NamedValueSet.NamedValue) -> None: ...
        def __eq__(self, arg0: NamedValueSet.NamedValue) -> bool: ...
        def __ne__(self, arg0: NamedValueSet.NamedValue) -> bool: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: NamedValueSet) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: dict) -> None: ...
    def clear(self) -> None: ...
    def contains(self, arg0: Identifier) -> bool: ...
    def copyToXmlAttributes(self, arg0) -> None: ...
    def getName(self, arg0: int) -> Identifier: ...
    def getValueAt(self, arg0: int) -> var: ...
    def getVarPointer(self, arg0: Identifier) -> var: ...
    def getVarPointerAt(self, arg0: int) -> var: ...
    def getWithDefault(self, arg0: Identifier, arg1: var) -> var: ...
    def indexOf(self, arg0: Identifier) -> int: ...
    def isEmpty(self) -> bool: ...
    def remove(self, arg0: Identifier) -> bool: ...
    def set(self, arg0: Identifier, arg1: var) -> bool: ...
    def setFromXmlAttributes(self, arg0) -> None: ...
    def size(self) -> int: ...
    def __eq__(self, arg0: NamedValueSet) -> bool: ...
    def __getitem__(self, arg0: Identifier) -> var: ...
    def __iter__(self) -> Iterator: ...
    def __ne__(self, arg0: NamedValueSet) -> bool: ...
    def __setitem__(self, arg0: Identifier, arg1: var) -> bool: ...

class NativeImageType(ImageType):
    def __init__(self) -> None: ...

class NotificationType:
    __members__: ClassVar[dict] = ...  # read-only
    __entries: ClassVar[dict] = ...
    dontSendNotification: ClassVar[NotificationType] = ...
    sendNotification: ClassVar[NotificationType] = ...
    sendNotificationAsync: ClassVar[NotificationType] = ...
    sendNotificationSync: ClassVar[NotificationType] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class OggVorbisAudioFormat(AudioFormat):
    encoderName: ClassVar[str] = ...
    id3album: ClassVar[str] = ...
    id3artist: ClassVar[str] = ...
    id3comment: ClassVar[str] = ...
    id3date: ClassVar[str] = ...
    id3genre: ClassVar[str] = ...
    id3title: ClassVar[str] = ...
    id3trackNumber: ClassVar[str] = ...
    def __init__(self) -> None: ...
    def estimateOggFileQuality(self, arg0: File) -> int: ...

class OutputStream:
    def __init__(self) -> None: ...
    def flush(self) -> None: ...
    def getNewLineString(self) -> str: ...
    def getPosition(self) -> int: ...
    def setNewLineString(self, arg0: str) -> None: ...
    def setPosition(self, arg0: int) -> bool: ...
    def write(self, arg0: buffer) -> bool: ...
    def writeBool(self, arg0: bool) -> bool: ...
    def writeByte(self, arg0: str) -> bool: ...
    def writeCompressedInt(self, arg0: int) -> bool: ...
    def writeDouble(self, arg0: float) -> bool: ...
    def writeDoubleBigEndian(self, arg0: float) -> bool: ...
    def writeFloat(self, arg0: float) -> bool: ...
    def writeFloatBigEndian(self, arg0: float) -> bool: ...
    def writeFromInputStream(self, arg0: InputStream, arg1: int) -> int: ...
    def writeInt(self, arg0: int) -> bool: ...
    def writeInt64(self, arg0: int) -> bool: ...
    def writeInt64BigEndian(self, arg0: int) -> bool: ...
    def writeIntBigEndian(self, arg0: int) -> bool: ...
    def writeRepeatedByte(self, arg0: int, arg1: int) -> bool: ...
    def writeShort(self, arg0: int) -> bool: ...
    def writeShortBigEndian(self, arg0: int) -> bool: ...
    def writeString(self, arg0: str) -> bool: ...
    def writeText(self, arg0: str, arg1: bool, arg2: bool, arg3: str) -> bool: ...

class PNGImageFormat(ImageFileFormat):
    def __init__(self) -> None: ...

class ParallelogramFloat:
    bottomLeft: PointFloat
    topLeft: PointFloat
    topRight: PointFloat
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: PointFloat, arg1: PointFloat, arg2: PointFloat) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> None: ...
    @overload
    def __init__(self, arg0: RectangleFloat) -> None: ...
    @overload
    def __init__(self, arg0: ParallelogramFloat) -> None: ...
    def getBottomLeft(self) -> PointFloat: ...
    def getBottomRight(self) -> PointFloat: ...
    def getBoundingBox(self) -> RectangleFloat: ...
    def getHeight(self) -> float: ...
    def getRelativePoint(self, arg0: PointFloat) -> PointFloat: ...
    def getTopLeft(self) -> PointFloat: ...
    def getTopRight(self) -> PointFloat: ...
    def getWidth(self) -> float: ...
    def isEmpty(self) -> bool: ...
    def isFinite(self) -> bool: ...
    def transformedBy(self, arg0: AffineTransform) -> ParallelogramFloat: ...
    def __add__(self, arg0: PointFloat) -> ParallelogramFloat: ...
    def __eq__(self, arg0: ParallelogramFloat) -> bool: ...
    def __iadd__(self, arg0: PointFloat) -> ParallelogramFloat: ...
    @overload
    def __imul__(self, arg0: float) -> ParallelogramFloat: ...
    @overload
    def __imul__(self, arg0: PointFloat) -> ParallelogramFloat: ...
    @overload
    def __mul__(self, arg0: float) -> ParallelogramFloat: ...
    @overload
    def __mul__(self, arg0: PointFloat) -> ParallelogramFloat: ...
    def __ne__(self, arg0: ParallelogramFloat) -> bool: ...
    def __sub__(self, arg0: PointFloat) -> ParallelogramFloat: ...

class ParallelogramInt:
    bottomLeft: PointInt
    topLeft: PointInt
    topRight: PointInt
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: PointInt, arg1: PointInt, arg2: PointInt) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: int, arg3: int, arg4: int, arg5: int) -> None: ...
    @overload
    def __init__(self, arg0: RectangleInt) -> None: ...
    @overload
    def __init__(self, arg0: ParallelogramInt) -> None: ...
    def getBottomLeft(self) -> PointInt: ...
    def getBottomRight(self) -> PointInt: ...
    def getBoundingBox(self) -> RectangleInt: ...
    def getHeight(self) -> int: ...
    def getRelativePoint(self, arg0: PointInt) -> PointInt: ...
    def getTopLeft(self) -> PointInt: ...
    def getTopRight(self) -> PointInt: ...
    def getWidth(self) -> int: ...
    def isEmpty(self) -> bool: ...
    def isFinite(self) -> bool: ...
    def transformedBy(self, arg0: AffineTransform) -> ParallelogramInt: ...
    def __add__(self, arg0: PointInt) -> ParallelogramInt: ...
    def __eq__(self, arg0: ParallelogramInt) -> bool: ...
    def __iadd__(self, arg0: PointInt) -> ParallelogramInt: ...
    @overload
    def __imul__(self, arg0: float) -> ParallelogramInt: ...
    @overload
    def __imul__(self, arg0: PointFloat) -> ParallelogramInt: ...
    @overload
    def __mul__(self, arg0: float) -> ParallelogramInt: ...
    @overload
    def __mul__(self, arg0: PointFloat) -> ParallelogramInt: ...
    def __ne__(self, arg0: ParallelogramInt) -> bool: ...
    def __sub__(self, arg0: PointInt) -> ParallelogramInt: ...

class Path:
    class Iterator:
        class PathElementType:
            __members__: ClassVar[dict] = ...  # read-only
            __entries: ClassVar[dict] = ...
            closePath: ClassVar[Path.Iterator.PathElementType] = ...
            cubicTo: ClassVar[Path.Iterator.PathElementType] = ...
            lineTo: ClassVar[Path.Iterator.PathElementType] = ...
            quadraticTo: ClassVar[Path.Iterator.PathElementType] = ...
            startNewSubPath: ClassVar[Path.Iterator.PathElementType] = ...
            def __init__(self, value: int) -> None: ...
            def __eq__(self, other: object) -> bool: ...
            def __hash__(self) -> int: ...
            def __index__(self) -> int: ...
            def __int__(self) -> int: ...
            def __ne__(self, other: object) -> bool: ...
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        closePath: ClassVar[Path.Iterator.PathElementType] = ...
        cubicTo: ClassVar[Path.Iterator.PathElementType] = ...
        lineTo: ClassVar[Path.Iterator.PathElementType] = ...
        quadraticTo: ClassVar[Path.Iterator.PathElementType] = ...
        startNewSubPath: ClassVar[Path.Iterator.PathElementType] = ...
        elementType: Path.Iterator.PathElementType
        x1: float
        x2: float
        x3: float
        y1: float
        y2: float
        y3: float
        def __init__(self, arg0: Path) -> None: ...
        def next(self) -> bool: ...
    defaultToleranceForMeasurement: ClassVar[float] = ...
    defaultToleranceForTesting: ClassVar[float] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: Path) -> None: ...
    def addArc(self, x: float, y: float, width: float, height: float, fromRadians: float, toRadians: float, startAsNewSubPath: bool = ...) -> None: ...
    def addArrow(self, arg0: LineFloat, arg1: float, arg2: float, arg3: float) -> None: ...
    def addBubble(self, arg0: RectangleFloat, arg1: RectangleFloat, arg2: PointFloat, arg3: float, arg4: float) -> None: ...
    def addCentredArc(self, centreX: float, centreY: float, radiusX: float, radiusY: float, rotationOfEllipse: float, fromRadians: float, toRadians: float, startAsNewSubPath: bool = ...) -> None: ...
    @overload
    def addEllipse(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def addEllipse(self, arg0: RectangleFloat) -> None: ...
    def addLineSegment(self, arg0: LineFloat, arg1: float) -> None: ...
    @overload
    def addPath(self, arg0: Path) -> None: ...
    @overload
    def addPath(self, arg0: Path, arg1: AffineTransform) -> None: ...
    @overload
    def addPieSegment(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: float) -> None: ...
    @overload
    def addPieSegment(self, arg0: RectangleFloat, arg1: float, arg2: float, arg3: float) -> None: ...
    def addPolygon(self, arg0: PointFloat, arg1: int, arg2: float, arg3: float) -> None: ...
    def addQuadrilateral(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: float, arg7: float) -> None: ...
    @overload
    def addRectangle(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def addRectangle(self, arg0: RectangleInt) -> None: ...
    @overload
    def addRectangle(self, arg0: RectangleFloat) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: bool, arg7: bool, arg8: bool, arg9: bool) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: RectangleInt, arg1: float) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: RectangleFloat, arg1: float) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: RectangleInt, arg1: float, arg2: float) -> None: ...
    @overload
    def addRoundedRectangle(self, arg0: RectangleFloat, arg1: float, arg2: float) -> None: ...
    def addStar(self, arg0: PointFloat, arg1: int, arg2: float, arg3: float, arg4: float) -> None: ...
    @overload
    def addTriangle(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> None: ...
    @overload
    def addTriangle(self, arg0: PointFloat, arg1: PointFloat, arg2: PointFloat) -> None: ...
    def applyTransform(self, arg0: AffineTransform) -> None: ...
    def clear(self) -> None: ...
    def closeSubPath(self) -> None: ...
    @overload
    def contains(self, x: float, y: float, tolerance: float = ...) -> bool: ...
    @overload
    def contains(self, point: PointFloat, tolerance: float = ...) -> bool: ...
    def createPathWithRoundedCorners(self, arg0: float) -> Path: ...
    @overload
    def cubicTo(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float) -> None: ...
    @overload
    def cubicTo(self, arg0: PointFloat, arg1: PointFloat, arg2: PointFloat) -> None: ...
    def getBounds(self) -> RectangleFloat: ...
    def getBoundsTransformed(self, transform: AffineTransform) -> RectangleFloat: ...
    def getClippedLine(self, line: LineFloat, keepSectionOutsidePath: bool) -> LineFloat: ...
    def getCurrentPosition(self) -> PointFloat: ...
    def getLength(self, transform: AffineTransform = ..., tolerance: float = ...) -> float: ...
    def getNearestPoint(self, targetPoint: PointFloat, pointOnPath: PointFloat, transform: AffineTransform = ..., tolerance: float = ...) -> float: ...
    def getPointAlongPath(self, distanceFromStart: float, transform: AffineTransform = ..., tolerance: float = ...) -> PointFloat: ...
    def intersectsLine(self, line: LineFloat, tolerance: float = ...) -> bool: ...
    def isEmpty(self) -> bool: ...
    def isUsingNonZeroWinding(self) -> bool: ...
    @overload
    def lineTo(self, endX: float, endY: float) -> None: ...
    @overload
    def lineTo(self, end: PointFloat) -> None: ...
    def loadPathFromData(self, arg0: buffer) -> None: ...
    def loadPathFromStream(self, arg0: InputStream) -> None: ...
    def preallocateSpace(self, arg0: int) -> None: ...
    def quadraticTo(self, controlPoint: PointFloat, endPoint: PointFloat) -> None: ...
    def restoreFromString(self, arg0: str) -> None: ...
    def scaleToFit(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None: ...
    def setUsingNonZeroWinding(self, arg0: bool) -> None: ...
    @overload
    def startNewSubPath(self, startX: float, startY: float) -> None: ...
    @overload
    def startNewSubPath(self, start: PointFloat) -> None: ...
    def swapWithPath(self, arg0: Path) -> None: ...
    def toString(self) -> str: ...
    def writePathToStream(self, arg0: OutputStream) -> None: ...
    def __eq__(self, arg0: Path) -> bool: ...
    def __ne__(self, arg0: Path) -> bool: ...

class PathFlatteningIterator:
    closesSubPath: bool
    subPathIndex: int
    x1: float
    x2: float
    y1: float
    y2: float
    def __init__(self, path: Path, transform: AffineTransform = ..., tolerance: float = ...) -> None: ...
    def isLastInSubpath(self) -> bool: ...
    def next(self) -> bool: ...

class PathStrokeType:
    class EndCapStyle:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        butt: ClassVar[PathStrokeType.EndCapStyle] = ...
        rounded: ClassVar[PathStrokeType.EndCapStyle] = ...
        square: ClassVar[PathStrokeType.EndCapStyle] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class JointStyle:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        beveled: ClassVar[PathStrokeType.JointStyle] = ...
        curved: ClassVar[PathStrokeType.JointStyle] = ...
        mitered: ClassVar[PathStrokeType.JointStyle] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    beveled: ClassVar[PathStrokeType.JointStyle] = ...
    butt: ClassVar[PathStrokeType.EndCapStyle] = ...
    curved: ClassVar[PathStrokeType.JointStyle] = ...
    mitered: ClassVar[PathStrokeType.JointStyle] = ...
    rounded: ClassVar[PathStrokeType.EndCapStyle] = ...
    square: ClassVar[PathStrokeType.EndCapStyle] = ...
    @overload
    def __init__(self, strokeThickness: float) -> None: ...
    @overload
    def __init__(self, strokeThickness: float, jointStyle: PathStrokeType.JointStyle, endStyle: PathStrokeType.EndCapStyle = ...) -> None: ...
    @overload
    def __init__(self, arg0: PathStrokeType) -> None: ...
    def createDashedStroke(self, destPath: Path, sourcePath: Path, dashLengths: list, transform: AffineTransform = ..., extraAccuracy: float = ...) -> None: ...
    def createStrokeWithArrowheads(self, destPath: Path, sourcePath: Path, arrowheadStartWidth: float, arrowheadStartLength: float, arrowheadEndWidth: float, arrowheadEndLength: float, transform: AffineTransform = ..., extraAccuracy: float = ...) -> None: ...
    def createStrokedPath(self, destPath: Path, sourcePath: Path, transform: AffineTransform = ..., extraAccuracy: float = ...) -> None: ...
    def getEndStyle(self) -> PathStrokeType.EndCapStyle: ...
    def getJointStyle(self) -> PathStrokeType.JointStyle: ...
    def getStrokeThickness(self) -> float: ...
    def setEndStyle(self, arg0: PathStrokeType.EndCapStyle) -> None: ...
    def setJointStyle(self, arg0: PathStrokeType.JointStyle) -> None: ...
    def setStrokeThickness(self, arg0: float) -> None: ...
    def __eq__(self, arg0: PathStrokeType) -> bool: ...
    def __ne__(self, arg0: PathStrokeType) -> bool: ...

class PenDetails:
    rotation: float
    tiltX: float
    tiltY: float
    def __init__(self) -> None: ...

class PerformanceCounter:
    class Statistics:
        averageSeconds: float
        maximumSeconds: float
        minimumSeconds: float
        name: str
        numRuns: int
        totalSeconds: float
        def __init__(self) -> None: ...
        def addResult(self, arg0: float) -> None: ...
        def clear(self) -> None: ...
        def toString(self) -> str: ...
    def __init__(self, counterName: str, runsPerPrintout: int = ..., loggingFile: File = ...) -> None: ...
    def getStatisticsAndReset(self) -> PerformanceCounter.Statistics: ...
    def printStatistics(self) -> None: ...
    def start(self) -> None: ...
    def stop(self) -> bool: ...

class PixelARGB:
    indexA: ClassVar[int] = ...
    indexB: ClassVar[int] = ...
    indexG: ClassVar[int] = ...
    indexR: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def blend(self, arg0) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB) -> None: ...
    @overload
    def blend(self, arg0) -> None: ...
    @overload
    def blend(self, arg0, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0, arg1: int) -> None: ...
    def desaturate(self) -> None: ...
    def getAlpha(self) -> int: ...
    def getBlue(self) -> int: ...
    def getEvenBytes(self) -> int: ...
    def getGreen(self) -> int: ...
    def getInARGBMaskOrder(self) -> int: ...
    def getInARGBMemoryOrder(self) -> int: ...
    def getNativeARGB(self) -> int: ...
    def getOddBytes(self) -> int: ...
    def getRed(self) -> int: ...
    def getUnpremultiplied(self) -> PixelARGB: ...
    @overload
    def multiplyAlpha(self, arg0: int) -> None: ...
    @overload
    def multiplyAlpha(self, arg0: float) -> None: ...
    def premultiply(self) -> None: ...
    @overload
    def set(self, arg0) -> None: ...
    @overload
    def set(self, arg0: PixelARGB) -> None: ...
    @overload
    def set(self, arg0) -> None: ...
    def setARGB(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    def setAlpha(self, arg0: int) -> None: ...
    @overload
    def tween(self, arg0, arg1: int) -> None: ...
    @overload
    def tween(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def tween(self, arg0, arg1: int) -> None: ...
    def unpremultiply(self) -> None: ...

class PixelAlpha:
    indexA: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def blend(self, arg0: PixelRGB) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB) -> None: ...
    @overload
    def blend(self, arg0: PixelAlpha) -> None: ...
    @overload
    def blend(self, arg0: PixelRGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelAlpha, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelRGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelAlpha, arg1: int) -> None: ...
    def desaturate(self) -> None: ...
    def getAlpha(self) -> int: ...
    def getBlue(self) -> int: ...
    def getEvenBytes(self) -> int: ...
    def getGreen(self) -> int: ...
    def getInARGBMaskOrder(self) -> int: ...
    def getInARGBMemoryOrder(self) -> int: ...
    def getNativeARGB(self) -> int: ...
    def getOddBytes(self) -> int: ...
    def getRed(self) -> int: ...
    @overload
    def multiplyAlpha(self, arg0: int) -> None: ...
    @overload
    def multiplyAlpha(self, arg0: float) -> None: ...
    def premultiply(self) -> None: ...
    @overload
    def set(self, arg0: PixelRGB) -> None: ...
    @overload
    def set(self, arg0: PixelARGB) -> None: ...
    @overload
    def set(self, arg0: PixelAlpha) -> None: ...
    def setARGB(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    def setAlpha(self, arg0: int) -> None: ...
    @overload
    def tween(self, arg0: PixelRGB, arg1: int) -> None: ...
    @overload
    def tween(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def tween(self, arg0: PixelAlpha, arg1: int) -> None: ...
    def unpremultiply(self) -> None: ...

class PixelRGB:
    indexB: ClassVar[int] = ...
    indexG: ClassVar[int] = ...
    indexR: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: int) -> None: ...
    @overload
    def blend(self, arg0: PixelRGB) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB) -> None: ...
    @overload
    def blend(self, arg0) -> None: ...
    @overload
    def blend(self, arg0: PixelRGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelRGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def blend(self, arg0, arg1: int) -> None: ...
    def desaturate(self) -> None: ...
    def getAlpha(self) -> int: ...
    def getBlue(self) -> int: ...
    def getEvenBytes(self) -> int: ...
    def getGreen(self) -> int: ...
    def getInARGBMaskOrder(self) -> int: ...
    def getInARGBMemoryOrder(self) -> int: ...
    def getNativeARGB(self) -> int: ...
    def getOddBytes(self) -> int: ...
    def getRed(self) -> int: ...
    @overload
    def multiplyAlpha(self, arg0: int) -> None: ...
    @overload
    def multiplyAlpha(self, arg0: float) -> None: ...
    def premultiply(self) -> None: ...
    @overload
    def set(self, arg0: PixelRGB) -> None: ...
    @overload
    def set(self, arg0: PixelARGB) -> None: ...
    @overload
    def set(self, arg0) -> None: ...
    def setARGB(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    def setAlpha(self, arg0: int) -> None: ...
    @overload
    def tween(self, arg0: PixelRGB, arg1: int) -> None: ...
    @overload
    def tween(self, arg0: PixelARGB, arg1: int) -> None: ...
    @overload
    def tween(self, arg0, arg1: int) -> None: ...
    def unpremultiply(self) -> None: ...

class PointFloat:
    x: float
    y: float
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...
    def addXY(self, arg0: float, arg1: float) -> None: ...
    def applyTransform(self, arg0: AffineTransform) -> None: ...
    def getAngleToPoint(self, arg0: PointFloat) -> float: ...
    def getDistanceFrom(self, arg0: PointFloat) -> float: ...
    def getDistanceFromOrigin(self) -> float: ...
    def getDistanceSquaredFrom(self, arg0: PointFloat) -> float: ...
    def getDistanceSquaredFromOrigin(self) -> float: ...
    def getDotProduct(self, arg0: PointFloat) -> float: ...
    @overload
    def getPointOnCircumference(self, arg0: float, arg1: float) -> PointFloat: ...
    @overload
    def getPointOnCircumference(self, arg0: float, arg1: float, arg2: float) -> PointFloat: ...
    def getX(self) -> float: ...
    def getY(self) -> float: ...
    def isFinite(self) -> bool: ...
    def isOrigin(self) -> bool: ...
    def rotatedAboutOrigin(self, arg0: float) -> PointFloat: ...
    def roundToInt(self) -> PointInt: ...
    def setX(self, arg0: float) -> None: ...
    def setXY(self, arg0: float, arg1: float) -> None: ...
    def setY(self, arg0: float) -> None: ...
    def toDouble(self, *args, **kwargs): ...
    def toFloat(self) -> PointFloat: ...
    def toInt(self) -> PointInt: ...
    def toString(self) -> str: ...
    def transformedBy(self, arg0: AffineTransform) -> PointFloat: ...
    def translated(self, arg0: float, arg1: float) -> PointFloat: ...
    def withX(self, arg0: float) -> PointFloat: ...
    def withY(self, arg0: float) -> PointFloat: ...
    def __add__(self, arg0: PointFloat) -> PointFloat: ...
    def __eq__(self, arg0: PointFloat) -> bool: ...
    def __iadd__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __imul__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __imul__(self, arg0: float) -> PointFloat: ...
    def __isub__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __itruediv__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __itruediv__(self, arg0: float) -> PointFloat: ...
    @overload
    def __mul__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __mul__(self, arg0: float) -> PointFloat: ...
    def __ne__(self, arg0: PointFloat) -> bool: ...
    def __neg__(self) -> PointFloat: ...
    def __sub__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __truediv__(self, arg0: PointFloat) -> PointFloat: ...
    @overload
    def __truediv__(self, arg0: float) -> PointFloat: ...

class PointInt:
    x: int
    y: int
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    def addXY(self, arg0: int, arg1: int) -> None: ...
    def applyTransform(self, arg0: AffineTransform) -> None: ...
    def getAngleToPoint(self, arg0: PointInt) -> float: ...
    def getDistanceFrom(self, arg0: PointInt) -> int: ...
    def getDistanceFromOrigin(self) -> int: ...
    def getDistanceSquaredFrom(self, arg0: PointInt) -> int: ...
    def getDistanceSquaredFromOrigin(self) -> int: ...
    def getDotProduct(self, arg0: PointInt) -> float: ...
    def getPointOnCircumference(self, *args, **kwargs): ...
    def getX(self) -> int: ...
    def getY(self) -> int: ...
    def isFinite(self) -> bool: ...
    def isOrigin(self) -> bool: ...
    def rotatedAboutOrigin(self, arg0: int) -> PointInt: ...
    def roundToInt(self) -> PointInt: ...
    def setX(self, arg0: int) -> None: ...
    def setXY(self, arg0: int, arg1: int) -> None: ...
    def setY(self, arg0: int) -> None: ...
    def toDouble(self, *args, **kwargs): ...
    def toFloat(self, *args, **kwargs): ...
    def toInt(self) -> PointInt: ...
    def toString(self) -> str: ...
    def transformedBy(self, arg0: AffineTransform) -> PointInt: ...
    def translated(self, arg0: int, arg1: int) -> PointInt: ...
    def withX(self, arg0: int) -> PointInt: ...
    def withY(self, arg0: int) -> PointInt: ...
    def __add__(self, arg0: PointInt) -> PointInt: ...
    def __eq__(self, arg0: PointInt) -> bool: ...
    def __iadd__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __imul__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __imul__(self, arg0: float) -> PointInt: ...
    def __isub__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __itruediv__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __itruediv__(self, arg0: float) -> PointInt: ...
    @overload
    def __mul__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __mul__(self, arg0: float) -> PointInt: ...
    def __ne__(self, arg0: PointInt) -> bool: ...
    def __neg__(self) -> PointInt: ...
    def __sub__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __truediv__(self, arg0: PointInt) -> PointInt: ...
    @overload
    def __truediv__(self, arg0: float) -> PointInt: ...

class PositionableAudioSource(AudioSource):
    def __init__(self) -> None: ...
    def getNextReadPosition(self) -> int: ...
    def getTotalLength(self) -> int: ...
    def isLooping(self) -> bool: ...
    def setLooping(self, arg0: bool) -> None: ...
    def setNextReadPosition(self, arg0: int) -> None: ...

class Process:
    class ProcessPriority:
        __members__: ClassVar[dict] = ...  # read-only
        HighPriority: ClassVar[Process.ProcessPriority] = ...
        LowPriority: ClassVar[Process.ProcessPriority] = ...
        NormalPriority: ClassVar[Process.ProcessPriority] = ...
        RealtimePriority: ClassVar[Process.ProcessPriority] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    HighPriority: ClassVar[Process.ProcessPriority] = ...
    LowPriority: ClassVar[Process.ProcessPriority] = ...
    NormalPriority: ClassVar[Process.ProcessPriority] = ...
    RealtimePriority: ClassVar[Process.ProcessPriority] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def hide(cls) -> None: ...
    @classmethod
    def isForegroundProcess(cls) -> bool: ...
    @classmethod
    def isRunningUnderDebugger(cls) -> bool: ...
    @classmethod
    def lowerPrivilege(cls) -> None: ...
    @classmethod
    def makeForegroundProcess(cls) -> None: ...
    @classmethod
    def openDocument(cls, arg0: str, arg1: str) -> bool: ...
    @classmethod
    def openEmailWithAttachments(cls, arg0: str, arg1: str, arg2: str, arg3: StringArray) -> bool: ...
    @classmethod
    def raisePrivilege(cls) -> None: ...
    @classmethod
    def setPriority(cls, arg0: Process.ProcessPriority) -> None: ...
    @classmethod
    def terminate(cls) -> None: ...

class PropertiesFile:
    class Options:
        applicationName: str
        commonToAllUsers: bool
        doNotSave: bool
        filenameSuffix: str
        folderName: str
        ignoreCaseOfKeyNames: bool
        millisecondsBeforeSaving: int
        osxLibrarySubFolder: str
        processLock: InterProcessLock
        storageFormat: PropertiesFile.StorageFormat
        def __init__(self) -> None: ...
        def getDefaultFile(self) -> File: ...

    class StorageFormat:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        storeAsBinary: ClassVar[PropertiesFile.StorageFormat] = ...
        storeAsCompressedBinary: ClassVar[PropertiesFile.StorageFormat] = ...
        storeAsXML: ClassVar[PropertiesFile.StorageFormat] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    storeAsBinary: ClassVar[PropertiesFile.StorageFormat] = ...
    storeAsCompressedBinary: ClassVar[PropertiesFile.StorageFormat] = ...
    storeAsXML: ClassVar[PropertiesFile.StorageFormat] = ...
    @overload
    def __init__(self, arg0: PropertiesFile.Options) -> None: ...
    @overload
    def __init__(self, arg0: File, arg1: PropertiesFile.Options) -> None: ...
    def getFile(self) -> File: ...
    def isValidFile(self) -> bool: ...
    def needsToBeSaved(self) -> bool: ...
    def reload(self) -> bool: ...
    def save(self) -> bool: ...
    def saveIfNeeded(self) -> bool: ...
    def setNeedsToBeSaved(self, arg0: bool) -> None: ...

class PropertySet:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: PropertySet) -> None: ...
    def addAllPropertiesFrom(self, arg0: PropertySet) -> None: ...
    def clear(self) -> None: ...
    def containsKey(self, arg0: str) -> bool: ...
    def createXml(self, *args, **kwargs): ...
    def getBoolValue(self, arg0: str, arg1: bool) -> bool: ...
    def getDoubleValue(self, arg0: str, arg1: float) -> float: ...
    def getFallbackPropertySet(self) -> PropertySet: ...
    def getIntValue(self, arg0: str, arg1: int) -> int: ...
    def getValue(self, arg0: str, arg1: str) -> str: ...
    def getXmlValue(self, *args, **kwargs): ...
    def removeValue(self, arg0: str) -> None: ...
    def restoreFromXml(self, arg0) -> None: ...
    def setFallbackPropertySet(self, arg0: PropertySet) -> None: ...
    @overload
    def setValue(self, arg0: str, arg1: var) -> None: ...
    @overload
    def setValue(self, arg0: str, arg1) -> None: ...

class Random:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    def combineSeed(self, arg0: int) -> None: ...
    @overload
    def fillBitsRandomly(self, arg0: buffer) -> None: ...
    @overload
    def fillBitsRandomly(self, arg0: BigInteger, arg1: int, arg2: int) -> None: ...
    def getSeed(self) -> int: ...
    @classmethod
    def getSystemRandom(cls) -> Random: ...
    def nextBool(self) -> bool: ...
    def nextDouble(self) -> float: ...
    def nextFloat(self) -> float: ...
    @overload
    def nextInt(self) -> int: ...
    @overload
    def nextInt(self, arg0: int) -> int: ...
    @overload
    def nextInt(self, arg0: RangeInt) -> int: ...
    def nextInt64(self) -> int: ...
    def nextLargeNumber(self, arg0: BigInteger) -> BigInteger: ...
    def setSeed(self, arg0: int) -> None: ...
    def setSeedRandomly(self) -> None: ...

class RangeFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...
    @classmethod
    def between(cls, arg0: float, arg1: float) -> RangeFloat: ...
    def clipValue(self, arg0: float) -> float: ...
    def constrainRange(self, arg0: RangeFloat) -> RangeFloat: ...
    @overload
    def contains(self, arg0: float) -> bool: ...
    @overload
    def contains(self, arg0: RangeFloat) -> bool: ...
    @classmethod
    def emptyRange(cls, arg0: float) -> RangeFloat: ...
    def expanded(self, arg0: float) -> RangeFloat: ...
    def getEnd(self) -> float: ...
    def getIntersectionWith(self, arg0: RangeFloat) -> RangeFloat: ...
    def getLength(self) -> float: ...
    def getStart(self) -> float: ...
    @overload
    def getUnionWith(self, arg0: RangeFloat) -> RangeFloat: ...
    @overload
    def getUnionWith(self, arg0: float) -> RangeFloat: ...
    def intersects(self, arg0: RangeFloat) -> bool: ...
    def isEmpty(self) -> bool: ...
    def movedToEndAt(self, arg0: float) -> RangeFloat: ...
    def movedToStartAt(self, arg0: float) -> RangeFloat: ...
    def setEnd(self, arg0: float) -> None: ...
    def setLength(self, arg0: float) -> None: ...
    def setStart(self, arg0: float) -> None: ...
    def withEnd(self, arg0: float) -> RangeFloat: ...
    def withStart(self, arg0: float) -> RangeFloat: ...
    @classmethod
    def withStartAndLength(cls, arg0: float, arg1: float) -> RangeFloat: ...
    def __add__(self, arg0: float) -> RangeFloat: ...
    def __eq__(self, arg0: RangeFloat) -> bool: ...
    def __iadd__(self, arg0: float) -> RangeFloat: ...
    def __isub__(self, arg0: float) -> RangeFloat: ...
    def __ne__(self, arg0: RangeFloat) -> bool: ...
    def __sub__(self, arg0: float) -> RangeFloat: ...

class RangeInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @classmethod
    def between(cls, arg0: int, arg1: int) -> RangeInt: ...
    def clipValue(self, arg0: int) -> int: ...
    def constrainRange(self, arg0: RangeInt) -> RangeInt: ...
    @overload
    def contains(self, arg0: int) -> bool: ...
    @overload
    def contains(self, arg0: RangeInt) -> bool: ...
    @classmethod
    def emptyRange(cls, arg0: int) -> RangeInt: ...
    def expanded(self, arg0: int) -> RangeInt: ...
    def getEnd(self) -> int: ...
    def getIntersectionWith(self, arg0: RangeInt) -> RangeInt: ...
    def getLength(self) -> int: ...
    def getStart(self) -> int: ...
    @overload
    def getUnionWith(self, arg0: RangeInt) -> RangeInt: ...
    @overload
    def getUnionWith(self, arg0: int) -> RangeInt: ...
    def intersects(self, arg0: RangeInt) -> bool: ...
    def isEmpty(self) -> bool: ...
    def movedToEndAt(self, arg0: int) -> RangeInt: ...
    def movedToStartAt(self, arg0: int) -> RangeInt: ...
    def setEnd(self, arg0: int) -> None: ...
    def setLength(self, arg0: int) -> None: ...
    def setStart(self, arg0: int) -> None: ...
    def withEnd(self, arg0: int) -> RangeInt: ...
    def withStart(self, arg0: int) -> RangeInt: ...
    @classmethod
    def withStartAndLength(cls, arg0: int, arg1: int) -> RangeInt: ...
    def __add__(self, arg0: int) -> RangeInt: ...
    def __eq__(self, arg0: RangeInt) -> bool: ...
    def __iadd__(self, arg0: int) -> RangeInt: ...
    def __isub__(self, arg0: int) -> RangeInt: ...
    def __ne__(self, arg0: RangeInt) -> bool: ...
    def __sub__(self, arg0: int) -> RangeInt: ...

class RangedDirectoryIterator:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, directory: File, isRecursive: bool, wildCard: str = ..., whatToLookFor: int = ..., followSymlinks: File.FollowSymlinks = ...) -> None: ...
    def __eq__(self, arg0: RangedDirectoryIterator) -> bool: ...
    def __iter__(self) -> Iterator: ...
    def __ne__(self, arg0: RangedDirectoryIterator) -> bool: ...

class ReadWriteLock:
    def __init__(self) -> None: ...
    def enterRead(self) -> None: ...
    def enterWrite(self) -> None: ...
    def exitRead(self) -> None: ...
    def exitWrite(self) -> None: ...
    def tryEnterRead(self) -> bool: ...
    def tryEnterWrite(self) -> bool: ...

class RectangleFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: PointFloat, arg1: PointFloat) -> None: ...
    @overload
    def __init__(self, arg0: RectangleFloat) -> None: ...
    def constrainedWithin(self, arg0: RectangleFloat) -> RectangleFloat: ...
    @overload
    def contains(self, arg0: float, arg1: float) -> bool: ...
    @overload
    def contains(self, arg0: PointFloat) -> bool: ...
    @overload
    def contains(self, arg0: RectangleFloat) -> bool: ...
    def enlargeIfAdjacent(self, arg0: RectangleFloat) -> bool: ...
    def expand(self, arg0: float, arg1: float) -> None: ...
    @overload
    def expanded(self, arg0: float) -> RectangleFloat: ...
    @overload
    def expanded(self, arg0: float, arg1: float) -> RectangleFloat: ...
    @classmethod
    def fromString(cls, arg0: str) -> RectangleFloat: ...
    def getAspectRatio(self, arg0: bool) -> float: ...
    def getBottom(self) -> float: ...
    def getBottomLeft(self) -> PointFloat: ...
    def getBottomRight(self) -> PointFloat: ...
    def getCentreX(self) -> float: ...
    def getCentreY(self) -> float: ...
    def getConstrainedPoint(self, arg0: PointFloat) -> PointFloat: ...
    def getHeight(self) -> float: ...
    def getHorizontalRange(self) -> RangeFloat: ...
    def getIntersection(self, arg0: RectangleFloat) -> RectangleFloat: ...
    def getPosition(self) -> PointFloat: ...
    def getProportion(self, arg0: RectangleFloat) -> RectangleFloat: ...
    def getRelativePoint(self, arg0: float, arg1: float) -> PointFloat: ...
    def getRight(self) -> float: ...
    def getSmallestIntegerContainer(self) -> RectangleInt: ...
    def getTopLeft(self) -> PointFloat: ...
    def getTopRight(self) -> PointFloat: ...
    def getUnion(self, arg0: RectangleFloat) -> RectangleFloat: ...
    def getVerticalRange(self) -> RangeFloat: ...
    def getWidth(self) -> float: ...
    def getX(self) -> float: ...
    def getY(self) -> float: ...
    def intersectRectangle(self, arg0: RectangleFloat) -> bool: ...
    @overload
    def intersects(self, arg0: RectangleFloat) -> bool: ...
    @overload
    def intersects(self, arg0: LineFloat) -> bool: ...
    def isEmpty(self) -> bool: ...
    def isFinite(self) -> bool: ...
    @classmethod
    def leftTopRightBottom(cls, arg0: float, arg1: float, arg2: float, arg3: float) -> RectangleFloat: ...
    def proportionOfHeight(self, arg0: float) -> float: ...
    def proportionOfWidth(self, arg0: float) -> float: ...
    def reduce(self, arg0: float, arg1: float) -> None: ...
    def reduceIfPartlyContainedIn(self, arg0: RectangleFloat) -> bool: ...
    @overload
    def reduced(self, arg0: float) -> RectangleFloat: ...
    @overload
    def reduced(self, arg0: float, arg1: float) -> RectangleFloat: ...
    def removeFromBottom(self, arg0: float) -> RectangleFloat: ...
    def removeFromLeft(self, arg0: float) -> RectangleFloat: ...
    def removeFromRight(self, arg0: float) -> RectangleFloat: ...
    def removeFromTop(self, arg0: float) -> RectangleFloat: ...
    def setBottom(self, arg0: float) -> None: ...
    def setBounds(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def setCentre(self, arg0: PointFloat) -> None: ...
    @overload
    def setCentre(self, arg0: float, arg1: float) -> None: ...
    def setHeight(self, arg0: float) -> None: ...
    def setHorizontalRange(self, arg0: RangeFloat) -> None: ...
    def setLeft(self, arg0: float) -> None: ...
    @overload
    def setPosition(self, arg0: PointFloat) -> None: ...
    @overload
    def setPosition(self, arg0: float, arg1: float) -> None: ...
    def setRight(self, arg0: float) -> None: ...
    def setSize(self, arg0: float, arg1: float) -> None: ...
    def setTop(self, arg0: float) -> None: ...
    def setVerticalRange(self, arg0: RangeFloat) -> None: ...
    def setWidth(self, arg0: float) -> None: ...
    def setX(self, arg0: float) -> None: ...
    def setY(self, arg0: float) -> None: ...
    def toFloat(self) -> RectangleFloat: ...
    def toNearestInt(self) -> RectangleInt: ...
    def toNearestIntEdges(self) -> RectangleInt: ...
    def toString(self) -> str: ...
    def transformedBy(self, arg0: AffineTransform) -> RectangleFloat: ...
    def translate(self, arg0: float, arg1: float) -> None: ...
    def translated(self, arg0: float, arg1: float) -> RectangleFloat: ...
    def withBottom(self, arg0: float) -> RectangleFloat: ...
    def withBottomY(self, arg0: float) -> RectangleFloat: ...
    def withCentre(self, arg0: PointFloat) -> RectangleFloat: ...
    def withHeight(self, arg0: float) -> RectangleFloat: ...
    def withLeft(self, arg0: float) -> RectangleFloat: ...
    @overload
    def withPosition(self, arg0: PointFloat) -> RectangleFloat: ...
    @overload
    def withPosition(self, arg0: float, arg1: float) -> RectangleFloat: ...
    def withRight(self, arg0: float) -> RectangleFloat: ...
    def withRightX(self, arg0: float) -> RectangleFloat: ...
    def withSize(self, arg0: float, arg1: float) -> RectangleFloat: ...
    def withSizeKeepingCentre(self, arg0: float, arg1: float) -> RectangleFloat: ...
    def withTop(self, arg0: float) -> RectangleFloat: ...
    def withTrimmedBottom(self, arg0: float) -> RectangleFloat: ...
    def withTrimmedLeft(self, arg0: float) -> RectangleFloat: ...
    def withTrimmedRight(self, arg0: float) -> RectangleFloat: ...
    def withTrimmedTop(self, arg0: float) -> RectangleFloat: ...
    def withWidth(self, arg0: float) -> RectangleFloat: ...
    def withX(self, arg0: float) -> RectangleFloat: ...
    def withY(self, arg0: float) -> RectangleFloat: ...
    def withZeroOrigin(self) -> RectangleFloat: ...
    def __add__(self, arg0: PointFloat) -> RectangleFloat: ...
    def __eq__(self, arg0: RectangleFloat) -> bool: ...
    def __iadd__(self, arg0: PointFloat) -> RectangleFloat: ...
    @overload
    def __imul__(self, arg0: float) -> RectangleFloat: ...
    @overload
    def __imul__(self, arg0: PointFloat) -> RectangleFloat: ...
    def __isub__(self, arg0: PointFloat) -> RectangleFloat: ...
    @overload
    def __itruediv__(self, arg0: float) -> RectangleFloat: ...
    @overload
    def __itruediv__(self, arg0: PointFloat) -> RectangleFloat: ...
    @overload
    def __mul__(self, arg0: float) -> RectangleFloat: ...
    @overload
    def __mul__(self, arg0: PointFloat) -> RectangleFloat: ...
    def __ne__(self, arg0: RectangleFloat) -> bool: ...
    def __sub__(self, arg0: PointFloat) -> RectangleFloat: ...
    @overload
    def __truediv__(self, arg0: float) -> RectangleFloat: ...
    @overload
    def __truediv__(self, arg0: PointFloat) -> RectangleFloat: ...

class RectangleInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def __init__(self, arg0: PointInt, arg1: PointInt) -> None: ...
    @overload
    def __init__(self, arg0: RectangleInt) -> None: ...
    def constrainedWithin(self, arg0: RectangleInt) -> RectangleInt: ...
    @overload
    def contains(self, arg0: int, arg1: int) -> bool: ...
    @overload
    def contains(self, arg0: PointInt) -> bool: ...
    @overload
    def contains(self, arg0: RectangleInt) -> bool: ...
    def enlargeIfAdjacent(self, arg0: RectangleInt) -> bool: ...
    def expand(self, arg0: int, arg1: int) -> None: ...
    @overload
    def expanded(self, arg0: int) -> RectangleInt: ...
    @overload
    def expanded(self, arg0: int, arg1: int) -> RectangleInt: ...
    @classmethod
    def fromString(cls, arg0: str) -> RectangleInt: ...
    def getAspectRatio(self, arg0: bool) -> int: ...
    def getBottom(self) -> int: ...
    def getBottomLeft(self) -> PointInt: ...
    def getBottomRight(self) -> PointInt: ...
    def getCentreX(self) -> int: ...
    def getCentreY(self) -> int: ...
    def getConstrainedPoint(self, arg0: PointInt) -> PointInt: ...
    def getHeight(self) -> int: ...
    def getHorizontalRange(self) -> RangeInt: ...
    def getIntersection(self, arg0: RectangleInt) -> RectangleInt: ...
    def getPosition(self) -> PointInt: ...
    def getProportion(self, arg0) -> RectangleInt: ...
    def getRelativePoint(self, arg0: float, arg1: float) -> PointInt: ...
    def getRight(self) -> int: ...
    def getSmallestIntegerContainer(self) -> RectangleInt: ...
    def getTopLeft(self) -> PointInt: ...
    def getTopRight(self) -> PointInt: ...
    def getUnion(self, arg0: RectangleInt) -> RectangleInt: ...
    def getVerticalRange(self) -> RangeInt: ...
    def getWidth(self) -> int: ...
    def getX(self) -> int: ...
    def getY(self) -> int: ...
    def intersectRectangle(self, arg0: RectangleInt) -> bool: ...
    @overload
    def intersects(self, arg0: RectangleInt) -> bool: ...
    @overload
    def intersects(self, arg0: LineInt) -> bool: ...
    def isEmpty(self) -> bool: ...
    def isFinite(self) -> bool: ...
    @classmethod
    def leftTopRightBottom(cls, arg0: int, arg1: int, arg2: int, arg3: int) -> RectangleInt: ...
    def proportionOfHeight(self, arg0: float) -> int: ...
    def proportionOfWidth(self, arg0: float) -> int: ...
    def reduce(self, arg0: int, arg1: int) -> None: ...
    def reduceIfPartlyContainedIn(self, arg0: RectangleInt) -> bool: ...
    @overload
    def reduced(self, arg0: int) -> RectangleInt: ...
    @overload
    def reduced(self, arg0: int, arg1: int) -> RectangleInt: ...
    def removeFromBottom(self, arg0: int) -> RectangleInt: ...
    def removeFromLeft(self, arg0: int) -> RectangleInt: ...
    def removeFromRight(self, arg0: int) -> RectangleInt: ...
    def removeFromTop(self, arg0: int) -> RectangleInt: ...
    def setBottom(self, arg0: int) -> None: ...
    def setBounds(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def setCentre(self, arg0: PointInt) -> None: ...
    @overload
    def setCentre(self, arg0: int, arg1: int) -> None: ...
    def setHeight(self, arg0: int) -> None: ...
    def setHorizontalRange(self, arg0: RangeInt) -> None: ...
    def setLeft(self, arg0: int) -> None: ...
    @overload
    def setPosition(self, arg0: PointInt) -> None: ...
    @overload
    def setPosition(self, arg0: int, arg1: int) -> None: ...
    def setRight(self, arg0: int) -> None: ...
    def setSize(self, arg0: int, arg1: int) -> None: ...
    def setTop(self, arg0: int) -> None: ...
    def setVerticalRange(self, arg0: RangeInt) -> None: ...
    def setWidth(self, arg0: int) -> None: ...
    def setX(self, arg0: int) -> None: ...
    def setY(self, arg0: int) -> None: ...
    def toFloat(self, *args, **kwargs): ...
    def toNearestInt(self) -> RectangleInt: ...
    def toNearestIntEdges(self) -> RectangleInt: ...
    def toString(self) -> str: ...
    def transformedBy(self, arg0: AffineTransform) -> RectangleInt: ...
    def translate(self, arg0: int, arg1: int) -> None: ...
    def translated(self, arg0: int, arg1: int) -> RectangleInt: ...
    def withBottom(self, arg0: int) -> RectangleInt: ...
    def withBottomY(self, arg0: int) -> RectangleInt: ...
    def withCentre(self, arg0: PointInt) -> RectangleInt: ...
    def withHeight(self, arg0: int) -> RectangleInt: ...
    def withLeft(self, arg0: int) -> RectangleInt: ...
    @overload
    def withPosition(self, arg0: PointInt) -> RectangleInt: ...
    @overload
    def withPosition(self, arg0: int, arg1: int) -> RectangleInt: ...
    def withRight(self, arg0: int) -> RectangleInt: ...
    def withRightX(self, arg0: int) -> RectangleInt: ...
    def withSize(self, arg0: int, arg1: int) -> RectangleInt: ...
    def withSizeKeepingCentre(self, arg0: int, arg1: int) -> RectangleInt: ...
    def withTop(self, arg0: int) -> RectangleInt: ...
    def withTrimmedBottom(self, arg0: int) -> RectangleInt: ...
    def withTrimmedLeft(self, arg0: int) -> RectangleInt: ...
    def withTrimmedRight(self, arg0: int) -> RectangleInt: ...
    def withTrimmedTop(self, arg0: int) -> RectangleInt: ...
    def withWidth(self, arg0: int) -> RectangleInt: ...
    def withX(self, arg0: int) -> RectangleInt: ...
    def withY(self, arg0: int) -> RectangleInt: ...
    def withZeroOrigin(self) -> RectangleInt: ...
    def __add__(self, arg0: PointInt) -> RectangleInt: ...
    def __eq__(self, arg0: RectangleInt) -> bool: ...
    def __iadd__(self, arg0: PointInt) -> RectangleInt: ...
    @overload
    def __imul__(self, arg0: float) -> RectangleInt: ...
    @overload
    def __imul__(self, arg0: PointFloat) -> RectangleInt: ...
    def __isub__(self, arg0: PointInt) -> RectangleInt: ...
    @overload
    def __itruediv__(self, arg0: float) -> RectangleInt: ...
    @overload
    def __itruediv__(self, arg0: PointFloat) -> RectangleInt: ...
    @overload
    def __mul__(self, arg0: float) -> RectangleInt: ...
    @overload
    def __mul__(self, arg0: PointFloat) -> RectangleInt: ...
    def __ne__(self, arg0: RectangleInt) -> bool: ...
    def __sub__(self, arg0: PointInt) -> RectangleInt: ...
    @overload
    def __truediv__(self, arg0: float) -> RectangleInt: ...
    @overload
    def __truediv__(self, arg0: PointFloat) -> RectangleInt: ...

class RectangleListFloat:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: RectangleFloat) -> None: ...
    @overload
    def __init__(self, arg0: RectangleListFloat) -> None: ...
    @overload
    def add(self, arg0: RectangleFloat) -> None: ...
    @overload
    def add(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def add(self, arg0: RectangleListFloat) -> None: ...
    def addWithoutMerging(self, arg0: RectangleFloat) -> None: ...
    def clear(self) -> None: ...
    @overload
    def clipTo(self, arg0: RectangleFloat) -> bool: ...
    @overload
    def clipTo(self, arg0: RectangleListInt) -> bool: ...
    @overload
    def clipTo(self, arg0: RectangleListFloat) -> bool: ...
    def consolidate(self) -> None: ...
    @overload
    def containsPoint(self, arg0: PointFloat) -> bool: ...
    @overload
    def containsPoint(self, arg0: float, arg1: float) -> bool: ...
    def containsRectangle(self, arg0: RectangleFloat) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def getBounds(self) -> RectangleFloat: ...
    def getIntersectionWith(self, arg0: RectangleFloat, arg1: RectangleListFloat) -> bool: ...
    def getNumRectangles(self) -> int: ...
    def getRectangle(self, arg0: int) -> RectangleFloat: ...
    def intersects(self, arg0: RectangleListFloat) -> bool: ...
    def intersectsRectangle(self, arg0: RectangleFloat) -> bool: ...
    def isEmpty(self) -> bool: ...
    @overload
    def offsetAll(self, arg0: PointFloat) -> None: ...
    @overload
    def offsetAll(self, arg0: float, arg1: float) -> None: ...
    @overload
    def scaleAll(self, arg0: int) -> None: ...
    @overload
    def scaleAll(self, arg0: float) -> None: ...
    @overload
    def subtract(self, arg0: RectangleFloat) -> None: ...
    @overload
    def subtract(self, arg0: RectangleListFloat) -> bool: ...
    def swapWith(self, arg0: RectangleListFloat) -> None: ...
    def toPath(self, *args, **kwargs): ...
    def transformAll(self, arg0: AffineTransform) -> None: ...
    def __iter__(self) -> Iterator: ...

class RectangleListInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: RectangleInt) -> None: ...
    @overload
    def __init__(self, arg0: RectangleListInt) -> None: ...
    @overload
    def add(self, arg0: RectangleInt) -> None: ...
    @overload
    def add(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...
    @overload
    def add(self, arg0: RectangleListInt) -> None: ...
    def addWithoutMerging(self, arg0: RectangleInt) -> None: ...
    def clear(self) -> None: ...
    @overload
    def clipTo(self, arg0: RectangleInt) -> bool: ...
    @overload
    def clipTo(self, arg0: RectangleListInt) -> bool: ...
    @overload
    def clipTo(self, arg0) -> bool: ...
    def consolidate(self) -> None: ...
    @overload
    def containsPoint(self, arg0: PointInt) -> bool: ...
    @overload
    def containsPoint(self, arg0: int, arg1: int) -> bool: ...
    def containsRectangle(self, arg0: RectangleInt) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    def getBounds(self) -> RectangleInt: ...
    def getIntersectionWith(self, arg0: RectangleInt, arg1: RectangleListInt) -> bool: ...
    def getNumRectangles(self) -> int: ...
    def getRectangle(self, arg0: int) -> RectangleInt: ...
    def intersects(self, arg0: RectangleListInt) -> bool: ...
    def intersectsRectangle(self, arg0: RectangleInt) -> bool: ...
    def isEmpty(self) -> bool: ...
    @overload
    def offsetAll(self, arg0: PointInt) -> None: ...
    @overload
    def offsetAll(self, arg0: int, arg1: int) -> None: ...
    @overload
    def scaleAll(self, arg0: int) -> None: ...
    @overload
    def scaleAll(self, arg0: float) -> None: ...
    @overload
    def subtract(self, arg0: RectangleInt) -> None: ...
    @overload
    def subtract(self, arg0: RectangleListInt) -> bool: ...
    def swapWith(self, arg0: RectangleListInt) -> None: ...
    def toPath(self, *args, **kwargs): ...
    def transformAll(self, arg0: AffineTransform) -> None: ...
    def __iter__(self) -> Iterator: ...

class RectanglePlacement:
    class Flags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        centred: ClassVar[RectanglePlacement.Flags] = ...
        doNotResize: ClassVar[RectanglePlacement.Flags] = ...
        fillDestination: ClassVar[RectanglePlacement.Flags] = ...
        onlyIncreaseInSize: ClassVar[RectanglePlacement.Flags] = ...
        onlyReduceInSize: ClassVar[RectanglePlacement.Flags] = ...
        stretchToFit: ClassVar[RectanglePlacement.Flags] = ...
        xLeft: ClassVar[RectanglePlacement.Flags] = ...
        xMid: ClassVar[RectanglePlacement.Flags] = ...
        xRight: ClassVar[RectanglePlacement.Flags] = ...
        yBottom: ClassVar[RectanglePlacement.Flags] = ...
        yMid: ClassVar[RectanglePlacement.Flags] = ...
        yTop: ClassVar[RectanglePlacement.Flags] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: RectanglePlacement.Flags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: RectanglePlacement.Flags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: RectanglePlacement.Flags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: RectanglePlacement.Flags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: RectanglePlacement.Flags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: RectanglePlacement.Flags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: RectanglePlacement.Flags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: RectanglePlacement.Flags) -> int: ...
        def __xor__(self, arg0: RectanglePlacement.Flags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    centred: ClassVar[RectanglePlacement.Flags] = ...
    doNotResize: ClassVar[RectanglePlacement.Flags] = ...
    fillDestination: ClassVar[RectanglePlacement.Flags] = ...
    onlyIncreaseInSize: ClassVar[RectanglePlacement.Flags] = ...
    onlyReduceInSize: ClassVar[RectanglePlacement.Flags] = ...
    stretchToFit: ClassVar[RectanglePlacement.Flags] = ...
    xLeft: ClassVar[RectanglePlacement.Flags] = ...
    xMid: ClassVar[RectanglePlacement.Flags] = ...
    xRight: ClassVar[RectanglePlacement.Flags] = ...
    yBottom: ClassVar[RectanglePlacement.Flags] = ...
    yMid: ClassVar[RectanglePlacement.Flags] = ...
    yTop: ClassVar[RectanglePlacement.Flags] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: RectanglePlacement.Flags) -> None: ...
    @overload
    def __init__(self, arg0: RectanglePlacement) -> None: ...
    @overload
    def appliedTo(self, arg0: RectangleInt, arg1: RectangleInt) -> RectangleInt: ...
    @overload
    def appliedTo(self, arg0: RectangleFloat, arg1: RectangleFloat) -> RectangleFloat: ...
    def applyTo(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: float, arg7: float) -> tuple: ...
    def getFlags(self) -> int: ...
    def getTransformToFit(self, arg0: RectangleFloat, arg1: RectangleFloat) -> AffineTransform: ...
    @overload
    def testFlags(self, arg0: int) -> bool: ...
    @overload
    def testFlags(self, arg0: RectanglePlacement.Flags) -> bool: ...
    def __eq__(self, arg0: RectanglePlacement) -> bool: ...
    def __ne__(self, arg0: RectanglePlacement) -> bool: ...

class RelativeTime:
    @overload
    def __init__(self, seconds: float = ...) -> None: ...
    @overload
    def __init__(self, arg0: RelativeTime) -> None: ...
    @classmethod
    def days(cls, arg0: float) -> RelativeTime: ...
    def getApproximateDescription(self) -> str: ...
    def getDescription(self, returnValueForZeroTime: str = ...) -> str: ...
    @classmethod
    def hours(cls, arg0: float) -> RelativeTime: ...
    def inDays(self) -> float: ...
    def inHours(self) -> float: ...
    def inMilliseconds(self) -> int: ...
    def inMinutes(self) -> float: ...
    def inSeconds(self) -> float: ...
    def inWeeks(self) -> float: ...
    @classmethod
    def milliseconds(cls, arg0: int) -> RelativeTime: ...
    @classmethod
    def minutes(cls, arg0: float) -> RelativeTime: ...
    @classmethod
    def seconds(cls, arg0: float) -> RelativeTime: ...
    @classmethod
    def weeks(cls, arg0: float) -> RelativeTime: ...
    def __add__(self, arg0: RelativeTime) -> RelativeTime: ...
    @overload
    def __iadd__(self, arg0: RelativeTime) -> RelativeTime: ...
    @overload
    def __iadd__(self, arg0: float) -> RelativeTime: ...
    @overload
    def __isub__(self, arg0: RelativeTime) -> RelativeTime: ...
    @overload
    def __isub__(self, arg0: float) -> RelativeTime: ...
    def __sub__(self, arg0: RelativeTime) -> RelativeTime: ...

class ResamplingAudioSource(AudioSource):
    def __init__(self, inputSource: AudioSource, deleteSourceWhenDeleted: bool = ..., numChannels: int = ...) -> None: ...
    def flushBuffers(self) -> None: ...
    def getResamplingRatio(self) -> float: ...
    def setResamplingRatio(self, arg0: float) -> None: ...

class ResizableWindow(TopLevelWindow):
    backgroundColourId: ClassVar[int] = ...
    @overload
    def __init__(self, arg0: str, arg1: bool) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: Colour, arg2: bool) -> None: ...
    def clearContentComponent(self) -> None: ...
    def getBackgroundColour(self) -> Colour: ...
    def getContentComponent(self) -> Component: ...
    def getWindowStateAsString(self) -> str: ...
    def isDraggable(self) -> bool: ...
    def isFullScreen(self) -> bool: ...
    def isKioskMode(self) -> bool: ...
    def isMinimised(self) -> bool: ...
    def isResizable(self) -> bool: ...
    def restoreWindowStateFromString(self, arg0: str) -> bool: ...
    def setBackgroundColour(self, arg0: Colour) -> None: ...
    def setBoundsConstrained(self, arg0: RectangleInt) -> None: ...
    def setContentComponentSize(self, arg0: int, arg1: int) -> None: ...
    def setContentNonOwned(self, arg0: Component, arg1: bool) -> None: ...
    def setContentOwned(self, arg0: Component, arg1: bool) -> None: ...
    def setDraggable(self, arg0: bool) -> None: ...
    def setFullScreen(self, arg0: bool) -> None: ...
    def setMinimised(self, arg0: bool) -> None: ...
    def setResizable(self, arg0: bool, arg1: bool) -> None: ...
    def setResizeLimits(self, arg0: int, arg1: int, arg2: int, arg3: int) -> None: ...

class Result:
    def __init__(self, arg0: Result) -> None: ...
    @classmethod
    def fail(cls, arg0: str) -> Result: ...
    def failed(self) -> bool: ...
    def getErrorMessage(self) -> str: ...
    @classmethod
    def ok(cls) -> Result: ...
    def wasOk(self) -> bool: ...
    def __bool__(self) -> bool: ...
    def __eq__(self, arg0: Result) -> bool: ...
    def __ne__(self, arg0: Result) -> bool: ...

class ReverbAudioSource(AudioSource):
    def __init__(self, inputSource: AudioSource, deleteSourceWhenDeleted: bool = ...) -> None: ...
    def isBypassed(self) -> bool: ...
    def setBypassed(self, arg0: bool) -> None: ...

class ScaledImage:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Image) -> None: ...
    @overload
    def __init__(self, arg0: Image, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: ScaledImage) -> None: ...
    def getImage(self) -> Image: ...
    def getScale(self) -> float: ...
    def getScaledBounds(self, *args, **kwargs): ...

class ShapeButton(Button):
    def __init__(self, arg0: str, arg1: Colour, arg2: Colour, arg3: Colour) -> None: ...
    def setBorderSize(self, arg0: BorderSizeInt) -> None: ...
    def setColours(self, arg0: Colour, arg1: Colour, arg2: Colour) -> None: ...
    def setOnColours(self, arg0: Colour, arg1: Colour, arg2: Colour) -> None: ...
    def setOutline(self, arg0: Colour, arg1: float) -> None: ...
    def setShape(self, arg0: Path, arg1: bool, arg2: bool, arg3: bool) -> None: ...
    def shouldUseOnColours(self, arg0: bool) -> None: ...

class Slider(Component):
    class DragMode:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        absoluteDrag: ClassVar[Slider.DragMode] = ...
        notDragging: ClassVar[Slider.DragMode] = ...
        velocityDrag: ClassVar[Slider.DragMode] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class IncDecButtonMode:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        incDecButtonsDraggable_AutoDirection: ClassVar[Slider.IncDecButtonMode] = ...
        incDecButtonsDraggable_Horizontal: ClassVar[Slider.IncDecButtonMode] = ...
        incDecButtonsDraggable_Vertical: ClassVar[Slider.IncDecButtonMode] = ...
        incDecButtonsNotDraggable: ClassVar[Slider.IncDecButtonMode] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Listener:
        def __init__(self) -> None: ...
        def sliderDragEnded(self, arg0: Slider) -> None: ...
        def sliderDragStarted(self, arg0: Slider) -> None: ...
        def sliderValueChanged(self, arg0: Slider) -> None: ...

    class RotaryParameters:
        endAngleRadians: float
        startAngleRadians: float
        stopAtEnd: bool
        def __init__(self) -> None: ...

    class SliderLayout:
        sliderBounds: RectangleInt
        textBoxBounds: RectangleInt
        def __init__(self) -> None: ...

    class SliderStyle:
        __members__: ClassVar[dict] = ...  # read-only
        IncDecButtons: ClassVar[Slider.SliderStyle] = ...
        LinearBar: ClassVar[Slider.SliderStyle] = ...
        LinearBarVertical: ClassVar[Slider.SliderStyle] = ...
        LinearHorizontal: ClassVar[Slider.SliderStyle] = ...
        LinearVertical: ClassVar[Slider.SliderStyle] = ...
        Rotary: ClassVar[Slider.SliderStyle] = ...
        RotaryHorizontalDrag: ClassVar[Slider.SliderStyle] = ...
        RotaryHorizontalVerticalDrag: ClassVar[Slider.SliderStyle] = ...
        RotaryVerticalDrag: ClassVar[Slider.SliderStyle] = ...
        ThreeValueHorizontal: ClassVar[Slider.SliderStyle] = ...
        ThreeValueVertical: ClassVar[Slider.SliderStyle] = ...
        TwoValueHorizontal: ClassVar[Slider.SliderStyle] = ...
        TwoValueVertical: ClassVar[Slider.SliderStyle] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class TextEntryBoxPosition:
        __members__: ClassVar[dict] = ...  # read-only
        NoTextBox: ClassVar[Slider.TextEntryBoxPosition] = ...
        TextBoxAbove: ClassVar[Slider.TextEntryBoxPosition] = ...
        TextBoxBelow: ClassVar[Slider.TextEntryBoxPosition] = ...
        TextBoxLeft: ClassVar[Slider.TextEntryBoxPosition] = ...
        TextBoxRight: ClassVar[Slider.TextEntryBoxPosition] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    IncDecButtons: ClassVar[Slider.SliderStyle] = ...
    LinearBar: ClassVar[Slider.SliderStyle] = ...
    LinearBarVertical: ClassVar[Slider.SliderStyle] = ...
    LinearHorizontal: ClassVar[Slider.SliderStyle] = ...
    LinearVertical: ClassVar[Slider.SliderStyle] = ...
    NoTextBox: ClassVar[Slider.TextEntryBoxPosition] = ...
    Rotary: ClassVar[Slider.SliderStyle] = ...
    RotaryHorizontalDrag: ClassVar[Slider.SliderStyle] = ...
    RotaryHorizontalVerticalDrag: ClassVar[Slider.SliderStyle] = ...
    RotaryVerticalDrag: ClassVar[Slider.SliderStyle] = ...
    TextBoxAbove: ClassVar[Slider.TextEntryBoxPosition] = ...
    TextBoxBelow: ClassVar[Slider.TextEntryBoxPosition] = ...
    TextBoxLeft: ClassVar[Slider.TextEntryBoxPosition] = ...
    TextBoxRight: ClassVar[Slider.TextEntryBoxPosition] = ...
    ThreeValueHorizontal: ClassVar[Slider.SliderStyle] = ...
    ThreeValueVertical: ClassVar[Slider.SliderStyle] = ...
    TwoValueHorizontal: ClassVar[Slider.SliderStyle] = ...
    TwoValueVertical: ClassVar[Slider.SliderStyle] = ...
    absoluteDrag: ClassVar[Slider.DragMode] = ...
    backgroundColourId: ClassVar[int] = ...
    incDecButtonsDraggable_AutoDirection: ClassVar[Slider.IncDecButtonMode] = ...
    incDecButtonsDraggable_Horizontal: ClassVar[Slider.IncDecButtonMode] = ...
    incDecButtonsDraggable_Vertical: ClassVar[Slider.IncDecButtonMode] = ...
    incDecButtonsNotDraggable: ClassVar[Slider.IncDecButtonMode] = ...
    notDragging: ClassVar[Slider.DragMode] = ...
    rotarySliderFillColourId: ClassVar[int] = ...
    rotarySliderOutlineColourId: ClassVar[int] = ...
    textBoxBackgroundColourId: ClassVar[int] = ...
    textBoxHighlightColourId: ClassVar[int] = ...
    textBoxOutlineColourId: ClassVar[int] = ...
    textBoxTextColourId: ClassVar[int] = ...
    thumbColourId: ClassVar[int] = ...
    trackColourId: ClassVar[int] = ...
    velocityDrag: ClassVar[Slider.DragMode] = ...
    onDragEnd: Callable[[], None]
    onDragStart: Callable[[], None]
    onValueChange: Callable[[], None]
    textFromValueFunction: Callable[[float], str]
    valueFromTextFunction: Callable[[str], float]
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, componentName: str) -> None: ...
    @overload
    def __init__(self, style: Slider.SliderStyle, textBoxPosition: Slider.TextEntryBoxPosition) -> None: ...
    def addListener(self, arg0: Slider.Listener) -> None: ...
    def getCurrentPopupDisplay(self) -> Component: ...
    def getDoubleClickReturnValue(self) -> float: ...
    def getInterval(self) -> float: ...
    def getMaxValue(self) -> float: ...
    def getMaxValueObject(self) -> Value: ...
    def getMaximum(self) -> float: ...
    def getMinValue(self) -> float: ...
    def getMinValueObject(self) -> Value: ...
    def getMinimum(self) -> float: ...
    def getMouseDragSensitivity(self) -> int: ...
    def getNumDecimalPlacesToDisplay(self) -> int: ...
    def getPositionOfValue(self, arg0: float) -> float: ...
    def getRange(self, *args, **kwargs): ...
    def getRotaryParameters(self) -> Slider.RotaryParameters: ...
    def getSkewFactor(self) -> float: ...
    def getSliderSnapsToMousePosition(self) -> bool: ...
    def getSliderStyle(self) -> Slider.SliderStyle: ...
    def getTextBoxHeight(self) -> int: ...
    def getTextBoxPosition(self) -> Slider.TextEntryBoxPosition: ...
    def getTextBoxWidth(self) -> int: ...
    def getTextFromValue(self, arg0: float) -> str: ...
    def getTextValueSuffix(self) -> str: ...
    def getThumbBeingDragged(self) -> int: ...
    def getValue(self) -> float: ...
    def getValueFromText(self, arg0: str) -> float: ...
    def getValueObject(self) -> Value: ...
    def getVelocityBasedMode(self) -> bool: ...
    def getVelocityModeIsSwappable(self) -> bool: ...
    def getVelocityOffset(self) -> float: ...
    def getVelocitySensitivity(self) -> float: ...
    def getVelocityThreshold(self) -> int: ...
    def hideTextBox(self, discardCurrentEditorContents: bool) -> None: ...
    def isBar(self) -> bool: ...
    def isDoubleClickReturnEnabled(self) -> bool: ...
    def isHorizontal(self) -> bool: ...
    def isRotary(self) -> bool: ...
    def isScrollWheelEnabled(self) -> bool: ...
    def isSymmetricSkew(self) -> bool: ...
    def isTextBoxEditable(self) -> bool: ...
    def isThreeValue(self) -> bool: ...
    def isTwoValue(self) -> bool: ...
    def isVertical(self) -> bool: ...
    def proportionOfLengthToValue(self, arg0: float) -> float: ...
    def removeListener(self, arg0: Slider.Listener) -> None: ...
    def setChangeNotificationOnlyOnRelease(self, arg0: bool) -> None: ...
    def setDoubleClickReturnValue(self, arg0: bool, arg1: float, arg2: ModifierKeys) -> None: ...
    def setIncDecButtonsMode(self, arg0: Slider.IncDecButtonMode) -> None: ...
    def setMaxValue(self, newValue: float, notification: NotificationType = ..., allowNudgingOfOtherValues: bool = ...) -> None: ...
    def setMinAndMaxValues(self, newMinValue: float, newMaxValue: float, notification: NotificationType = ...) -> None: ...
    def setMinValue(self, newValue: float, notification: NotificationType = ..., allowNudgingOfOtherValues: bool = ...) -> None: ...
    def setMouseDragSensitivity(self, distanceForFullScaleDrag: int) -> None: ...
    def setNumDecimalPlacesToDisplay(self, arg0: int) -> None: ...
    def setPopupDisplayEnabled(self, arg0: bool, arg1: bool, arg2: Component, arg3: int) -> None: ...
    def setPopupMenuEnabled(self, arg0: bool) -> None: ...
    @overload
    def setRange(self, newMinimum: float, newMaximum: float, newInterval: float = ...) -> None: ...
    @overload
    def setRange(self, newRange, newInterval: float) -> None: ...
    @overload
    def setRotaryParameters(self, newParameters: Slider.RotaryParameters) -> None: ...
    @overload
    def setRotaryParameters(self, startAngleRadians: float, endAngleRadians: float, stopAtEnd: bool) -> None: ...
    def setScrollWheelEnabled(self, arg0: bool) -> None: ...
    def setSkewFactor(self, factor: float, symmetricSkew: bool = ...) -> None: ...
    def setSkewFactorFromMidPoint(self, sliderValueToShowAtMidPoint: float) -> None: ...
    def setSliderSnapsToMousePosition(self, arg0: bool) -> None: ...
    def setSliderStyle(self, newStyle: Slider.SliderStyle) -> None: ...
    def setTextBoxIsEditable(self, shouldBeEditable: bool) -> None: ...
    def setTextBoxStyle(self, newPosition: Slider.TextEntryBoxPosition, isReadOnly: bool, textEntryBoxWidth: int, textEntryBoxHeight: int) -> None: ...
    def setTextValueSuffix(self, arg0: str) -> None: ...
    def setValue(self, newValue: float, notification: NotificationType = ...) -> None: ...
    def setVelocityBasedMode(self, isVelocityBased: bool) -> None: ...
    def setVelocityModeParameters(self, sensitivity: float = ..., threshold: int = ..., offset: float = ..., userCanPressKeyToSwapMode: bool = ..., modifiersToSwapModes: ModifierKeys.Flags = ...) -> None: ...
    def showTextBox(self) -> None: ...
    def snapValue(self, arg0: float, arg1: Slider.DragMode) -> float: ...
    def startedDragging(self) -> None: ...
    def stoppedDragging(self) -> None: ...
    def updateText(self) -> None: ...
    def valueChanged(self) -> None: ...
    def valueToProportionOfLength(self, arg0: float) -> float: ...

class SoftwareImageType(ImageType):
    def __init__(self) -> None: ...

class SpinLock:
    def __init__(self) -> None: ...
    def enter(self) -> None: ...
    def exit(self) -> None: ...
    def tryEnter(self) -> bool: ...

class StringArray:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: StringArray) -> None: ...
    @overload
    def __init__(self, arg0: str, *args) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    def add(self, arg0: str) -> None: ...
    @overload
    def addArray(self, other: StringArray, startIndex: int = ..., numElementsToAdd: int = ...) -> None: ...
    @overload
    def addArray(self, other: list, startIndex: int = ..., numElementsToAdd: int = ...) -> None: ...
    def addIfNotAlreadyThere(self, stringToAdd: str, ignoreCase: bool = ...) -> bool: ...
    def addLines(self, arg0: str) -> int: ...
    @overload
    def addTokens(self, stringToTokenise: str, preserveQuotedStrings: bool) -> int: ...
    @overload
    def addTokens(self, stringToTokenise: str, breakCharacters: str, quoteCharacters: str) -> int: ...
    def clear(self) -> None: ...
    def clearQuick(self) -> None: ...
    def contains(self, stringToLookFor: str, ignoreCase: bool = ...) -> bool: ...
    def ensureStorageAllocated(self, arg0: int) -> None: ...
    @classmethod
    def fromLines(cls, arg0: str) -> StringArray: ...
    @overload
    @classmethod
    def fromTokens(cls, stringToTokenise: str, preserveQuotedStrings: bool) -> StringArray: ...
    @overload
    @classmethod
    def fromTokens(cls, stringToTokenise: str, breakCharacters: str, quoteCharacters: str) -> StringArray: ...
    def getReference(self, arg0: int) -> str: ...
    def indexOf(self, stringToLookFor: str, ignoreCase: bool = ..., startIndex: int = ...) -> int: ...
    def insert(self, arg0: int, arg1: str) -> None: ...
    def isEmpty(self) -> bool: ...
    def joinIntoString(self, separatorString: str, startIndex: int = ..., numberOfElements: int = ...) -> str: ...
    def mergeArray(self, other: StringArray, ignoreCase: bool = ...) -> None: ...
    def minimiseStorageOverheads(self) -> None: ...
    def move(self, arg0: int, arg1: int) -> None: ...
    def remove(self, arg0: int) -> None: ...
    def removeDuplicates(self, arg0: bool) -> None: ...
    def removeEmptyStrings(self, removeWhitespaceStrings: bool = ...) -> None: ...
    def removeRange(self, arg0: int, arg1: int) -> None: ...
    def removeString(self, stringToRemove: str, ignoreCase: bool = ...) -> None: ...
    def set(self, arg0: int, arg1: str) -> None: ...
    def size(self) -> int: ...
    def sort(self, ignoreCase: bool) -> None: ...
    def sortNatural(self) -> None: ...
    def swapWith(self, arg0: StringArray) -> None: ...
    def trim(self) -> None: ...
    def __eq__(self, arg0: StringArray) -> bool: ...
    def __getitem__(self, arg0: int) -> str: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __ne__(self, arg0: StringArray) -> bool: ...
    def __setitem__(self, arg0: int, arg1: str) -> None: ...

class SubregionStream(InputStream):
    def __init__(self, arg0: InputStream, arg1: int, arg2: int, arg3: bool) -> None: ...

class SystemAudioVolume:
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def getGain(cls) -> float: ...
    @classmethod
    def isMuted(cls) -> bool: ...
    @classmethod
    def setGain(cls, arg0: float) -> bool: ...
    @classmethod
    def setMuted(cls, arg0: bool) -> bool: ...

class SystemClipboard:
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def copyTextToClipboard(cls, arg0: str) -> None: ...
    @classmethod
    def getTextFromClipboard(cls) -> str: ...

class SystemStats:
    class MachineIdFlags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        fileSystemId: ClassVar[SystemStats.MachineIdFlags] = ...
        legacyUniqueId: ClassVar[SystemStats.MachineIdFlags] = ...
        macAddresses: ClassVar[SystemStats.MachineIdFlags] = ...
        uniqueId: ClassVar[SystemStats.MachineIdFlags] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class OperatingSystemType:
        __members__: ClassVar[dict] = ...  # read-only
        Android: ClassVar[SystemStats.OperatingSystemType] = ...
        Linux: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_10: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_11: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_12: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_13: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_14: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_15: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_7: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_8: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOSX_10_9: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOS_11: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOS_12: ClassVar[SystemStats.OperatingSystemType] = ...
        MacOS_13: ClassVar[SystemStats.OperatingSystemType] = ...
        UnknownOS: ClassVar[SystemStats.OperatingSystemType] = ...
        WASM: ClassVar[SystemStats.OperatingSystemType] = ...
        Win2000: ClassVar[SystemStats.OperatingSystemType] = ...
        WinVista: ClassVar[SystemStats.OperatingSystemType] = ...
        WinXP: ClassVar[SystemStats.OperatingSystemType] = ...
        Windows: ClassVar[SystemStats.OperatingSystemType] = ...
        Windows10: ClassVar[SystemStats.OperatingSystemType] = ...
        Windows11: ClassVar[SystemStats.OperatingSystemType] = ...
        Windows7: ClassVar[SystemStats.OperatingSystemType] = ...
        Windows8_0: ClassVar[SystemStats.OperatingSystemType] = ...
        Windows8_1: ClassVar[SystemStats.OperatingSystemType] = ...
        __entries: ClassVar[dict] = ...
        iOS: ClassVar[SystemStats.OperatingSystemType] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: SystemStats.OperatingSystemType) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: SystemStats.OperatingSystemType) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: SystemStats.OperatingSystemType) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: SystemStats.OperatingSystemType) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: SystemStats.OperatingSystemType) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: SystemStats.OperatingSystemType) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: SystemStats.OperatingSystemType) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: SystemStats.OperatingSystemType) -> int: ...
        def __xor__(self, arg0: SystemStats.OperatingSystemType) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    Android: ClassVar[SystemStats.OperatingSystemType] = ...
    Linux: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_10: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_11: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_12: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_13: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_14: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_15: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_7: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_8: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOSX_10_9: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOS_11: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOS_12: ClassVar[SystemStats.OperatingSystemType] = ...
    MacOS_13: ClassVar[SystemStats.OperatingSystemType] = ...
    UnknownOS: ClassVar[SystemStats.OperatingSystemType] = ...
    WASM: ClassVar[SystemStats.OperatingSystemType] = ...
    Win2000: ClassVar[SystemStats.OperatingSystemType] = ...
    WinVista: ClassVar[SystemStats.OperatingSystemType] = ...
    WinXP: ClassVar[SystemStats.OperatingSystemType] = ...
    Windows: ClassVar[SystemStats.OperatingSystemType] = ...
    Windows10: ClassVar[SystemStats.OperatingSystemType] = ...
    Windows11: ClassVar[SystemStats.OperatingSystemType] = ...
    Windows7: ClassVar[SystemStats.OperatingSystemType] = ...
    Windows8_0: ClassVar[SystemStats.OperatingSystemType] = ...
    Windows8_1: ClassVar[SystemStats.OperatingSystemType] = ...
    fileSystemId: ClassVar[SystemStats.MachineIdFlags] = ...
    iOS: ClassVar[SystemStats.OperatingSystemType] = ...
    legacyUniqueId: ClassVar[SystemStats.MachineIdFlags] = ...
    macAddresses: ClassVar[SystemStats.MachineIdFlags] = ...
    uniqueId: ClassVar[SystemStats.MachineIdFlags] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def getComputerName(cls) -> str: ...
    @classmethod
    def getCpuModel(cls) -> str: ...
    @classmethod
    def getCpuSpeedInMegahertz(cls) -> int: ...
    @classmethod
    def getCpuVendor(cls) -> str: ...
    @classmethod
    def getDeviceDescription(cls) -> str: ...
    @classmethod
    def getDeviceManufacturer(cls) -> str: ...
    @classmethod
    def getDisplayLanguage(cls) -> str: ...
    @classmethod
    def getEnvironmentVariable(cls, arg0: str, arg1: str) -> str: ...
    @classmethod
    def getFullUserName(cls) -> str: ...
    @classmethod
    def getJUCEVersion(cls) -> str: ...
    @classmethod
    def getLogonName(cls) -> str: ...
    @classmethod
    def getMachineIdentifiers(cls, arg0: SystemStats.MachineIdFlags) -> StringArray: ...
    @classmethod
    def getMemorySizeInMegabytes(cls) -> int: ...
    @classmethod
    def getNumCpus(cls) -> int: ...
    @classmethod
    def getNumPhysicalCpus(cls) -> int: ...
    @classmethod
    def getOperatingSystemName(cls) -> str: ...
    @classmethod
    def getOperatingSystemType(cls) -> SystemStats.OperatingSystemType: ...
    @classmethod
    def getPageSize(cls) -> int: ...
    @classmethod
    def getStackBacktrace(cls) -> str: ...
    @classmethod
    def getUniqueDeviceID(cls) -> str: ...
    @classmethod
    def getUserLanguage(cls) -> str: ...
    @classmethod
    def getUserRegion(cls) -> str: ...
    @classmethod
    def has3DNow(cls) -> bool: ...
    @classmethod
    def hasAVX(cls) -> bool: ...
    @classmethod
    def hasAVX2(cls) -> bool: ...
    @classmethod
    def hasAVX512BW(cls) -> bool: ...
    @classmethod
    def hasAVX512CD(cls) -> bool: ...
    @classmethod
    def hasAVX512DQ(cls) -> bool: ...
    @classmethod
    def hasAVX512ER(cls) -> bool: ...
    @classmethod
    def hasAVX512F(cls) -> bool: ...
    @classmethod
    def hasAVX512IFMA(cls) -> bool: ...
    @classmethod
    def hasAVX512PF(cls) -> bool: ...
    @classmethod
    def hasAVX512VBMI(cls) -> bool: ...
    @classmethod
    def hasAVX512VL(cls) -> bool: ...
    @classmethod
    def hasAVX512VPOPCNTDQ(cls) -> bool: ...
    @classmethod
    def hasFMA3(cls) -> bool: ...
    @classmethod
    def hasFMA4(cls) -> bool: ...
    @classmethod
    def hasMMX(cls) -> bool: ...
    @classmethod
    def hasNeon(cls) -> bool: ...
    @classmethod
    def hasSSE(cls) -> bool: ...
    @classmethod
    def hasSSE2(cls) -> bool: ...
    @classmethod
    def hasSSE3(cls) -> bool: ...
    @classmethod
    def hasSSE41(cls) -> bool: ...
    @classmethod
    def hasSSE42(cls) -> bool: ...
    @classmethod
    def hasSSSE3(cls) -> bool: ...
    @classmethod
    def isOperatingSystem64Bit(cls) -> bool: ...

class TableHeaderComponent(Component):
    class ColumnPropertyFlags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        appearsOnColumnMenu: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        defaultFlags: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        draggable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        notResizable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        notResizableOrSortable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        notSortable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        resizable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        sortable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        sortedBackwards: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        sortedForwards: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        visible: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
        def __init__(self, value: int) -> None: ...
        def __and__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> int: ...
        @overload
        def __eq__(self, other: object) -> bool: ...
        @overload
        def __eq__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> bool: ...
        @overload
        def __eq__(self, arg0: int) -> bool: ...
        @overload
        def __ge__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> bool: ...
        @overload
        def __ge__(self, arg0: int) -> bool: ...
        @overload
        def __gt__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> bool: ...
        @overload
        def __gt__(self, arg0: int) -> bool: ...
        @overload
        def __hash__(self) -> int: ...
        @overload
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        @overload
        def __int__(self) -> int: ...
        def __invert__(self) -> int: ...
        @overload
        def __le__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> bool: ...
        @overload
        def __le__(self, arg0: int) -> bool: ...
        @overload
        def __lt__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> bool: ...
        @overload
        def __lt__(self, arg0: int) -> bool: ...
        @overload
        def __ne__(self, other: object) -> bool: ...
        @overload
        def __ne__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> bool: ...
        @overload
        def __ne__(self, arg0: int) -> bool: ...
        def __or__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> int: ...
        def __xor__(self, arg0: TableHeaderComponent.ColumnPropertyFlags) -> int: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Listener:
        def __init__(self) -> None: ...
    appearsOnColumnMenu: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    backgroundColourId: ClassVar[int] = ...
    defaultFlags: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    draggable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    highlightColourId: ClassVar[int] = ...
    notResizable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    notResizableOrSortable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    notSortable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    outlineColourId: ClassVar[int] = ...
    resizable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    sortable: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    sortedBackwards: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    sortedForwards: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    textColourId: ClassVar[int] = ...
    visible: ClassVar[TableHeaderComponent.ColumnPropertyFlags] = ...
    def __init__(self) -> None: ...
    @overload
    def addColumn(self, columnName: str, columnId: int, width: int, minimumWidth: int = ..., maximumWidth: int = ..., propertyFlags: int = ..., insertIndex: int = ...) -> None: ...
    @overload
    def addColumn(self, columnName: str, columnId: int, width: int, minimumWidth: int = ..., maximumWidth: int = ..., propertyFlags: TableHeaderComponent.ColumnPropertyFlags = ..., insertIndex: int = ...) -> None: ...
    def addListener(self, arg0: TableHeaderComponent.Listener) -> None: ...
    def columnClicked(self, arg0: int, arg1: ModifierKeys) -> None: ...
    def getColumnIdAtX(self, arg0: int) -> int: ...
    def getColumnIdOfIndex(self, arg0: int, arg1: bool) -> int: ...
    def getColumnName(self, arg0: int) -> str: ...
    def getColumnPosition(self, arg0: int) -> RectangleInt: ...
    def getColumnWidth(self, arg0: int) -> int: ...
    def getIndexOfColumnId(self, arg0: int, arg1: bool) -> int: ...
    def getNumColumns(self, arg0: bool) -> int: ...
    def getSortColumnId(self) -> int: ...
    def getTotalWidth(self) -> int: ...
    def isColumnVisible(self, arg0: int) -> bool: ...
    def isPopupMenuActive(self) -> bool: ...
    def isSortedForwards(self) -> bool: ...
    def isStretchToFitActive(self) -> bool: ...
    def moveColumn(self, arg0: int, arg1: int) -> None: ...
    def reSortTable(self) -> None: ...
    def reactToMenuItem(self, arg0: int, arg1: int) -> None: ...
    def removeAllColumns(self) -> None: ...
    def removeColumn(self, arg0: int) -> None: ...
    def removeListener(self, arg0: TableHeaderComponent.Listener) -> None: ...
    def resizeAllColumnsToFit(self, arg0: int) -> None: ...
    def restoreFromString(self, arg0: str) -> None: ...
    def setColumnName(self, arg0: int, arg1: str) -> None: ...
    def setColumnVisible(self, arg0: int, arg1: bool) -> None: ...
    def setColumnWidth(self, arg0: int, arg1: int) -> None: ...
    def setPopupMenuActive(self, arg0: bool) -> None: ...
    def setSortColumnId(self, arg0: int, arg1: bool) -> None: ...
    def setStretchToFitActive(self, arg0: bool) -> None: ...
    def showColumnChooserMenu(self, arg0: int) -> None: ...
    def toString(self) -> str: ...

class TableListBox(ListBox):
    def __init__(self, componentName: str = ..., model: TableListBoxModel = ...) -> None: ...
    def autoSizeAllColumns(self) -> None: ...
    def autoSizeColumn(self, arg0: int) -> None: ...
    def getCellComponent(self, arg0: int, arg1: int) -> Component: ...
    def getCellPosition(self, arg0: int, arg1: int, arg2: bool) -> RectangleInt: ...
    def getHeader(self) -> TableHeaderComponent: ...
    def getHeaderHeight(self) -> int: ...
    def getTableListBoxModel(self) -> TableListBoxModel: ...
    def isAutoSizeMenuOptionShown(self) -> bool: ...
    def scrollToEnsureColumnIsOnscreen(self, arg0: int) -> None: ...
    def setAutoSizeMenuOptionShown(self, arg0: bool) -> None: ...
    def setHeader(self, arg0: object) -> None: ...
    def setHeaderHeight(self, arg0: int) -> None: ...
    def setModel(self, arg0: TableListBoxModel) -> None: ...

class TableListBoxModel:
    def __init__(self) -> None: ...

class TestApplication:
    def __init__(self, arg0: handle) -> None: ...
    def processEvents(self, milliseconds: int = ...) -> None: ...
    def __enter__(self) -> TestApplication: ...
    def __exit__(self, arg0: Optional[type], arg1: Optional[object], arg2: Optional[object]) -> None: ...
    def __next__(self) -> TestApplication: ...

class TextButton(Button):
    buttonColourId: ClassVar[int] = ...
    buttonOnColourId: ClassVar[int] = ...
    textColourOffId: ClassVar[int] = ...
    textColourOnId: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: str) -> None: ...
    @overload
    def changeWidthToFitText(self) -> None: ...
    @overload
    def changeWidthToFitText(self, arg0: int) -> None: ...
    def getBestWidthForHeight(self, arg0: int) -> int: ...

class TextEditor(TextInputTarget, Component):
    class InputFilter:
        def __init__(self) -> None: ...
        def filterNewText(self, arg0: TextEditor, arg1: str) -> str: ...

    class LengthAndCharacterRestriction(TextEditor.InputFilter):
        def __init__(self, arg0: int, arg1: str) -> None: ...

    class Listener:
        def __init__(self) -> None: ...
        def textEditorEscapeKeyPressed(self, arg0: TextEditor) -> None: ...
        def textEditorFocusLost(self, arg0: TextEditor) -> None: ...
        def textEditorReturnKeyPressed(self, arg0: TextEditor) -> None: ...
        def textEditorTextChanged(self, arg0: TextEditor) -> None: ...
    onEscapeKey: Callable[[], None]
    onFocusLost: Callable[[], None]
    onReturnKey: Callable[[], None]
    onTextChange: Callable[[], None]
    def __init__(self, componentName: str = ..., passwordCharacter: int = ...) -> None: ...
    def addListener(self, arg0: TextEditor.Listener) -> None: ...
    def applyColourToAllText(self, newColour: Colour, changeCurrentTextColour: bool = ...) -> None: ...
    def applyFontToAllText(self, newFont: Font, changeCurrentFont: bool = ...) -> None: ...
    def areScrollbarsShown(self) -> bool: ...
    def clear(self) -> None: ...
    def copy(self) -> None: ...
    def copyToClipboard(self) -> bool: ...
    def cut(self) -> None: ...
    def cutToClipboard(self) -> bool: ...
    def deleteBackwards(self, arg0: bool) -> bool: ...
    def deleteForwards(self, arg0: bool) -> bool: ...
    def getBorder(self) -> BorderSizeInt: ...
    def getCaretPosition(self) -> int: ...
    def getCaretRectangleForCharIndex(self, arg0: int) -> RectangleInt: ...
    def getCharIndexForPoint(self, arg0: PointInt) -> int: ...
    def getClicksOutsideDismissVirtualKeyboard(self) -> bool: ...
    def getFont(self) -> Font: ...
    def getHighlightedRegion(self) -> RangeInt: ...
    def getHighlightedText(self) -> str: ...
    def getInputFilter(self) -> TextEditor.InputFilter: ...
    def getJustificationType(self) -> Justification: ...
    def getLeftIndent(self) -> int: ...
    def getLineSpacing(self) -> float: ...
    def getReturnKeyStartsNewLine(self) -> bool: ...
    def getText(self) -> str: ...
    def getTextBounds(self, arg0: RangeInt) -> RectangleListInt: ...
    def getTextHeight(self) -> int: ...
    def getTextInRange(self, arg0: RangeInt) -> str: ...
    def getTextToShowWhenEmpty(self) -> str: ...
    def getTextValue(self) -> Value: ...
    def getTextWidth(self) -> int: ...
    def getTopIndent(self) -> int: ...
    def getTotalNumChars(self) -> int: ...
    def insertTextAtCaret(self, arg0: str) -> None: ...
    def isCaretVisible(self) -> bool: ...
    def isEmpty(self) -> bool: ...
    def isMultiLine(self) -> bool: ...
    def isPopupMenuCurrentlyActive(self) -> bool: ...
    def isPopupMenuEnabled(self) -> bool: ...
    def isReadOnly(self) -> bool: ...
    def isTabKeyUsedAsCharacter(self) -> bool: ...
    def isWhitespaceUnderlined(self) -> bool: ...
    def moveCaretDown(self, arg0: bool) -> bool: ...
    def moveCaretLeft(self, arg0: bool, arg1: bool) -> bool: ...
    def moveCaretRight(self, arg0: bool, arg1: bool) -> bool: ...
    @overload
    def moveCaretToEnd(self) -> None: ...
    @overload
    def moveCaretToEnd(self, arg0: bool) -> bool: ...
    def moveCaretToEndOfLine(self, arg0: bool) -> bool: ...
    def moveCaretToStartOfLine(self, arg0: bool) -> bool: ...
    def moveCaretToTop(self, arg0: bool) -> bool: ...
    def moveCaretUp(self, arg0: bool) -> bool: ...
    def pageDown(self, arg0: bool) -> bool: ...
    def pageUp(self, arg0: bool) -> bool: ...
    def paste(self) -> None: ...
    def pasteFromClipboard(self) -> bool: ...
    def redo(self) -> bool: ...
    def removeListener(self, arg0: TextEditor.Listener) -> None: ...
    def scrollDown(self) -> bool: ...
    def scrollEditorToPositionCaret(self, arg0: int, arg1: int) -> None: ...
    def scrollUp(self) -> bool: ...
    def selectAll(self) -> bool: ...
    def setBorder(self, arg0: BorderSizeInt) -> None: ...
    def setCaretPosition(self, arg0: int) -> None: ...
    def setCaretVisible(self, arg0: bool) -> None: ...
    def setClicksOutsideDismissVirtualKeyboard(self, arg0: bool) -> None: ...
    def setEscapeAndReturnKeysConsumed(self, arg0: bool) -> None: ...
    def setFont(self, arg0: Font) -> None: ...
    def setHighlightedRegion(self, arg0: RangeInt) -> None: ...
    def setIndents(self, arg0: int, arg1: int) -> None: ...
    def setInputFilter(self, arg0: TextEditor.InputFilter, arg1: bool) -> None: ...
    def setInputRestrictions(self, maxTextLength: int, allowedCharacters: str = ...) -> None: ...
    def setJustification(self, arg0: Justification) -> None: ...
    def setLineSpacing(self, arg0: float) -> None: ...
    def setMultiLine(self, shouldBeMultiLine: bool, shouldWordWrap: bool = ...) -> None: ...
    def setPopupMenuEnabled(self, arg0: bool) -> None: ...
    def setReadOnly(self, arg0: bool) -> None: ...
    def setReturnKeyStartsNewLine(self, arg0: bool) -> None: ...
    def setScrollBarThickness(self, arg0: int) -> None: ...
    def setScrollToShowCursor(self, arg0: bool) -> None: ...
    def setScrollbarsShown(self, arg0: bool) -> None: ...
    def setSelectAllWhenFocused(self, arg0: bool) -> None: ...
    def setTabKeyUsedAsCharacter(self, arg0: bool) -> None: ...
    def setText(self, newText: str, sendTextChangeMessage: bool = ...) -> None: ...
    def setTextToShowWhenEmpty(self, arg0: str, arg1: Colour) -> None: ...
    def setWhitespaceUnderlined(self, arg0: bool) -> None: ...
    def undo(self) -> bool: ...

class TextInputTarget:
    def __init__(self) -> None: ...

class Thread:
    class Listener:
        def __init__(self) -> None: ...
        def exitSignalSent(self) -> None: ...

    class Priority:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        background: ClassVar[Thread.Priority] = ...
        high: ClassVar[Thread.Priority] = ...
        highest: ClassVar[Thread.Priority] = ...
        low: ClassVar[Thread.Priority] = ...
        normal: ClassVar[Thread.Priority] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class RealtimeOptions:
        def __init__(self) -> None: ...
        def getMaximumProcessingTimeMs(self) -> Optional[float]: ...
        def getPeriodMs(self) -> Optional[float]: ...
        def getPriority(self) -> Thread.Priority: ...
        def getProcessingTimeMs(self) -> Optional[float]: ...
        def withApproximateAudioProcessingTime(self, arg0: int, arg1: float) -> Thread.RealtimeOptions: ...
        def withMaximumProcessingTimeMs(self, arg0: float) -> Thread.RealtimeOptions: ...
        def withPeriodHz(self, arg0: float) -> Thread.RealtimeOptions: ...
        def withPeriodMs(self, arg0: float) -> Thread.RealtimeOptions: ...
        def withPriority(self, arg0: Thread.Priority) -> Thread.RealtimeOptions: ...
        def withProcessingTimeMs(self, arg0: float) -> Thread.RealtimeOptions: ...

    class ThreadID:
        @overload
        def __init__(self, arg0: capsule) -> None: ...
        @overload
        def __init__(self, arg0: Thread.ThreadID) -> None: ...
        def __eq__(self, arg0: Thread.ThreadID) -> bool: ...
        def __ne__(self, arg0: Thread.ThreadID) -> bool: ...
    def __init__(self, threadName: str, threadStackSize: int = ...) -> None: ...
    def addListener(self, arg0: Thread.Listener) -> None: ...
    @classmethod
    def currentThreadShouldExit(cls) -> bool: ...
    @classmethod
    def getCurrentThread(cls) -> Thread: ...
    @classmethod
    def getCurrentThreadId(cls, *args, **kwargs): ...
    def getThreadId(self, *args, **kwargs): ...
    def getThreadName(self) -> str: ...
    def isRealtime(self) -> bool: ...
    def isThreadRunning(self) -> bool: ...
    def notify(self) -> None: ...
    def removeListener(self, arg0: Thread.Listener) -> None: ...
    def run(self) -> None: ...
    def setAffinityMask(self, arg0: int) -> None: ...
    @classmethod
    def setCurrentThreadAffinityMask(cls, arg0: int) -> None: ...
    @classmethod
    def setCurrentThreadName(cls, arg0: str) -> None: ...
    def signalThreadShouldExit(self) -> None: ...
    @classmethod
    def sleep(cls, arg0: int) -> None: ...
    def startRealtimeThread(self, arg0: Thread.RealtimeOptions) -> bool: ...
    @overload
    def startThread(self) -> bool: ...
    @overload
    def startThread(self, arg0: Thread.Priority) -> bool: ...
    def stopThread(self, arg0: int) -> bool: ...
    def threadShouldExit(self) -> bool: ...
    def wait(self, arg0: float) -> bool: ...
    def waitForThreadToExit(self, arg0: int) -> bool: ...

class ThreadPool:
    class JobSelector:
        def __init__(self) -> None: ...
        def isJobSuitable(self, arg0: ThreadPoolJob) -> bool: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, options: ThreadPoolOptions) -> None: ...
    @overload
    def __init__(self, numberOfThreads: int, threadStackSizeBytes: int = ..., desiredThreadPriority: Thread.Priority = ...) -> None: ...
    @overload
    def addJob(self, arg0: ThreadPoolJob) -> None: ...
    @overload
    def addJob(self, arg0: Callable[[], ThreadPoolJob.JobStatus]) -> None: ...
    @overload
    def addJob(self, arg0: Callable[[], None]) -> None: ...
    def contains(self, arg0: ThreadPoolJob) -> bool: ...
    def getJob(self, arg0: int) -> ThreadPoolJob: ...
    def getNamesOfAllJobs(self, arg0: bool) -> StringArray: ...
    def getNumJobs(self) -> int: ...
    def getNumThreads(self) -> int: ...
    def isJobRunning(self, arg0: ThreadPoolJob) -> bool: ...
    def moveJobToFront(self, arg0: ThreadPoolJob) -> None: ...
    def removeAllJobs(self, interruptRunningJobs: bool, timeOutMilliseconds: int, selectedJobsToRemove: ThreadPool.JobSelector = ...) -> None: ...
    def removeJob(self, arg0: ThreadPoolJob, arg1: bool, arg2: int) -> bool: ...
    def waitForJobToFinish(self, arg0: ThreadPoolJob, arg1: int) -> bool: ...

class ThreadPoolJob:
    class JobStatus:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        jobHasFinished: ClassVar[ThreadPoolJob.JobStatus] = ...
        jobNeedsRunningAgain: ClassVar[ThreadPoolJob.JobStatus] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    jobHasFinished: ClassVar[ThreadPoolJob.JobStatus] = ...
    jobNeedsRunningAgain: ClassVar[ThreadPoolJob.JobStatus] = ...
    def __init__(self, arg0: str) -> None: ...
    def addListener(self, arg0: Thread.Listener) -> None: ...
    @classmethod
    def getCurrentThreadPoolJob(cls) -> ThreadPoolJob: ...
    def getJobName(self) -> str: ...
    def isRunning(self) -> bool: ...
    def removeListener(self, arg0: Thread.Listener) -> None: ...
    def runJob(self) -> ThreadPoolJob.JobStatus: ...
    def setJobName(self, arg0: str) -> None: ...
    def shouldExit(self) -> bool: ...
    def signalJobShouldExit(self) -> None: ...

class ThreadPoolOptions:
    desiredThreadPriority: Thread.Priority
    numberOfThreads: int
    threadName: str
    threadStackSizeBytes: int
    def __init__(self) -> None: ...
    def withDesiredThreadPriority(self, arg0: Thread.Priority) -> ThreadPoolOptions: ...
    def withNumberOfThreads(self, arg0: int) -> ThreadPoolOptions: ...
    def withThreadName(self, arg0: str) -> ThreadPoolOptions: ...
    def withThreadStackSizeBytes(self, arg0: int) -> ThreadPoolOptions: ...

class Time:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: Time) -> None: ...
    @overload
    def __init__(self, year: int, month: int, day: int, hours: int, minutes: int, seconds: int = ..., milliseconds: int = ..., useLocalTime: bool = ...) -> None: ...
    @classmethod
    def currentTimeMillis(cls) -> int: ...
    def formatted(self, arg0: str) -> str: ...
    @classmethod
    def fromISO8601(cls, arg0: str) -> Time: ...
    @classmethod
    def getApproximateMillisecondCounter(cls) -> int: ...
    @classmethod
    def getCompilationDate(cls) -> Time: ...
    @classmethod
    def getCurrentTime(cls) -> Time: ...
    def getDayOfMonth(self) -> int: ...
    def getDayOfWeek(self) -> int: ...
    def getDayOfYear(self) -> int: ...
    @classmethod
    def getHighResolutionTicks(cls) -> int: ...
    @classmethod
    def getHighResolutionTicksPerSecond(cls) -> int: ...
    def getHours(self) -> int: ...
    def getHoursInAmPmFormat(self) -> int: ...
    @classmethod
    def getMillisecondCounter(cls) -> int: ...
    @classmethod
    def getMillisecondCounterHiRes(cls) -> float: ...
    def getMilliseconds(self) -> int: ...
    def getMinutes(self) -> int: ...
    def getMonth(self) -> int: ...
    def getMonthName(self, arg0: bool) -> str: ...
    def getSeconds(self) -> int: ...
    def getTimeZone(self) -> str: ...
    def getUTCOffsetSeconds(self) -> int: ...
    def getUTCOffsetString(self, arg0: bool) -> str: ...
    def getWeekdayName(self, arg0: bool) -> str: ...
    def getYear(self) -> int: ...
    @classmethod
    def highResolutionTicksToSeconds(cls, arg0: int) -> float: ...
    def isAfternoon(self) -> bool: ...
    def isDaylightSavingTime(self) -> bool: ...
    @classmethod
    def secondsToHighResolutionTicks(cls, arg0: float) -> int: ...
    def setSystemTimeToThisTime(self) -> bool: ...
    def toISO8601(self, includeDividerCharacters: bool) -> str: ...
    def toMilliseconds(self) -> int: ...
    def toString(self, includeDate: bool, includeTime: bool, includeSeconds: bool = ..., use24HourClock: bool = ...) -> str: ...
    @classmethod
    def waitForMillisecondCounter(cls, arg0: int) -> None: ...
    def __add__(self, arg0: RelativeTime) -> Time: ...
    def __eq__(self, arg0: Time) -> bool: ...
    def __ge__(self, arg0: Time) -> bool: ...
    def __gt__(self, arg0: Time) -> bool: ...
    def __iadd__(self, arg0: RelativeTime) -> Time: ...
    def __isub__(self, arg0: RelativeTime) -> Time: ...
    def __le__(self, arg0: Time) -> bool: ...
    def __lt__(self, arg0: Time) -> bool: ...
    def __ne__(self, arg0: Time) -> bool: ...
    def __sub__(self, arg0: RelativeTime) -> Time: ...

class TimeSliceClient:
    def __init__(self) -> None: ...
    def useTimeSlice(self) -> int: ...

class TimeSliceThread:
    def __init__(self, threadName: str) -> None: ...
    def addTimeSliceClient(self, arg0: TimeSliceClient, arg1: int) -> None: ...
    def contains(self, arg0: TimeSliceClient) -> bool: ...
    def getClient(self, arg0: int) -> TimeSliceClient: ...
    def getNumClients(self) -> int: ...
    def moveToFrontOfQueue(self, arg0: TimeSliceClient) -> None: ...
    def removeAllClients(self) -> None: ...
    def removeTimeSliceClient(self, arg0: TimeSliceClient) -> None: ...

class Timer:
    def __init__(self) -> None: ...
    @classmethod
    def callAfterDelay(cls, arg0: int, arg1: Callable[[], None]) -> None: ...
    @classmethod
    def callPendingTimersSynchronously(cls) -> None: ...
    def getTimerInterval(self) -> int: ...
    def isTimerRunning(self) -> bool: ...
    def startTimer(self, arg0: int) -> None: ...
    def startTimerHz(self, arg0: int) -> None: ...
    def stopTimer(self) -> None: ...
    def timerCallback(self) -> None: ...

class ToggleButton(Button):
    textColourId: ClassVar[int] = ...
    tickColourId: ClassVar[int] = ...
    tickDisabledColourId: ClassVar[int] = ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    def changeWidthToFitText(self) -> None: ...

class ToneGeneratorAudioSource(AudioSource):
    def __init__(self) -> None: ...
    def setAmplitude(self, arg0: float) -> None: ...
    def setFrequency(self, arg0: float) -> None: ...

class Toolbar(Component):
    class CustomisationFlags:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        allCustomisationOptionsEnabled: ClassVar[Toolbar.CustomisationFlags] = ...
        allowIconsOnlyChoice: ClassVar[Toolbar.CustomisationFlags] = ...
        allowIconsWithTextChoice: ClassVar[Toolbar.CustomisationFlags] = ...
        allowTextOnlyChoice: ClassVar[Toolbar.CustomisationFlags] = ...
        showResetToDefaultsButton: ClassVar[Toolbar.CustomisationFlags] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class ToolbarItemStyle:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        iconsOnly: ClassVar[Toolbar.ToolbarItemStyle] = ...
        iconsWithText: ClassVar[Toolbar.ToolbarItemStyle] = ...
        textOnly: ClassVar[Toolbar.ToolbarItemStyle] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    allCustomisationOptionsEnabled: ClassVar[Toolbar.CustomisationFlags] = ...
    allowIconsOnlyChoice: ClassVar[Toolbar.CustomisationFlags] = ...
    allowIconsWithTextChoice: ClassVar[Toolbar.CustomisationFlags] = ...
    allowTextOnlyChoice: ClassVar[Toolbar.CustomisationFlags] = ...
    backgroundColourId: ClassVar[int] = ...
    buttonMouseDownBackgroundColourId: ClassVar[int] = ...
    buttonMouseOverBackgroundColourId: ClassVar[int] = ...
    editingModeOutlineColourId: ClassVar[int] = ...
    iconsOnly: ClassVar[Toolbar.ToolbarItemStyle] = ...
    iconsWithText: ClassVar[Toolbar.ToolbarItemStyle] = ...
    labelTextColourId: ClassVar[int] = ...
    separatorColourId: ClassVar[int] = ...
    showResetToDefaultsButton: ClassVar[Toolbar.CustomisationFlags] = ...
    textOnly: ClassVar[Toolbar.ToolbarItemStyle] = ...
    def __init__(self) -> None: ...
    def addDefaultItems(self, arg0: ToolbarItemFactory) -> None: ...
    def addItem(self, arg0: ToolbarItemFactory, arg1: int, arg2: int) -> None: ...
    def clear(self) -> None: ...
    def getItemComponent(self, *args, **kwargs): ...
    def getItemId(self, arg0: int) -> int: ...
    def getLength(self) -> int: ...
    def getNumItems(self) -> int: ...
    def getStyle(self) -> Toolbar.ToolbarItemStyle: ...
    def getThickness(self) -> int: ...
    def isVertical(self) -> bool: ...
    def removeAndReturnItem(self, *args, **kwargs): ...
    def removeToolbarItem(self, arg0: int) -> None: ...
    def restoreFromString(self, arg0: ToolbarItemFactory, arg1: str) -> bool: ...
    def setEditingActive(self, arg0: bool) -> None: ...
    def setStyle(self, arg0: Toolbar.ToolbarItemStyle) -> None: ...
    def setVertical(self, arg0: bool) -> None: ...
    def showCustomisationDialog(self, arg0: ToolbarItemFactory, arg1: int) -> None: ...
    def toString(self) -> str: ...

class ToolbarItemComponent(Button):
    class ToolbarEditingMode:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        editableOnPalette: ClassVar[ToolbarItemComponent.ToolbarEditingMode] = ...
        editableOnToolbar: ClassVar[ToolbarItemComponent.ToolbarEditingMode] = ...
        normalMode: ClassVar[ToolbarItemComponent.ToolbarEditingMode] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    editableOnPalette: ClassVar[ToolbarItemComponent.ToolbarEditingMode] = ...
    editableOnToolbar: ClassVar[ToolbarItemComponent.ToolbarEditingMode] = ...
    normalMode: ClassVar[ToolbarItemComponent.ToolbarEditingMode] = ...
    def __init__(self, arg0: int, arg1: str, arg2: bool) -> None: ...
    def contentAreaChanged(self, arg0: RectangleInt) -> None: ...
    def getContentArea(self) -> RectangleInt: ...
    def getEditingMode(self) -> ToolbarItemComponent.ToolbarEditingMode: ...
    def getItemId(self) -> int: ...
    def getStyle(self) -> Toolbar.ToolbarItemStyle: ...
    def getToolbar(self) -> Toolbar: ...
    def getToolbarItemSizes(self, arg0: int, arg1: bool, arg2: int, arg3: int, arg4: int) -> bool: ...
    def isToolbarVertical(self) -> bool: ...
    def paintButtonArea(self, arg0: Graphics, arg1: int, arg2: int, arg3: bool, arg4: bool) -> None: ...
    def setEditingMode(self, arg0: ToolbarItemComponent.ToolbarEditingMode) -> None: ...
    def setStyle(self, arg0: Toolbar.ToolbarItemStyle) -> None: ...

class ToolbarItemFactory:
    class SpecialItemIds:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        flexibleSpacerId: ClassVar[ToolbarItemFactory.SpecialItemIds] = ...
        separatorBarId: ClassVar[ToolbarItemFactory.SpecialItemIds] = ...
        spacerId: ClassVar[ToolbarItemFactory.SpecialItemIds] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    flexibleSpacerId: ClassVar[ToolbarItemFactory.SpecialItemIds] = ...
    separatorBarId: ClassVar[ToolbarItemFactory.SpecialItemIds] = ...
    spacerId: ClassVar[ToolbarItemFactory.SpecialItemIds] = ...
    def __init__(self) -> None: ...
    def createItem(self, *args, **kwargs): ...
    def getAllToolbarItemIds(self, arg0: ArrayInt) -> None: ...
    def getDefaultItemSet(self, arg0: ArrayInt) -> None: ...

class TopLevelWindow(Component):
    def __init__(self, arg0: str, arg1: bool) -> None: ...
    def addToDesktop(self) -> None: ...
    def centreAroundComponent(self, arg0: Component, arg1: int, arg2: int) -> None: ...
    @classmethod
    def getActiveTopLevelWindow(cls) -> TopLevelWindow: ...
    @classmethod
    def getNumTopLevelWindows(cls) -> int: ...
    @classmethod
    def getTopLevelWindow(cls, arg0: int) -> TopLevelWindow: ...
    def isActiveWindow(self) -> bool: ...
    def isDropShadowEnabled(self) -> bool: ...
    def isUsingNativeTitleBar(self) -> bool: ...
    def setDropShadowEnabled(self, arg0: bool) -> None: ...
    def setUsingNativeTitleBar(self, arg0: bool) -> None: ...

class URL:
    class DownloadTask:
        def __init__(self, *args, **kwargs) -> None: ...
        def getLengthDownloaded(self) -> int: ...
        def getTargetLocation(self) -> File: ...
        def getTotalLength(self) -> int: ...
        def hadError(self) -> bool: ...
        def isFinished(self) -> bool: ...
        def statusCode(self) -> int: ...
        @property
        def Listener(self): ...

    class DownloadTaskListener:
        def __init__(self) -> None: ...
        def finished(self, arg0: URL.DownloadTask, arg1: bool) -> None: ...
        def progress(self, arg0: URL.DownloadTask, arg1: int, arg2: int) -> None: ...

    class DownloadTaskOptions:
        extraHeaders: str
        listener: URL.DownloadTaskListener
        sharedContainer: str
        usePost: bool
        def __init__(self) -> None: ...
        def withExtraHeaders(self, arg0: str) -> URL.DownloadTaskOptions: ...
        def withListener(self, arg0: URL.DownloadTaskListener) -> URL.DownloadTaskOptions: ...
        def withSharedContainer(self, arg0: str) -> URL.DownloadTaskOptions: ...
        def withUsePost(self, arg0: bool) -> URL.DownloadTaskOptions: ...

    class InputStreamOptions:
        def __init__(self, arg0: URL.ParameterHandling) -> None: ...
        def getConnectionTimeoutMs(self) -> int: ...
        def getExtraHeaders(self) -> str: ...
        def getHttpRequestCmd(self) -> str: ...
        def getNumRedirectsToFollow(self) -> int: ...
        def getParameterHandling(self) -> URL.ParameterHandling: ...
        def getProgressCallback(self) -> Callable[[int, int], bool]: ...
        def getResponseHeaders(self, *args, **kwargs): ...
        def getStatusCode(self) -> int: ...
        def withConnectionTimeoutMs(self, arg0: int) -> URL.InputStreamOptions: ...
        def withExtraHeaders(self, arg0: str) -> URL.InputStreamOptions: ...
        def withHttpRequestCmd(self, arg0: str) -> URL.InputStreamOptions: ...
        def withNumRedirectsToFollow(self, arg0: int) -> URL.InputStreamOptions: ...
        def withProgressCallback(self, arg0: Callable[[int, int], bool]) -> URL.InputStreamOptions: ...
        def withResponseHeaders(self, arg0) -> URL.InputStreamOptions: ...
        def withStatusCode(self, arg0: int) -> URL.InputStreamOptions: ...

    class ParameterHandling:
        __members__: ClassVar[dict] = ...  # read-only
        __entries: ClassVar[dict] = ...
        inAddress: ClassVar[URL.ParameterHandling] = ...
        inPostData: ClassVar[URL.ParameterHandling] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: File) -> None: ...
    @classmethod
    def addEscapeChars(cls, arg0: str, arg1: bool, arg2: bool) -> str: ...
    def createInputStream(self, arg0) -> InputStream: ...
    def createOutputStream(self) -> OutputStream: ...
    @classmethod
    def createWithoutParsing(cls, arg0: str) -> URL: ...
    def downloadToFile(self, *args, **kwargs): ...
    def getAnchorString(self) -> str: ...
    def getChildURL(self, arg0: str) -> URL: ...
    def getDomain(self) -> str: ...
    def getFileName(self) -> str: ...
    def getLocalFile(self) -> File: ...
    def getParameterNames(self) -> StringArray: ...
    def getParameterValues(self) -> StringArray: ...
    def getParentURL(self) -> URL: ...
    def getPort(self) -> int: ...
    def getPostData(self) -> str: ...
    def getPostDataAsMemoryBlock(self) -> MemoryBlock: ...
    def getQueryString(self) -> str: ...
    def getScheme(self) -> str: ...
    def getSubPath(self, arg0: bool) -> str: ...
    def isEmpty(self) -> bool: ...
    def isLocalFile(self) -> bool: ...
    @classmethod
    def isProbablyAWebsiteURL(cls, arg0: str) -> bool: ...
    @classmethod
    def isProbablyAnEmailAddress(cls, arg0: str) -> bool: ...
    def isWellFormed(self) -> bool: ...
    def launchInDefaultBrowser(self) -> bool: ...
    def readEntireBinaryStream(self, arg0: MemoryBlock, arg1: bool) -> bool: ...
    def readEntireTextStream(self, arg0: bool) -> str: ...
    def readEntireXmlStream(self, *args, **kwargs): ...
    @classmethod
    def removeEscapeChars(cls, arg0: str) -> str: ...
    def toString(self, includeGetParameters: bool) -> str: ...
    def withAnchor(self, arg0: str) -> URL: ...
    def withDataToUpload(self, arg0: str, arg1: str, arg2: MemoryBlock, arg3: str) -> URL: ...
    def withFileToUpload(self, arg0: str, arg1: File, arg2: str) -> URL: ...
    def withNewDomainAndPath(self, arg0: str) -> URL: ...
    def withNewSubPath(self, arg0: str) -> URL: ...
    @overload
    def withPOSTData(self, arg0: str) -> URL: ...
    @overload
    def withPOSTData(self, arg0: MemoryBlock) -> URL: ...
    def withParameter(self, arg0: str, arg1: str) -> URL: ...
    def withParameters(self, arg0) -> URL: ...
    def __eq__(self, arg0: URL) -> bool: ...
    def __ne__(self, arg0: URL) -> bool: ...

class UndoManager:
    def __init__(self, maxNumberOfUnitsToKeep: int = ..., minimumTransactionsToKeep: int = ...) -> None: ...
    @overload
    def beginNewTransaction(self) -> None: ...
    @overload
    def beginNewTransaction(self, arg0: str) -> None: ...
    def canRedo(self) -> bool: ...
    def canUndo(self) -> bool: ...
    def clearUndoHistory(self) -> None: ...
    def getActionsInCurrentTransaction(self) -> list: ...
    def getCurrentTransactionName(self) -> str: ...
    def getNumActionsInCurrentTransaction(self) -> int: ...
    def getNumberOfUnitsTakenUpByStoredCommands(self) -> int: ...
    def getRedoDescription(self) -> str: ...
    def getRedoDescriptions(self) -> StringArray: ...
    def getTimeOfRedoTransaction(self) -> Time: ...
    def getTimeOfUndoTransaction(self) -> Time: ...
    def getUndoDescription(self) -> str: ...
    def getUndoDescriptions(self) -> StringArray: ...
    def isPerformingUndoRedo(self) -> bool: ...
    @overload
    def perform(self, arg0: object) -> bool: ...
    @overload
    def perform(self, arg0: object, arg1: str) -> bool: ...
    def redo(self) -> bool: ...
    def setCurrentTransactionName(self, arg0: str) -> None: ...
    def setMaxNumberOfStoredUnits(self, arg0: int, arg1: int) -> None: ...
    def undo(self) -> bool: ...
    def undoCurrentTransactionOnly(self) -> bool: ...

class UndoableAction:
    def __init__(self) -> None: ...
    def createCoalescedAction(self, arg0: UndoableAction) -> UndoableAction: ...
    def getSizeInUnits(self) -> int: ...
    def perform(self) -> bool: ...
    def undo(self) -> bool: ...

class Uuid:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Uuid) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: object) -> None: ...
    def getClockSeqAndReserved(self) -> int: ...
    def getClockSeqLow(self) -> int: ...
    def getNode(self) -> int: ...
    def getRawData(self) -> memoryview: ...
    def getTimeHighAndVersion(self) -> int: ...
    def getTimeLow(self) -> int: ...
    def getTimeMid(self) -> int: ...
    def hash(self) -> int: ...
    def isNull(self) -> bool: ...
    @classmethod
    def null(cls) -> Uuid: ...
    def toDashedString(self) -> str: ...
    def toString(self) -> str: ...
    @overload
    def __eq__(self, arg0: Uuid) -> bool: ...
    @overload
    def __eq__(self, arg0: str) -> bool: ...
    def __ge__(self, arg0: Uuid) -> bool: ...
    def __gt__(self, arg0: Uuid) -> bool: ...
    def __le__(self, arg0: Uuid) -> bool: ...
    def __lt__(self, arg0: Uuid) -> bool: ...
    @overload
    def __ne__(self, arg0: Uuid) -> bool: ...
    @overload
    def __ne__(self, arg0: str) -> bool: ...

class Value:
    class Listener:
        def __init__(self) -> None: ...
        def valueChanged(self, arg0: Value) -> None: ...

    class ValueSource:
        def __init__(self) -> None: ...
        def getValue(self) -> var: ...
        def sendChangeMessage(self, arg0: bool) -> None: ...
        def setValue(self, arg0: var) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Value.ValueSource) -> None: ...
    @overload
    def __init__(self, arg0: var) -> None: ...
    @overload
    def __init__(self, arg0: Value) -> None: ...
    def addListener(self, arg0: Value.Listener) -> None: ...
    def asVar(self) -> var: ...
    def getValue(self) -> var: ...
    def getValueSource(self) -> Value.ValueSource: ...
    def referTo(self, arg0: Value) -> None: ...
    def refersToSameSourceAs(self, arg0: Value) -> bool: ...
    def removeListener(self, arg0: Value.Listener) -> None: ...
    def setValue(self, arg0: var) -> None: ...
    def toString(self) -> str: ...
    def __eq__(self, arg0: Value) -> bool: ...
    def __ne__(self, arg0: Value) -> bool: ...

class ValueTree:
    class Comparator:
        def __init__(self) -> None: ...
        def compareElements(self, arg0: ValueTree, arg1: ValueTree) -> int: ...

    class Listener:
        def __init__(self) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Identifier) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: dict) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree) -> None: ...
    def addChild(self, arg0: ValueTree, arg1: int, arg2: UndoManager) -> None: ...
    def addListener(self, arg0: ValueTree.Listener) -> None: ...
    def appendChild(self, arg0: ValueTree, arg1: UndoManager) -> None: ...
    def copyPropertiesAndChildrenFrom(self, arg0: ValueTree, arg1: UndoManager) -> None: ...
    def copyPropertiesFrom(self, arg0: ValueTree, arg1: UndoManager) -> None: ...
    def createCopy(self) -> ValueTree: ...
    def createXml(self) -> XmlElement: ...
    @overload
    @classmethod
    def fromXml(cls, arg0: XmlElement) -> ValueTree: ...
    @overload
    @classmethod
    def fromXml(cls, arg0: str) -> ValueTree: ...
    def getChild(self, arg0: int) -> ValueTree: ...
    def getChildWithName(self, arg0: Identifier) -> ValueTree: ...
    def getChildWithProperty(self, arg0: Identifier, arg1: var) -> ValueTree: ...
    def getNumChildren(self) -> int: ...
    def getNumProperties(self) -> int: ...
    def getOrCreateChildWithName(self, arg0: Identifier, arg1: UndoManager) -> ValueTree: ...
    def getParent(self) -> ValueTree: ...
    @overload
    def getProperty(self, arg0: Identifier) -> var: ...
    @overload
    def getProperty(self, arg0: Identifier, arg1: var) -> var: ...
    def getPropertyAsValue(self, arg0: Identifier, arg1: UndoManager, arg2: bool) -> Value: ...
    def getPropertyName(self, arg0: int) -> Identifier: ...
    def getReferenceCount(self) -> int: ...
    def getRoot(self) -> ValueTree: ...
    def getSibling(self, arg0: int) -> ValueTree: ...
    def getType(self) -> Identifier: ...
    def hasProperty(self, arg0: Identifier) -> bool: ...
    def hasType(self, arg0: Identifier) -> bool: ...
    def indexOf(self, arg0: ValueTree) -> int: ...
    def isAChildOf(self, arg0: ValueTree) -> bool: ...
    def isEquivalentTo(self, arg0: ValueTree) -> bool: ...
    def isValid(self) -> bool: ...
    def moveChild(self, arg0: int, arg1: int, arg2: UndoManager) -> None: ...
    @classmethod
    def readFromData(cls, arg0: buffer) -> ValueTree: ...
    @classmethod
    def readFromGZIPData(cls, arg0: buffer) -> ValueTree: ...
    @classmethod
    def readFromStream(cls, arg0: InputStream) -> ValueTree: ...
    def removeAllChildren(self, arg0: UndoManager) -> None: ...
    def removeAllProperties(self, arg0: UndoManager) -> None: ...
    @overload
    def removeChild(self, arg0: ValueTree, arg1: UndoManager) -> None: ...
    @overload
    def removeChild(self, arg0: int, arg1: UndoManager) -> None: ...
    def removeListener(self, arg0: ValueTree.Listener) -> None: ...
    def removeProperty(self, arg0: Identifier, arg1: UndoManager) -> None: ...
    def sendPropertyChangeMessage(self, arg0: Identifier) -> None: ...
    def setProperty(self, arg0: Identifier, arg1: var, arg2: UndoManager) -> ValueTree: ...
    def setPropertyExcludingListener(self, arg0: ValueTree.Listener, arg1: Identifier, arg2: var, arg3: UndoManager) -> ValueTree: ...
    def sort(self, arg0: ValueTree.Comparator, arg1: UndoManager, arg2: bool) -> None: ...
    def toXmlString(self, arg0: XmlElement.TextFormat) -> str: ...
    def writeToStream(self, arg0: OutputStream) -> None: ...
    def __eq__(self, arg0: ValueTree) -> bool: ...
    def __ne__(self, arg0: ValueTree) -> bool: ...

class ValueTreePropertyWithDefault:
    onDefaultChange: Callable[[], None]
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: var) -> None: ...
    @overload
    def __init__(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: var, arg4: str) -> None: ...
    def get(self) -> var: ...
    def getDefault(self) -> var: ...
    def getPropertyAsValue(self) -> Value: ...
    def getPropertyID(self) -> Identifier: ...
    def getUndoManager(self) -> UndoManager: ...
    def getValueTree(self) -> ValueTree: ...
    def isUsingDefault(self) -> bool: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager) -> None: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: var) -> None: ...
    @overload
    def referTo(self, arg0: ValueTree, arg1: Identifier, arg2: UndoManager, arg3: var, arg4: str) -> None: ...
    def resetToDefault(self) -> None: ...
    def setDefault(self, arg0: var) -> None: ...
    def setValue(self, arg0: var, arg1: UndoManager) -> None: ...

class ValueTreeSynchroniser:
    def __init__(self, arg0: ValueTree) -> None: ...
    @classmethod
    def applyChange(cls, arg0: ValueTree, arg1: buffer, arg2: UndoManager) -> bool: ...
    def getRoot(self) -> ValueTree: ...
    def sendFullSyncCallback(self) -> None: ...
    def stateChanged(self, arg0: buffer) -> None: ...

class WASAPIDeviceMode:
    __members__: ClassVar[dict] = ...  # read-only
    __entries: ClassVar[dict] = ...
    exclusive: ClassVar[WASAPIDeviceMode] = ...
    shared: ClassVar[WASAPIDeviceMode] = ...
    sharedLowLatency: ClassVar[WASAPIDeviceMode] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class WaitableEvent:
    def __init__(self, manualReset: bool = ...) -> None: ...
    def reset(self) -> None: ...
    def signal(self) -> None: ...
    def wait(self, timeOutMilliseconds: float = ...) -> bool: ...

class WavAudioFormat(AudioFormat):
    bwavCodingHistory: ClassVar[str] = ...
    bwavDescription: ClassVar[str] = ...
    bwavOriginationDate: ClassVar[str] = ...
    bwavOriginationTime: ClassVar[str] = ...
    bwavOriginator: ClassVar[str] = ...
    bwavOriginatorRef: ClassVar[str] = ...
    bwavTimeReference: ClassVar[str] = ...
    def __init__(self) -> None: ...
    def createBWAVMetadata(self, *args, **kwargs): ...
    def replaceMetadataInFile(self, arg0: File, arg1) -> bool: ...

class WildcardFileFilter(FileFilter):
    def __init__(self, arg0: str, arg1: str, arg2: str) -> None: ...

class WindowsMediaAudioFormat(AudioFormat):
    def __init__(self) -> None: ...

class XmlDocument:
    @overload
    def __init__(self, file: File) -> None: ...
    @overload
    def __init__(self, textToParse: str) -> None: ...
    def getDocumentElement(self, onlyReadOuterDocumentElement: bool = ...) -> XmlElement: ...
    def getDocumentElementIfTagMatches(self, requiredTag: str) -> XmlElement: ...
    def getLastParseError(self) -> str: ...
    @overload
    @classmethod
    def parse(cls, file: File) -> XmlElement: ...
    @overload
    @classmethod
    def parse(cls, textToParse: str) -> XmlElement: ...
    def setEmptyTextElementsIgnored(self, shouldBeIgnored: bool) -> None: ...

class XmlElement:
    class Comparator:
        def __init__(self) -> None: ...
        def compareElements(self, arg0: XmlElement, arg1: XmlElement) -> int: ...

    class TextFormat:
        addDefaultHeader: bool
        customEncoding: str
        customHeader: str
        dtd: str
        lineWrapLength: int
        newLineChars: str
        def __init__(self) -> None: ...
        def singleLine(self) -> XmlElement.TextFormat: ...
        def withoutHeader(self) -> XmlElement.TextFormat: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: Identifier) -> None: ...
    @overload
    def __init__(self, arg0: XmlElement) -> None: ...
    def addChildElement(self, arg0: XmlElement) -> None: ...
    def addTextElement(self, arg0: str) -> None: ...
    def compareAttribute(self, arg0: str, arg1: str, arg2: bool) -> bool: ...
    def containsChildElement(self, arg0: XmlElement) -> bool: ...
    def createNewChildElement(self, arg0: str) -> XmlElement: ...
    @classmethod
    def createTextElement(cls, arg0: str) -> XmlElement: ...
    def deleteAllChildElements(self) -> None: ...
    def deleteAllChildElementsWithTagName(self, arg0: str) -> None: ...
    def deleteAllTextElements(self) -> None: ...
    def findParentElementOf(self, arg0: XmlElement) -> XmlElement: ...
    def getAllSubText(self) -> str: ...
    def getAttributeName(self, arg0: int) -> str: ...
    def getAttributeValue(self, arg0: int) -> str: ...
    def getBoolAttribute(self, attributeName: str, defaultReturnValue: bool = ...) -> bool: ...
    def getChildByAttribute(self, arg0: str, arg1: str) -> XmlElement: ...
    def getChildByName(self, arg0: str) -> XmlElement: ...
    def getChildElement(self, arg0: int) -> XmlElement: ...
    def getChildElementAllSubText(self, arg0: str, arg1: str) -> str: ...
    def getDoubleAttribute(self, attributeName: str, defaultReturnValue: float = ...) -> float: ...
    def getFirstChildElement(self) -> XmlElement: ...
    def getIntAttribute(self, attributeName: str, defaultReturnValue: int = ...) -> int: ...
    def getNamespace(self) -> str: ...
    def getNextElement(self) -> XmlElement: ...
    def getNextElementWithTagName(self, arg0: str) -> XmlElement: ...
    def getNumAttributes(self) -> int: ...
    def getNumChildElements(self) -> int: ...
    @overload
    def getStringAttribute(self, arg0: str) -> str: ...
    @overload
    def getStringAttribute(self, arg0: str, arg1: str) -> str: ...
    def getTagName(self) -> str: ...
    def getTagNameWithoutNamespace(self) -> str: ...
    def getText(self) -> str: ...
    def hasAttribute(self, arg0: str) -> bool: ...
    def hasTagName(self, arg0: str) -> bool: ...
    def hasTagNameIgnoringNamespace(self, arg0: str) -> bool: ...
    def insertChildElement(self, arg0: XmlElement, arg1: int) -> None: ...
    def isEquivalentTo(self, arg0: XmlElement, arg1: bool) -> bool: ...
    def isTextElement(self) -> bool: ...
    @classmethod
    def isValidXmlName(cls, arg0: str) -> bool: ...
    def prependChildElement(self, arg0: XmlElement) -> None: ...
    def removeAllAttributes(self) -> None: ...
    def removeAttribute(self, arg0: Identifier) -> None: ...
    def removeChildElement(self, arg0: XmlElement, arg1: bool) -> None: ...
    def replaceChildElement(self, arg0: XmlElement, arg1: XmlElement) -> bool: ...
    @overload
    def setAttribute(self, arg0: Identifier, arg1: str) -> None: ...
    @overload
    def setAttribute(self, arg0: Identifier, arg1: int) -> None: ...
    @overload
    def setAttribute(self, arg0: Identifier, arg1: float) -> None: ...
    def setTagName(self, arg0: str) -> None: ...
    def setText(self, arg0: str) -> None: ...
    def sortChildElements(self, arg0: XmlElement.Comparator, arg1: bool) -> None: ...
    def toString(self, format: XmlElement.TextFormat = ...) -> str: ...
    @overload
    def writeTo(self, output: OutputStream, format: XmlElement.TextFormat = ...) -> None: ...
    @overload
    def writeTo(self, output: File, format: XmlElement.TextFormat = ...) -> bool: ...

def START_JUCE_APPLICATION(arg0: handle) -> None: ...
def absoluteTolerance(*args, **kwargs): ...
@overload
def approximatelyEqual(arg0: int, arg1: int) -> bool: ...
@overload
def approximatelyEqual(arg0: int, arg1: int) -> bool: ...
@overload
def approximatelyEqual(arg0: float, arg1: float) -> bool: ...
@overload
def approximatelyEqual(arg0: float, arg1: float) -> bool: ...
@overload
def countNumberOfBits(arg0: int) -> int: ...
@overload
def countNumberOfBits(arg0: int) -> int: ...
@overload
def degreesToRadians(arg0: float) -> float: ...
@overload
def degreesToRadians(arg0: float) -> float: ...
@overload
def exactlyEqual(arg0: float, arg1: float) -> bool: ...
@overload
def exactlyEqual(arg0: float, arg1: float) -> bool: ...
def findHighestSetBit(arg0: int) -> int: ...
@overload
def isPowerOfTwo(arg0: int) -> bool: ...
@overload
def isPowerOfTwo(arg0: int) -> bool: ...
@overload
def juce_hypot(arg0: float, arg1: float) -> float: ...
@overload
def juce_hypot(arg0: float, arg1: float) -> float: ...
@overload
def juce_isfinite(arg0: float) -> bool: ...
@overload
def juce_isfinite(arg0: float) -> bool: ...
@overload
def mapFromLog10(arg0: float, arg1: float, arg2: float) -> float: ...
@overload
def mapFromLog10(arg0: float, arg1: float, arg2: float) -> float: ...
@overload
def mapToLog10(arg0: float, arg1: float, arg2: float) -> float: ...
@overload
def mapToLog10(arg0: float, arg1: float, arg2: float) -> float: ...
@overload
def negativeAwareModulo(arg0: str, arg1: str) -> str: ...
@overload
def negativeAwareModulo(arg0: int, arg1: int) -> int: ...
@overload
def negativeAwareModulo(arg0: int, arg1: int) -> int: ...
@overload
def negativeAwareModulo(arg0: int, arg1: int) -> int: ...
@overload
def negativeAwareModulo(arg0: int, arg1: int) -> int: ...
@overload
def negativeAwareModulo(arg0: int, arg1: int) -> int: ...
@overload
def nextFloatDown(arg0: float) -> float: ...
@overload
def nextFloatDown(arg0: float) -> float: ...
@overload
def nextFloatUp(arg0: float) -> float: ...
@overload
def nextFloatUp(arg0: float) -> float: ...
@overload
def nextPowerOfTwo(arg0: int) -> int: ...
@overload
def nextPowerOfTwo(arg0: int) -> int: ...
@overload
def radiansToDegrees(arg0: float) -> float: ...
@overload
def radiansToDegrees(arg0: float) -> float: ...
def readLittleEndianBitsInBuffer(arg0: buffer, arg1: int, arg2: int) -> int: ...
def relativeTolerance(*args, **kwargs): ...
@overload
def roundToInt(arg0: int) -> int: ...
@overload
def roundToInt(arg0: float) -> int: ...
@overload
def roundToInt(arg0: float) -> int: ...
def roundToIntAccurate(arg0: float) -> int: ...
@overload
def truncatePositiveToUnsignedInt(arg0: float) -> int: ...
@overload
def truncatePositiveToUnsignedInt(arg0: float) -> int: ...
def writeLittleEndianBitsInBuffer(arg0: buffer, arg1: int, arg2: int, arg3: int) -> None: ...
